<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Frame_admin
 *
 * Обработка Ajax-запросов
 */
class Frame_admin extends Theme_admin
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array результаты, передаваемы Ajaxом
	 */
	private $result;

	/**
	 * @var string SQL-условия для списка
	 */
	protected $where;

	/**
	 * @var array настройки отображения
	 */
	public $config_module;

    /**
     * Конструктор класса
     *
     * @param Initadmin $diafan
     * @return \Frame_admin
     */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	public function ajax_module()
	{
		if ($this->diafan->include_class)
		{
			$init = new $this->diafan->include_class( $this );
		}
	}

    /**
     * Обработчик функции быстрого сохранения полей
     *
     * @return void
     */

	public function fast_save()
	{
		if (!$this->diafan->_user->checked)
		{
			$this->result["error"] = 'ERROR';
			$this->send_json();
		}

		$this->result["hash"] = $this->diafan->_user->get_hash();
		$this->result["res"] = FALSE;
		if(in_array($_POST['name'], $this->fast_edit_rows))
		{
			$func = 'fast_save_' . preg_replace('/[^a-z_]+/', '', $_POST['name']);
			if (method_exists($this, $func))
			{
				$this->result["res"] = $this->$func();
			}
			else
			{
				$this->result["res"] = (bool)DB::query('UPDATE {' . $this->table . '} SET %h="' . ( (bool)$_POST['type'] ? '%h' : '%d' ) . '" WHERE id=%d LIMIT 1', $_POST['name'], $_POST['value'], $_POST['id']);
			}
		}


		$this->send_json();
	}

	public function change_theme()
	{
		if (!$this->diafan->_user->checked)
		{
			$this->result["error"] = 'ERROR';
			$this->send_json();
		}

		$this->result["hash"] = $this->diafan->_user->get_hash();

		$_POST['theme']=preg_replace('/\W/','',$_POST['theme']);
		if(file_exists(ABSOLUTE_PATH . 'adm/img/themes/'.$_POST['theme'].'.jpg'))
		{
			$img = $_POST['theme'].'.jpg';
			DB::query("UPDATE {users} SET background='%h' WHERE id=%d",$img,$this->diafan->_user->id);

			$this->result["background"] = BASE_PATH.'adm/img/themes/'.$img;

		}


		$this->send_json();
	}

	/**
	 * Подгружает список для сортировки элементов
	 *
	 * @return void
	 */
	public function sort_module()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (!$this->diafan->_user->checked)
		{
			$this->result["error"] = 'ERROR';
			$this->send_json();
		}

		$this->result["hash"] = $this->diafan->_user->get_hash();

		$text = '<select name="sort">';

		//список элементов, которые при сортировке стоят перед редактируемым элементом
		$text .= $this->select_option("sort", $this->table, "sort", "name", '',
			( !empty( $_POST["parent_id"] ) ? "parent_id='" . $_POST["parent_id"] . "' AND " : '' ) .
			( !empty( $_POST["cat_id"] ) ? 'cat_id="' . $_POST["cat_id"] . '" AND ' : '' ) .
			( !empty( $_POST["site_id"] ) ? 'site_id="' . $_POST["site_id"] . '" AND ' : '' ) .
			"sort<='" . $_POST["sort"] . "'" .
			( $this->is_variable("act") ? " AND act='1'" : '' ) .
			" AND id<>'" . $this->diafan->edit . "'" .
			$this->where . ( $this->config_module["trash"] ? " AND trash='0'" : '' )
			, '', '', '', ( $this->is_variable("act") ? 'act DESC,' : '' ) . 'sort ASC, id ASC')

			. '<option value="' . $this->diafan->edit . '" selected>----' . ( $_POST["name"] ? $_POST["name"] : $this->diafan->edit ) . '---</option>'

			//список элементов, которые при сортировке стоят после редактируемого элемента
			. $this->select_option("sort", $this->table, "sort", "name", '', ( !empty( $_POST["parent_id"] ) ? "parent_id='" . $_POST["parent_id"] . "' AND " : '' ) .
			( !empty( $_POST["cat_id"] ) ? 'cat_id="' . $_POST["cat_id"] . '" AND ' : '' ) .
			( !empty( $_POST["site_id"] ) ? 'site_id="' . $_POST["site_id"] . '" AND ' : '' ) .
			"sort>'" . $_POST["sort"] . "'" .
			( $this->is_variable("act") ? " AND act='1'" : '' ) .
			" AND id<>'" . $this->diafan->edit . "'" .
			$this->where . ( $this->config_module["trash"] ? " AND trash='0'" : '' )
			, '', '', '', ( $this->is_variable("act") ? 'act DESC,' : '' ) .
			'sort ASC, id ASC') . '<option value="down">----' . _ADMIN_ORDERING_DOWN . '---</option></select>';

		$this->result["data"] = $text;
		$this->send_json();
	}

	/**
	 * Подгружает список родителей
	 *
	 * @return void
	 */
	public function parent_id_module()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (!$this->diafan->_user->checked)
		{
			$this->result["error"] = 'ERROR';
			$this->send_json();
		}

		$_POST['parent_id']=(int)preg_replace("/\D/","",$_POST['parent_id']);

		$this->result["hash"] = $this->diafan->_user->get_hash();

		$result = DB::query("SELECT id, [".$this->name."] as `name`, parent_id FROM {" . $this->table . "} WHERE id<>'%d'" . ( $this->diafan->module == 'site' ? " AND id<>1" : '' ) .($this->config_module['trash']? " AND trash='0'":''). " ORDER BY id ASC", $this->diafan->edit);

		while ($row = DB::fetch_array($result))
		{

			$cats[$row["parent_id"]][] = $row;
		}
		$this->result["data"] = '<select name="parent_id" upload="1">
			<option value="">' . ( $this->diafan->module == 'site' ? _LANG_HOME : '' ) . '</option>' . $this->get_options($cats, $cats[0], array ( $_POST["parent_id"] )) . '</select>';
		$this->send_json();
	}

	/**
	 * Отдает ответ Ajax
	 *
	 * @return void
	 */
	private function send_json()
	{
		if ($this->result)
		{
			include_once ABSOLUTE_PATH . 'plugins/json.php';
			echo to_json($this->result);
			exit;
		}
	}

	public function group_cat_id()
	{
		if (!$this->diafan->_user->checked)
		{
			echo "{error: 'HASH'}";
			return FALSE;
		}
		$this->result["hash"] = $this->diafan->_user->get_hash();

		//проверка прав
		if ($this->diafan->admin_roles('edit'))
		{
			$this->result["error"] = 'ROLES';
			$this->send_json();
			return FALSE;
		}

		if (empty( $_POST['ids'] ) || empty($_POST['cat_id']))
		{
			$this->result["error"] = 'EMPTY';
			$this->send_json();
			return FALSE;
		}

		$cat_id = intval($_POST['cat_id']);
		foreach($_POST['ids'] as $id)
		{
			$id = intval($id);
			if ($this->config_module["element_multiple"])
			{
				DB::query("DELETE FROM {%s_category_rel} WHERE element_id=%d", $this->diafan->module, $id);
				DB::query("INSERT INTO {%s_category_rel} (element_id, cat_id) VALUES('%d', '%d')", $this->diafan->module, $id, $cat_id);

			}
			elseif ($this->config_module["parent"] && DB::query_result("SELECT cat_id FROM {%h} WHERE id=%d", $this->table, $id) != $cat_id)
			{
				$children = $this->diafan->get_children($id, $this->table);
				if ($children)
				{
					DB::query("UPDATE {%h} SET cat_id=%d WHERE id IN (%h)", $this->table, $cat_id, implode(",", $children));
				}
			}
		}
		$this->result["status"]=TRUE;
		$this->result["redirect"] = URL;
		$this->send_json();
	}

	/**
	 * Возвращает номер элемента, к которому подключается фотография или тэг
	 *
	 * @return integer
	 */
	private function get_id_element()
	{
		if (!empty( $_POST["id"] ))
		{
			return intval($_POST["id"]);
		}
		else
		{
			$names = array ();
			$values = array ();
			if (!empty( $_POST["parent_id"] ))
			{
				$names[] = "parent_id";
				$values[] = "'" . $_POST["parent_id"] . "'";
			}
			if (!empty( $_POST["cat_id"] ))
			{
				$names[] = "cat_id";
				$values[] = "'" . $_POST["cat_id"] . "'";
			}
			if (!empty( $_POST["site_id"] ))
			{
				$names[] = "site_id";
				$values[] = "'" . $_POST["site_id"] . "'";
			}

			DB::query("INSERT INTO {" . $this->table . "} (" . implode(', ', $names) . ") VALUES (" . implode(', ', $values) . ")");

			return DB::last_id($this->table);
		}
	}
}