<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Frame_admin
 *
 * Сортировка by Gar|k
 */
class Frame_admin
{

	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var string таблица в базе данных
	 */
	public $table;

	/**
	 * @var array настройки отображения
	 */
	public $config_module = array ();

	/**
	 * @var array поля таблицы с типами
	 */
	public $variable_table = array ();

	/**
	 * @var array переводимые поля
	 */
	public $language_names = array ();

	/**
	 * @var string SQL-условия для списка
	 */
	protected $where;

    /**
     * Конструктор класса
     *
     * @param Initadmin $diafan
     * @return \Frame_admin
     */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Сортирует элементы
	 *
	 * @return boolean
	 */
	public function move_module()
	{

		// Прошел ли пользователь проверку идентификационного хэша
		if (!$this->diafan->_user->checked)
		{
			echo "{error: 'HASH'}";
			return FALSE;
		}

		//проверка прав на сортировку
		if ($this->diafan->admin_roles('edit'))
		{
			echo "{error: 'ROLES'}";
			return FALSE;
		}

        //проверка присланы ли данные
		if (empty( $_POST['sort'] ))
		{
			echo "{error: 'SORT'}";
			return FALSE;
		}

		$result["status"] = TRUE;
		$result["hash"] = $this->diafan->_user->get_hash();

		foreach ($_POST['sort'] as $id => $sort)
		{

			if (!DB::query("UPDATE {" . $this->table . "} SET sort=%d WHERE id=%d", $sort, $id))
			{
				$result["status"] = FALSE;
				break;
			}
		}

		//$this->diafan->_cache->delete("", $this->diafan->rewrite);
		$this->diafan->_cache->delete("", $this->diafan->module);

		include_once ABSOLUTE_PATH . 'plugins/json.php';
		echo to_json($result);

		return TRUE;
	}

    /**
     * Обработчик перетаскивания на страницу
     *
     * @return bool
     */

	public function move_page()
	{

		// Прошел ли пользователь проверку идентификационного хэша
		if (!$this->diafan->_user->checked)
		{
			echo "{error: 'HASH'}";
			return FALSE;
		}
                
                $result["hash"] = $this->diafan->_user->get_hash();

		//проверка прав на сортировку
		if ($this->diafan->admin_roles('edit'))
		{
			echo "{error: 'ROLES'}";
			return FALSE;
		}

        //проверяем входящие переменные
		
                $item=DB::fetch_array(DB::query("SELECT id,".( $this->config_module["parent"] ? "parent_id,":'')."sort FROM {".$this->table."} WHERE id=%d LIMIT 1",$_POST['id']));
                
                if(empty($item)) 
                    {
			echo "{error: 'EMPTY'}";
			return FALSE;
                    }
                    
                
                             
		$this->page=(int)preg_replace("/\D/",'',$_POST['page']);
		if (! $this->nastr) $this->nastr = 10;
		if ($this->page)
		{
			$this->polog = ( ($this->page - 1) * $this->nastr )  ;
		}
		else
		{
			$this->page  = 1;
			$this->polog = 0;
		}
              
		$first_item=DB::fetch_array($this->sql_query( ( isset($item['parent_id']) ? $item['parent_id'] : 0 ) , $this->polog ));
                
                $result['status']=DB::query("UPDATE {".$this->table."} SET sort=%d WHERE id=%d LIMIT 1",$item['sort'],$first_item['id']);
		$result['status']=DB::query("UPDATE {".$this->table."} SET sort=%d WHERE id=%d LIMIT 1",$first_item['sort'],$item['id']);

                
		include_once ABSOLUTE_PATH . 'plugins/json.php';
		echo to_json($result);

		return TRUE;
	}
        
        /**
	 * Формирует SQL-запрос для списка элементов
	 *
	 * @param integer $id родитель
	 * @return resource
	 */
	private function sql_query($id,$polog)
	{
		return DB::query("SELECT e.id" .
			( $this->config_module["order"] ? ', e.sort' : '' ) . " FROM {" . $this->table . "} as e" . (
		$this->config_module["element_multiple"] && $this->diafan->cat ?
			" INNER JOIN {" . $this->table . "_category_rel} AS c ON e.id=c.element_id" .
				" AND e.id=c.element_id AND c.cat_id='" . $this->diafan->cat . "'" : '' ) . " WHERE 1=1" .
			( $this->config_module["parent"] ? " AND e.parent_id='" . $id . "'" : '' ) . (
		$this->config_module["element"] && !$this->config_module["element_multiple"] && $this->diafan->cat ?
			" AND e.cat_id='" . $this->diafan->cat . "'" : '' ) . (
		$this->config_module["element_site"] && $this->diafan->site ?
			" AND e.site_id='" . $this->diafan->site . "'" : '' ) .
			( $this->table == 'site' ? " AND e.id<>1 AND e.block='0'" : '' ) .
			( $this->config_module["trash"] ? " AND e.trash='0'" : '' ) .
			( $this->config_module["element_multiple"] && $this->diafan->cat ? " GROUP BY e.id" : '' ) . " ORDER BY " .
			( $this->config_module["prior"] ? 'e.prior DESC, ' : '' ) .
			( $this->config_module["date"] || $this->config_module["datetime"] ? 'e.created DESC, ' : '' ) .
			( $this->config_module["act"] ? 'e.act' . $this->lang_act . ' DESC, ' : '' ) .
			( $this->table == 'site' ? " e.is_menu DESC, e.block ASC, " : '' ) .
			( $this->config_module["order"] ? 'e.sort ASC, e.id ASC' : 'e.id DESC' ) . ' LIMIT ' . $polog. ', 1');
	}

    /**
     * Перемещение вложенности
     *
     * @param $id идентификатор элемента
     * @param $pid идентификатор родителя элемента
     * @return bool
     */

	private function move_parent($id,$pid)
	{
		$res=FALSE;

		$oldrow = DB::fetch_array(DB::query("SELECT id,parent_id FROM {" . $this->table . "} WHERE id=%d LIMIT 1", $id));

		if ($oldrow['parent_id'] != $pid)
		{
			$children = $this->diafan->get_children($id, $this->table);
			$children[] = $id;
			$count_children = count($children);

			// если родитель был, у текущего элемента и его детей удаляем всех старых родителей, вышего текущего элемента
			// у старых родителей выше текущего элемента уменьшаем количество детей

			$old_parents = $this->diafan->get_parents($id, $this->table);
			foreach ($old_parents as $parent_id)
			{
				DB::query("DELETE FROM {" . $this->table . "_parents} WHERE element_id IN (%h) AND parent_id=%d", implode(",", $children), $parent_id);
				DB::query("UPDATE {" . $this->table . "} SET count_children=count_children-%d WHERE id=%d", $count_children, $parent_id);
			}

			$parents = $this->diafan->get_parents($pid, $this->table);
			$parents[] = $pid;
			foreach ($parents as $parent_id)
			{
				DB::query("UPDATE {" . $this->table . "} SET count_children=count_children+%d WHERE id=%d", $count_children, $parent_id);
				foreach ($children as $child)
				{
					DB::query("INSERT INTO {" . $this->table . "_parents} (element_id, parent_id) VALUES (%d, %d)", $child, $parent_id);
				}
			}

			DB::query("UPDATE {" . $this->table . "} SET parent_id=%d WHERE id=%d LIMIT 1", $pid, $id);

			$this->diafan->_cache->delete("", $this->diafan->module);
			$res = TRUE;
		}

		return $res;
	}

    /**
     * Обработчик перемещения вложенности
     *
     * @return bool
     */

	public function move_parent_module()
	{
		if (!$this->diafan->_user->checked)
		{
			echo "{error: 'HASH'}";
			return FALSE;
		}

		//проверка прав на сортировку
		if ($this->diafan->admin_roles('edit'))
		{
			echo "{error: 'ROLES'}";
			return FALSE;
		}

		if (empty( $_POST['id'] ))
		{
			echo "{error: 'EMPTY'}";
			return FALSE;
		}

		$id = intval($_POST['id']);
		$pid = intval($_POST['parent_id']);

		$result["status"] = $this->move_parent($id,$pid);
		$result["hash"] = $this->diafan->_user->get_hash();


		include_once ABSOLUTE_PATH . 'plugins/json.php';
		echo to_json($result);

		return TRUE;
	}

}