<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Banners_model
 *
 * Модель модуля "Баннеры"
 */
class Banners_model extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	protected $result;

	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;
	}


	/**
	 * Генерирует данные для шаблонной функции: блок баннера
	 * 
	 * @param integer $cat_id категория
	 * @return array
	 */
	public function show_block($id, $cat_id)
	{
		if(! DB::query_result("SELECT id FROM {modules} WHERE module_name='banners'"))
		{
			return false;
		}
		$time = time();
		$this->result = array();               

		if (!empty($id))
		{
			$result = DB::query("SELECT e.id, e.type, e.file, e.html, e.link, e.section, e.check_number, e.show_number, e.check_user, e.show_user, e.view, e.width, e.height, e.[alt], e.[title]"
			." FROM {banners} as e" 
			." WHERE e.[act]='1' AND e.trash='0'"
			." AND e.id=%d AND (e.date_start<=%d OR e.date_start=0) AND (e.date_finish>=%d OR e.date_finish=0)", 
			$id, $time, $time);

			$rows = $this->get_elements($result);                   

			if (!empty($rows))
			{
				$this->result = $rows[0];  
			}                    
		}                
		elseif(empty($id) && !empty($cat_id) && $this->diafan->configmodules("cat", "banners"))
		{
			$result = DB::query("SELECT DISTINCT e.id, e.type, e.file, e.html, e.link, e.section, e.check_number, e.show_number, e.check_user, e.show_user, e.view, e.width, e.height, e.[alt], e.[title]"
								." FROM {banners} as e"
								." INNER JOIN {banners_category_rel} as c ON c.element_id=e.id"                                   		                                   
								." WHERE e.[act]='1' AND e.trash='0'"
								." AND c.cat_id=%d"
								." AND (e.date_start<=%d OR e.date_start=0) AND (e.date_finish>=%d OR e.date_finish=0)",
								$cat_id, $time, $time);


			$rows = $this->get_elements($result);

			if (!empty($rows))
			{
				$max_count = count($rows);

				$rand = mt_rand(0, $max_count - 1);                                      

				$this->result = $rows[$rand];  
			} 

		}                
		else
		{
			return FALSE;
		}

		if (!empty($this->result['id']))
		{
			$this->result['view'] = $this->result['view'] + 1;
			DB::query("UPDATE {banners} SET view=%d WHERE id=%d", $this->result['view'], $this->result['id']);
		}

		if (!empty($this->result['check_number']))
		{
			$this->result['show_number'] = $this->result['show_number'] - 1;                
			DB::query("UPDATE {banners} SET show_number=%d, view=%d WHERE id=%d", $this->result['show_number'], $this->result['view'], $this->result['id']);
		}

		return $this->result;
	}
        
	public function get_elements($result)
	{
            $time = time(); 
            $rows = array();
            while ($row = DB::fetch_array($result))
            {

                if ($row['section'] == 2 && $this->diafan->cid != 1)
                {
                    break;
                } 
                if ($row['section'] == 3 && $this->diafan->cid == 1)
                {
                    break;
                }
                if ($row['section'] == 1)
                {
                    $rows_parents = array();
                    $parent_result = DB::query("SELECT site_id FROM {banners_site_rel} WHERE element_id=%d", $row['id']);
                    while($row_parent = DB::fetch_array($parent_result))
                    {
                        $rows_parents[] = $row_parent['site_id'];
                    }
                    if(! in_array($this->diafan->cid, $rows_parents))
                    {
                        break;
                    }
                } 
                
                if ($row['type'] == 0)
                {
                    break;
                }
                
                if ($row['type'] == 1)
                {
                   $row['image'] = $row['file'];
                   unset ($row['html']);
                   unset ($row['file']);
                }
                
                if ($row['type'] == 2)
                {
                   $row['swf'] = $row['file'];
                   unset ($row['html']);
                   unset ($row['file']);
                }
                
                if ($row['type'] == 3)
                {
                   unset ($row['file']); 
                }
                
                if (!empty($row['check_user']))
                {
                    if(!isset($_COOKIE['show_banner_'.$row['id']]) || !isset($_COOKIE['end_show_banner_'.$row['id']]))
                    {
                        setcookie('show_banner_'.$row['id'], 1, $time+86400, '/');
                        setcookie('end_show_banner_'.$row['id'], $time+86400, $time+86400, '/');
                    }
                    elseif($_COOKIE['show_banner_'.$row['id']] <= $row['show_user'] && $_COOKIE['end_show_banner_'.$row['id']] > $time)
                    {
                        $new_cookie_value = $_COOKIE['show_banner_'.$row['id']] + 1;
                        setcookie('show_banner_'.$row['id'], $new_cookie_value, $time+86400, '/');
                    }
                    elseif($_COOKIE['end_show_banner_'.$row['id']] < $time)
                    {
                        setcookie('show_banner_'.$row['id'], 1, $time+86400, '/');
                        setcookie('end_show_banner_'.$row['id'], $time+86400, $time+86400, '/');
                    }
                    else
                    {
                        break;
                    }
                }
                if(!empty($row['check_number']))
                {
                    if($row['show_number'] > 0)
                    {  
                        $rows[] = $row;                                                         
                    }
                }
                else
                {
                   $rows[] = $row;  
                }
            } 
            
            return $rows;
        }
}