<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Cart_ajax
 *
 * Обработка запросов
 */
class Cart_ajax extends Ajax 
{
    /**
     * Обрабатывает полученные данные из формы
     * 
     * @return boolean
     */
    public function ajax_request()
    {
        if (! empty($_POST['module']) && $_POST['module'] == 'cart' && (! $this->diafan->configmodules('security_user', 'shop') || $this->diafan->_user->id) || empty($_POST["action"]))
        {
			switch($_POST["action"])
			{
				case 'recalc':
					return $this->recalc();
				case 'order':
					return $this->order();
				default :
					return false;
			}
		}
		return false;
	}

    /**
     * Пересчет суммы заказа
     * 
     * @return boolean
     */
	private function recalc()
	{
		$summ  = 0;
		$count = 0;
		if (!empty($_SESSION["cart"]))
		{
			foreach ($_SESSION["cart"] as $good_id => $array)
			{
				foreach ($array as $param => $c)
				{
					if (!empty($_POST['del' . $good_id . '_' . $param]) || empty($_POST['editshop' . $good_id . '_' . $param]))
					{
						unset($_SESSION["cart"][$good_id][$param]);
					}
					else
					{
						$edit_count = intval($_POST['editshop' . $good_id . '_' . $param]);
						if ($edit_count <= 0)
						{
							unset($_SESSION["cart"][$good_id][$param]);
							continue;
						}
						$row = $this->diafan->_shop->price_get($good_id, $c["param"], $this->diafan->_user->id, false);
						$this_not_good = false;
						if ($edit_count > $_SESSION["cart"][$good_id][$param]["count"] && $this->diafan->configmodules('use_count_goods', 'shop') && $edit_count > $row["count_goods"])
						{
							$edit_count = $_SESSION["cart"][$good_id][$param]["count"];
							$not_goods = true;
						}
						else
						{
							$_SESSION["cart"][$good_id][$param]["count"] = $edit_count;
						}

						//товар-файл => можно купить только 1 товар
						if(! empty($_SESSION["cart"][$good_id][$param]["is_file"]))
						{
							$edit_count = 1;
							$_SESSION["cart"][$good_id][$param]["count"] = 1;
						}
						$summ += $row["price"] * $edit_count;

						$count += $edit_count;
					}
					if(empty($_SESSION["cart"][$good_id]))
					{
						unset($_SESSION["cart"][$good_id]); 
					}
				}
			}
		}
		$_SESSION["cart_summ"]  = $summ;
		$_SESSION["cart_count"] = $count;
		// пересчитываем сумму заказа с учетом скидки, действующей от суммы заказа
		$summ = 0;
		if (!empty($_SESSION["cart"]))
		{
		    foreach ($_SESSION["cart"] as $good_id => $array)
		    {
			foreach ($array as $param => $c)
			{
			    $row = $this->diafan->_shop->price_get($good_id, $c["param"], $this->diafan->_user->id);
			    $summ += $row["price"] * $c["count"];
			}
		    }
		}
		$_SESSION["cart_summ_discount"] = $summ;
		if (!empty($not_goods))
		{
			$json["error"] = _LANG_NOT_GOODS;
		}
		else
		{
			$json["error"] = _LANG_CHANGES_SAVED;
		}

		$_SESSION["cart_delivery"] = $this->diafan->get_param($_POST, 'delivery_id', 0, 2);

		$_SESSION["cart_additional_cost"] = array();
		if(! empty($_POST["additional_cost_ids"]))
		{
			foreach ($_POST["additional_cost_ids"] as $additional_cost_id)
			{
				$_SESSION["cart_additional_cost"][] = intval($additional_cost_id);
			}
		}

		$cart_tpl = array("count" => $count, "summ" => $this->diafan->format_price($summ), "currency" => $this->diafan->configmodules("currency", "shop"), 
"link" => BASE_PATH_HREF . $this->diafan->_route->module("cart", true));
		$json["target"]           = "#show_cart";
		$json["data"]             = $this->diafan->_tpl->get('info', 'cart', $cart_tpl);

		if (!empty($_POST['ajax']))
		{
			Customization::inc('modules/cart/cart.model.php');
			$model  = new Cart_model($this->diafan);
			$result = $model->form_table();

			$json["table"] = $this->diafan->_tpl->get('table', 'cart', $result);
			if (! $count)
			{
				$json["empty"] = 1;
			}

			include_once ABSOLUTE_PATH.'plugins/json.php';
			echo to_json($json);
		}
		else
		{
			$this->diafan->redirect($this->diafan->_route->current_link() . '?error=cart&mess-table=' . $json["error"]);
		}
		return true;
    }

    /**
     * Оформление заказа
     * 
     * @return boolean
     */
	private function order()
	{
		$this->module = 'shop';
		$this->tag = 'cart';
		$params = $this->get_params(array("module" => "shop", "table" => "shop_order"));

		$this->empty_required_field(array("module" => "shop", "params" => $params));

		if ($this->send_errors())
			return true;

		$summ = 0;
		DB::query("INSERT INTO {shop_order} (user_id, created, status, lang_id) VALUES (%d, %d, '0', %d)",
		          $this->diafan->_user->id,
		          time(),
		          _LANG
		         );
		$order_id = DB::last_id("shop_order");

		// товары
		$goods_summ = 0;
		foreach ($_SESSION["cart"] as $good_id => $array)
		{
			foreach ($array as $param => $c)
			{
				$price = 0;
				$select_depend = 0;
                
                if(! empty($c["count"]) && ! empty($c["is_file"]))//товар-файл => можно купить только 1 товар
                {
                    $c["count"] = 1;
                }
                
				DB::query("INSERT INTO {shop_order_goods} (order_id, good_id, count_goods) VALUES ('%d', '%d', '%d')", $order_id, $good_id, $c["count"]);
				$shop_good_id = DB::last_id("shop_order_goods");

				foreach ($c["param"] as $id => $value)
				{
					DB::query("INSERT INTO {shop_order_goods_param} (order_good_id, value, param_id) VALUES ('%d', '%d', '%d')", $shop_good_id, $value, $id);
				}	 
				$row = $this->diafan->_shop->price_get($good_id, $c["param"], $this->diafan->_user->id);

				DB::query("UPDATE {shop_order_goods} SET price=%f, discount_id=%d WHERE id=%d", $row["price"], $row["discount_id"], $shop_good_id);
				$goods_summ += $row["price"] * $c["count"];
			}
		}
		$summ += $goods_summ;

		// доставка
		$delivery_summ = 0;
		$delivery_id = 0;
		if(! empty($_SESSION["cart_delivery"]))
		{
			$result = DB::query("SELECT id, price, amount FROM {shop_delivery}  WHERE [act]='1' AND trash='0'AND id=%d", $_SESSION["cart_delivery"]);
			if ($row = DB::fetch_array($result))
			{
				if (! empty($row['amount']))
				{
					if ($row['amount'] < $goods_summ)
					{
						$row['price'] = 0;
					}
				}
				$delivery_summ = $row["price"];
				$delivery_id = $row["id"];
				$summ += $delivery_summ;
			}
			DB::query("UPDATE {shop_order} SET delivery_summ=%f, delivery_id=%d WHERE id=%d", $delivery_summ, $delivery_id, $order_id);
		}

		// дополнительная стоимость
		$cart_additional_cost = ! empty($_SESSION["cart_additional_cost"]) ? $_SESSION["cart_additional_cost"] : array();
		$result = DB::query("SELECT id, price, percent, amount, required FROM {shop_additional_cost} WHERE [act]='1' AND trash='0'");
		while ($row = DB::fetch_array($result))
		{
			if (in_array($row["id"], $cart_additional_cost) || $row["required"])
			{
				$row["summ"] = $row['price'];
				if($row['percent'])
				{
					$row["summ"] = $goods_summ * $row['percent'] / 100;
				}
				if (! empty($row['amount']))
				{
					if ($row['amount'] < $goods_summ)
					{
						$row["summ"] = 0;
					}
				}
				DB::query("INSERT INTO {shop_order_additional_cost} (order_id, additional_cost_id, summ) VALUES (%d, %d, %f)", 
						$order_id, $row["id"], $row["summ"]);
				$summ += $row['summ'];
			}
		}
		DB::query("UPDATE {shop_order} SET summ=%f WHERE id=%d", $summ, $order_id);
		
		$this->send_mails($order_id, $params);

		$this->insert_values(array("id" => $order_id, "table" => "shop_order", "params" => $params));

		$_SESSION["order"][] = $order_id;

		unset($_SESSION["cart"]);
		unset($_SESSION["cart_summ"]);
		unset($_SESSION["cart_summ_discount"]);
		unset($_SESSION["cart_count"]);
		unset($_SESSION["cart_delivery"]);
		unset($_SESSION["cart_additional_cost"]);
		
		// если у пользователя купон на скидку с ограниченным действием, используем один раз купон
		$discount = DB::fetch_array(DB::query("SELECT id, count_use FROM {shop_discount} WHERE coupon<>'' AND user_id=%d AND trash='0' AND act='1'", $this->diafan->_user->id));
		if($discount)
		{
			if($discount["count_use"] == 1)
			{
				DB::query("UPDATE {shop_discount} SET count_use=0, act='0' WHERE id=%d", $discount["id"]);
				$this->diafan->_shop->price_calc(0, $discount["id"]);
			}
			elseif($discount["count_use"])
			{
				DB::query("UPDATE {shop_discount} SET count_use=count_use-1 WHERE id=%d", $discount["id"]);
			}
		}
		if(empty($_POST["payment_id"]))
		{
			$this->result["form_hide"] = true;
			$this->result["target"] = '.cart_table_form';
			$this->result["form"] = $this->diafan->configmodules('mes', 'shop');
		}
		else
		{
			DB::query("UPDATE {shop_order} SET payment_id='%d' WHERE id=%d", $_POST["payment_id"], $order_id);
			$payment_text = DB::query_result("SELECT text FROM {shop_payment} WHERE id=%d AND payment='' LIMIT 1", $_POST["payment_id"]);

			if(!empty($payment_text))
			{
				$this->result["form_hide"] = true;
				$this->result["target"] = '.cart_table_form';
				$this->result["form"] = $this->diafan->configmodules('mes', 'shop').$payment_text;
			}
			else
			{
				$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->cid, "cart").'step2/show'.$order_id.'/';
			}
		}

		return $this->send_errors();
	}

	/**
	 * Отправляет письма администратору сайта и пользователю, сделавшему заказ
	 *
	 * @param integer $order_id номер заказа
	 * @param array $params поля формы, заполняемой пользователем
	 * @return boolean
	 */
	public function send_mails($order_id, $params)
	{
		require_once (ABSOLUTE_PATH.'includes/mail.php');

		Customization::inc('modules/cart/cart.model.php');

		$model = new Cart_model($this->diafan);
		$result_cart = $model->form();
		$result_cart["hide_form"] = true;
		$cart = $this->diafan->_tpl->get('table', 'cart', $result_cart);

		//send mail admin
		$subject = str_replace(array('%title', '%url'),
		                       array(TITLE, BASE_URL),
		                       $this->diafan->configmodules('subject_admin', 'shop')
		                      );

		$user_email = $this->diafan->_user->mail ? $this->diafan->_user->mail : $this->diafan->get_param($_POST, "mail", '', 1);
		$message = str_replace(
			array('%title',
				'%url',
				'%id',
				'%message',
				'%order'
			),
			array(
				TITLE,
				BASE_URL,
				$order_id,
				$this->message_param,
				$cart
			),
			$this->diafan->configmodules('message_admin', 'shop'));

		send_mail(
				$this->diafan->configmodules("emailconfadmin", 'shop') ? $this->diafan->configmodules("email_admin", 'shop') : EMAIL_CONFIG,
				$subject,
				$message,
				$this->diafan->configmodules("emailconf", 'shop') ? $this->diafan->configmodules("email", 'shop') : ''
			);

		foreach($params as $param)
		{
			if ($param["type"] == "email")
            {
                $user_email = $_POST["p".$param["id"]];
            }
		}

		//send mail user
		if (empty($user_email))
		{
			return false;
		}
		
		$subject = str_replace(
				array('%title', '%url'),
				array(TITLE, BASE_URL),
				$this->diafan->configmodules('subject', 'shop')
			);

		$message = str_replace(
				array('%title', '%url', '%id', '%order'),
				array(
					TITLE,
					BASE_URL,
					$order_id,
					$cart
				),
				$this->diafan->configmodules('message', 'shop')
			);

		send_mail(
				$user_email,
				$subject,
				$message,
				$this->diafan->configmodules("emailconf", 'shop') ? $this->diafan->configmodules("email", 'shop') : ''
			);
		return true;
	}
}