<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Clauses_admin_category
 *
 * Редактирование категорий статей
 */
class Clauses_admin_category extends Frame_admin
{

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'clausescategory';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'clauses_category';

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
	$this->diafan = $diafan;

	$this->nastr = 100;

	//поля в базе данных для редактирования
	$this->variable_table = array('main' =>
	    array(
		'name' => 'text',
		'act' => 'checkbox',
		'menu' => 'module',
		'images' => 'module',
		'comments' => 'module',
		'hr2' => 'hr',
		'anons' => 'editor',
		'text' => 'editor',
	    ),
	    'other_rows' =>
	    array(
		'hr1' => 'hr',
		'number' => 'function',
		'timeedit' => 'text',
		'title_meta' => 'text',
		'keywords' => 'text',
		'descr' => 'textarea',
		'rewrite' => 'function',
		'access' => 'function',
		'theme' => 'function',
		'view' => 'none',
		'parent_id' => 'select',
		'site_id' => 'function',
		'map_no_show' => 'checkbox',
	    )
	);

	//поля, которые прячутся в Дополнительно
	$this->variable_other = array(
	    'hr1' => 1,
	    'number' => 1,
	    'title_meta' => 1,
	    'timeedit' => 1,
	    'keywords' => 1,
	    'descr' => 1,
	    'rewrite' => 1,
	    'access' => 1,
	    'sort' => 'function',
	    'theme' => 1,
	    'view' => 1,
	    'parent_id' => 1,
	    'site_id' => 1,
	    'map_no_show' => 1
	);

	//переводимые поля
	$this->language_names = array(
	    'name',
	    'title_meta',
	    'act',
	    'keywords',
	    'descr',
	    'anons',
	    'text'
	);

	$this->config_module = array(
	    'parent' => 1, //содержит вложенности
	    'order' => 1, //сортируется
	    'menu' => 1, //используется в меню
	    'act' => 1, //показать/скрыть
	    'del' => 1, //удалить
	    'category' => 1, //часть модуля - категории
	    'category_rel' => 1, //работают вместе с таблицей {module_category_rel}
	    'element_site' => 1, //модуль может быть прикреплен к нескольким страницам
	    'trash' => 1  //использовать корзину	
	);

	if (!extension_loaded('gd') && !extension_loaded('gd2'))
	{
	    $this->diafan->error = 7;
	}

	//высота поля для Визуального редактора
	$this->editor_height = array(
	    'anons' => 200,
	    'text' => 400
	);
    }

    /**
     * Выводит список категорий
     * @return boolean true
     */
    public function show_module()
    {
	$this->addnew_init(_ADMIN_ADD_CATEGORY);

	$this->list_row();


	return true;
    }

}