<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Clauses_model
 *
 * Модель модуля "Статьи"
 */
class Clauses_model extends Model
{


	/**
	 * Генерирует данные для списка всех статей без деления на категории
	 * 
	 * @return array
	 */
	public function list_()
	{
		if ($this->diafan->cat)
		{
			include ABSOLUTE_PATH.'includes/404.php';
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		$cache_meta = array(
				"name"     => "list",
				"language" => _LANG,
				"page"     => $this->diafan->page > 1 ? $this->diafan->page : 1,
				"site_id"  => $this->diafan->cid,
				"time"     => $time,
				"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
			);

		//кеширование
		if (! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			////navigation//
			$this->diafan->_paginator->page    = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("page" => "%d"));
			$this->diafan->_paginator->nen = DB::query_result(
						"SELECT COUNT(DISTINCT e.id) FROM {clauses} AS e"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
						." WHERE e.[act]='1' AND e.trash='0'"
						." AND e.site_id=%d AND e.created<%d"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")", 
						$this->diafan->cid, $time
					);

			$links = $this->diafan->_paginator->get();
			////navigation///

			$result = DB::query_range(
					"SELECT e.id, e.created, e.[name], e.[anons], e.timeedit, e.cat_id, e.site_id FROM {clauses} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
					." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d AND e.created<%d"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
					$this->diafan->cid, $time,
					$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
				);

			$this->result["rows"] = $this->get_elements($result);

			$this->result["paginator"] = $links;
			
			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["tags"] = $this->diafan->configmodules("tags") ? $this->diafan->_tags->get($row["id"]) : '';

				$this->result["rows"][$i]["show_rating"] = $this->diafan->configmodules("rating") ? $this->diafan->_rating->get($row["id"]) : '';

				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'clauses', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'clauses',  _LANG);

				$this->result["rows"][$i]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'clauses');
			}
		}
		if($this->diafan->configmodules("theme_list"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_list");
		}
		if($this->diafan->configmodules("view_list"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_list");
		}
		else
		{
			$this->result["view"] = 'list';
		}
		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);
		return $this->result;
		
	}

	/**
	 * Генерирует данные для первой страницы статей
	 * 
	 * @return array
	 */
	public function first_page()
	{
		if ($this->diafan->page)
		{
			include ABSOLUTE_PATH.'includes/404.php';
		}
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
				"name"     => "first_page",
				"language" => _LANG,
				"time"     => $time,
				"site_id"  => $this->diafan->cid,
				"role_id"  => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
			);
		if (! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			$result = DB::query(
					"SELECT c.id, c.[name], c.[anons], c.timeedit, c.site_id FROM {clauses_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='clauses'" : "")
					." WHERE c.[act]='1' AND c.parent_id=0 AND c.trash='0' AND c.site_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY c.id ORDER by c.sort ASC, c.id ASC",
					$this->diafan->cid
				);

			while ($row = DB::fetch_array($result))
			{
				$this->result["categories"][$row["id"]]["name"] = $row["name"];
				$this->result["categories"][$row["id"]]["anons"] = $row["anons"];

				if (empty($this->result["timeedit"]) || $row["timeedit"] > $this->result["timeedit"])
				{
					$this->result["timeedit"] = $row["timeedit"];
				}

				$this->result["categories"][$row["id"]]["children"] = array();
				$result_children = DB::query(
						"SELECT c.id, c.[name], c.[anons], c.site_id FROM {clauses_category} AS c"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='clauses'" : "")
						." WHERE c.[act]='1' AND c.parent_id=%d AND c.trash='0' AND c.site_id=%d"
						." AND (c.access='0'"
						.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." GROUP BY c.id ORDER BY c.sort ASC, c.id ASC",
						$row["id"], $this->diafan->cid);

				while ($child = DB::fetch_array($result_children))
				{
					$child["link"]  = $this->diafan->_route->link($child["site_id"], 'clauses', $child["id"]);
					if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
					{
						$child["img"] = $this->diafan->_images->get($child["id"], $child["name"], $this->diafan->module,
						                                            $this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
						                                            $child["link"], true);
					}
					unset($child["site_id"]);
					$this->result["categories"][$row["id"]]["children"][] = $child;
				}

				$children = array();
				if ($this->diafan->configmodules("childrens_elements"))
				{
					$children = $this->diafan->get_children($row["id"],"clauses_category");
				}
				$children[] = $row["id"];

				$result_img = DB::query_range(
						"SELECT e.id, e.[name], e.cat_id, e.timeedit, e.[anons], e.site_id, e.created FROM {clauses} AS e"
						." INNER JOIN {clauses_category_rel} AS r ON e.id=r.element_id"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
						." WHERE r.cat_id IN (%s) AND e.[act]='1' AND e.trash='0' AND e.created<'%d'"
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
						implode(',', $children), $time, 0, $this->diafan->configmodules("count_list")
				);
				$this->result["categories"][$row["id"]]["rows"] = $this->get_elements($result_img);

				$this->result["categories"][$row["id"]]["link_all"] = $this->diafan->_route->link($row["site_id"], 'clauses', $row["id"]);

				if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
				{
					$this->result["categories"][$row["id"]]["img"] =
					$this->diafan->_images->get($row["id"], $row["name"], $this->diafan->module,
					                            $this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
					                            $this->result["categories"][$row["id"]]["link_all"],
					                            true);
				}
			}

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		if (! empty($this->result["categories"]))
		{
			foreach ($this->result["categories"] as $cat => $rows)
			{
				if (! $rows)
					continue;

				$this->result["categories"][$cat]["name"] = $this->diafan->_useradmin->get($rows["name"], 'name', $cat, 'clauses_category', _LANG);
				$this->result["categories"][$cat]["anons"] = $this->diafan->_useradmin->get($rows["anons"], 'anons', $cat, 'clauses_category', _LANG);
				foreach ($rows["children"] as $k => $row)
				{
					$this->result["categories"][$cat]["children"][$k]["name"] =
						$this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'clauses_category', _LANG);

					$this->result["categories"][$cat]["children"][$k]["anons"] =
						$this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'clauses_category', _LANG);
				}

				foreach ($rows["rows"] as $k => $row)
				{
					$this->result["categories"][$cat]["rows"][$k]["tags"] = $this->diafan->configmodules("tags") ? $this->diafan->_tags->get($row["id"]) : '';

					$this->result["categories"][$cat]["rows"][$k]["show_rating"] =
						$this->diafan->configmodules("rating") ? $this->diafan->_rating->get($row["id"]) : '';

					$this->result["categories"][$cat]["rows"][$k]["name"] =
						$this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'clauses', _LANG);

					$this->result["categories"][$cat]["rows"][$k]["anons"] =
						$this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'clauses', _LANG);
		
					$this->result["categories"][$cat]["rows"][$k]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'clauses');
				}
			}
		}
		if($this->diafan->configmodules("theme_first_page"))
		{
			$this->result["theme"] = $this->diafan->configmodules("theme_first_page");
		}
		if($this->diafan->configmodules("view_first_page"))
		{
			$this->result["view"] = $this->diafan->configmodules("view_first_page");
		}
		else
		{
			$this->result["view"] = 'first_page';
		}
		return $this->result;
	}

	/**
	 * Генерирует данные для списка статей в категории
	 * 
	 * @return array
	 */
	public function list_category()
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
				"name"     => "list",
				"cat_id"   => $this->diafan->cat,
				"language" => _LANG,
				"page"     => $this->diafan->page > 1 ? $this->diafan->page : 1,
				"time"     => $time,
				"site_id"  => $this->diafan->cid,
				"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
			);
		if (! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$this->result = array();

			$this->result["level"] = count($this->diafan->get_parents($this->diafan->cat, 'clauses_category'));
			
			$this->result["path"] = $this->get_path('clauses');

			$result = DB::query("SELECT id, [name], timeedit, [descr], [keywords], sort, parent_id, [title_meta], access, theme, view FROM {clauses_category}"
			                    ." WHERE [act]='1' and id=%d AND trash='0' AND site_id=%d"
			                    ." ORDER BY sort ASC, id ASC",
			                    $this->diafan->cat, $this->diafan->cid);

			if (! $row = DB::fetch_array($result))
			{
				include_once ABSOLUTE_PATH.'includes/404.php';
			}
			if (empty($row) || (!empty($row['access']) && !$this->access(0, $row['id'])))
			{
				include_once(ABSOLUTE_PATH.'includes/403.php');
			}

			if($row["theme"])
			{
				$this->result["theme"] = $row["theme"];
			}
			elseif($this->diafan->configmodules("theme_list"))
			{
				$this->result["theme"] = $this->diafan->configmodules("theme_list");
			}

			if($row["view"])
			{
				$this->result["view"] = $row["view"];
			}
			elseif($this->diafan->configmodules("view_list"))
			{
				$this->result["view"] = $this->diafan->configmodules("view_list");
			}
			else
			{
				$this->result["view"] = 'list';
			}

			$this->result["id"]  = $row["id"];
			if ($this->diafan->configmodules("images_cat"))
			{
				$this->result["img"] = $this->diafan->_images->get($row["id"], $row["name"], $this->diafan->module, 0, 1, true);
			}

			if ($this->diafan->configmodules("childrens_elements"))
			{
				$children = $this->diafan->get_children($this->diafan->cat, "clauses_category");
			}
			$children[] = $this->diafan->cat;

			////navigation//
			$this->diafan->_paginator->page    = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("page" => "%d"));
			$this->diafan->_paginator->nen = DB::query_result(
					"SELECT COUNT(DISTINCT e.id) FROM {clauses} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
					." INNER JOIN {clauses_category_rel} AS r ON e.id=r.element_id"
					." AND e.id=r.element_id AND r.cat_id IN (%s)"
					." WHERE e.[act]='1' AND e.trash='0' AND e.created<'%d'"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")",
					implode(',', $children), $time
				);
			$links = $this->diafan->_paginator->get();
			////navigation///

			$result_img = DB::query_range(
					"SELECT e.id, e.[name], e.cat_id, e.timeedit, e.[anons], e.site_id, e.created FROM {clauses} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
					." INNER JOIN {clauses_category_rel} AS r ON e.id=r.element_id AND r.cat_id IN (%s)"
					." WHERE e.[act]='1' AND e.trash='0' AND e.created<%d"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY e.id ORDER BY e.prior DESC, e.created DESC, e.id DESC",
					implode(',', $children), $time,
					$this->diafan->_paginator->polog, $this->diafan->_paginator->nastr
				);

			$this->result["rows"] = $this->get_elements($result_img);

			$this->result["paginator"] = $links;

			$this->result["titlemodule"] = $row["name"];
			$this->result["edit_titlemodule"] = array("id" => $row["id"], "table" => "clauses_category");
			$this->result["title_meta"]  = $row["title_meta"];
			$this->result["timeedit"]    = $row["timeedit"];
			$this->result["keywords"]    = $row["keywords"];
			$this->result["descr"]       = $row["descr"];

			$previous = DB::fetch_array(DB::query(
					"SELECT c.[name], c.id FROM {clauses_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='clauses'" : "")
					." WHERE c.[act]='1' AND c.trash='0' AND c.site_id=%d"
					." AND (c.sort<%d OR c.sort=%d AND c.id<%d) AND c.parent_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY c.sort DESC, c.id DESC LIMIT 1",
					$this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->cat, $row["parent_id"]
				));
			if ($previous)
			{
				$this->result["previous"]["text"] = $previous["name"];
				$this->result["previous"]["id"]   = $previous["id"];
				$this->result["previous"]["link"] = $this->diafan->_route->link($this->diafan->cid, "clauses", $previous["id"]);
			}
			
			$next = DB::fetch_array(DB::query(
					"SELECT c.[name], c.id FROM {clauses_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='clauses'" : "")
					." WHERE c.[act]='1' AND c.trash='0' AND c.site_id=%d"
					." AND (c.sort>%d OR c.sort=%d AND c.id>%d) AND c.parent_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY c.sort ASC, c.id ASC LIMIT 1",
					$this->diafan->cid, $row["sort"], $row["sort"], $this->diafan->cat, $row["parent_id"]
				));
			if ($next)
			{
				$this->result["next"]["text"] = $next["name"];
				$this->result["next"]["id"]   = $next["id"];
				$this->result["next"]["link"] = $this->diafan->_route->link($this->diafan->cid, "clauses", $next["id"]);
			}

			$this->result["children"] = array();
			$result_children = DB::query(
					"SELECT c.id, c.[name], c.[anons], c.site_id FROM {clauses_category} AS c"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.cat_id=c.id AND a.module_name='clauses'" : "")
					." WHERE c.[act]='1' AND c.parent_id=%d AND c.trash='0' AND c.site_id=%d"
					." AND (c.access='0'"
					.($this->diafan->_user->id ? " OR c.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." GROUP BY c.id ORDER BY c.sort ASC, c.id ASC", 
					$row["id"], $this->diafan->cid
				);

			while ($child = DB::fetch_array($result_children))
			{
				$child["link"]  = $this->diafan->_route->link($child["site_id"], 'clauses', $child["id"]);
				if ($this->diafan->configmodules("images_cat") && $this->diafan->configmodules("list_img_cat"))
				{
					$child["img"] = $this->diafan->_images->get($child["id"], $child["name"], $this->diafan->module,
																$this->diafan->configmodules("list_img_cat") == 1 ? 1 : 0,
																$child["link"], true);
				}
				unset($child["site_id"]);
				$this->result["children"][] = $child;
			}

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}

		$text = DB::query_result("SELECT [text] FROM {clauses_category} WHERE id=%d", $this->diafan->cat);
		$this->result["text"] = $this->diafan->_useradmin->get($text, 'text', $this->diafan->cat, 'clauses_category', _LANG);

		if ($this->diafan->configmodules("cat") && ! empty($this->diafan->cat) && $this->diafan->configmodules("comments_cat"))
		{
			$this->result["comments"] = $this->diafan->_comments->get();
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["tags"] = $this->diafan->configmodules("tags") ? $this->diafan->_tags->get($row["id"]) : '';

				$this->result["rows"][$i]["show_rating"] = $this->diafan->configmodules("rating") ? $this->diafan->_rating->get($row["id"]) : '';

				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'clauses', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'clauses',  _LANG);

				$this->result["rows"][$i]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'clauses');
			}
			if (! empty($this->result["previous"]["text"]))
			{
				$this->result["previous"]["text"] =
					$this->diafan->_useradmin->get($this->result["previous"]["text"], 'name', $this->result["previous"]["id"], 'clauses_category', _LANG);
			}
			if (! empty($this->result["next"]["text"]))
			{
				$this->result["next"]["text"] =
					$this->diafan->_useradmin->get($this->result["next"]["text"], 'name', $this->result["next"]["id"], 'clauses_category', _LANG);
			}
			foreach ($this->result["children"] as $id => $row)
			{
				$this->result["children"][$id]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'clauses_category', _LANG);
				$this->result["children"][$id]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'clauses_category', _LANG);
			}
			foreach ($this->result["path"] as $k => $path)
			{
				if ($k == 0)
					continue;
				$this->result["path"][$k]["name"] = $this->diafan->_useradmin->get($path["name"], 'name', $path["id"], 'clauses_category', _LANG);
			}
		}
		$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);
		return $this->result;
	}

	/**
	 * Генерирует данные для страницы статьи
	 * 
	 * @return array|boolean false
	 */
	public function id()
	{
		//кеширование
		$cache_meta = array(
				"name"     => "show",
				"cat_id"   => $this->diafan->cat,
				"show"     => $this->diafan->show,
				"language" => _LANG,
				"site_id"  => $this->diafan->cid,
				"role_id" => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
			);
		if (! $this->result = $this->diafan->_cache->get($cache_meta, $this->diafan->module))
		{
			$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

			$row = DB::fetch_array(DB::query("SELECT id, [name], timeedit, created, cat_id, [keywords], [descr], site_id, [title_meta], access, theme, view FROM"
			                                 ." {clauses} WHERE [act]='1' AND id = %d AND trash='0' AND site_id=%d AND created<%d",
			                                 $this->diafan->show, $this->diafan->cid, $time));
			if (empty($row))
			{
				include ABSOLUTE_PATH.'includes/404.php';
				return false;
			}

			if (! $this->diafan->rewrite_module && ($this->diafan->configmodules("cat") && $this->diafan->cat != $row["cat_id"]
			  || ! $this->diafan->configmodules("cat") && $this->diafan->cat))
			{
				include ABSOLUTE_PATH.'includes/404.php';
				return false;
			}
			if (!empty($row['access']) && !$this->access($row['id']))
			{
				include ABSOLUTE_PATH . 'includes/403.php';
			}

			if($row["theme"])
			{
				$this->result["theme"] = $row["theme"];
			}
			elseif($this->diafan->configmodules("theme_id"))
			{
				$this->result["theme"] = $this->diafan->configmodules("theme_id");
			}

			if($row["view"])
			{
				$this->result["view"] = $row["view"];
			}
			elseif($this->diafan->configmodules("view_id"))
			{
				$this->result["view"] = $this->diafan->configmodules("view_id");
			}
			else
			{
				$this->result["view"] = 'id';
			}
			$this->result["id"]     = $this->diafan->show;
			$this->diafan->cat      = $this->diafan->configmodules("cat") ? $row["cat_id"] : 0;
			$this->result["cat_id"] = $this->diafan->configmodules("cat") ? $row["cat_id"] : 0;

			if ($this->diafan->configmodules("images"))
			{
				$this->result["img"]    = $this->diafan->_images->get($row["id"], $row["name"], $this->diafan->module);
			}

			if ($this->result["cat_id"])
			{
				$this->result["allclauses"]["link"] = $this->diafan->_route->link($row["site_id"], "clauses", $row["cat_id"]);
			}
			else
			{
				$this->result["allclauses"]["link"] = $this->diafan->_route->link($row["site_id"]);
			}

			$previous = DB::fetch_array(DB::query(
					"SELECT e.[name], e.id, e.cat_id FROM {clauses} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
					." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
					.($this->diafan->configmodules("cat") ? " AND e.cat_id='" . $this->diafan->cat . "'" : '')
					." AND e.created<%d AND (e.created<%d OR e.created=%d AND e.id<%d)"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY e.prior DESC, e.created DESC, e.id DESC LIMIT 1",
					$this->diafan->cid, $time, $row["created"], $row["created"], $this->diafan->show
				));
			if ($previous)
			{
				$this->result["previous"]["text"] = $previous["name"];
				if (! $this->diafan->configmodules("cat"))
				{
					$previous["cat_id"] = 0;
				}
				$this->result["previous"]["id"]   = $previous["id"];
				$this->result["previous"]["link"] = $this->diafan->_route->link($this->diafan->cid, "clauses", $previous["cat_id"], $previous["id"]);
			}
			$next = DB::fetch_array(DB::query(
					"SELECT e.[name], e.id, e.cat_id FROM {clauses} AS e"
					.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
					." WHERE e.[act]='1' AND e.trash='0' AND e.site_id=%d"
					.($this->diafan->configmodules("cat") ? " AND e.cat_id='" . $this->diafan->cat . "'" : '')
					." AND e.created<%d AND (e.created>%d OR e.created=%d AND e.id>%d)"
					." AND (e.access='0'"
					.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
					.")"
					." ORDER BY e.prior ASC, e.created ASC, e.id ASC LIMIT 1",
					$this->diafan->cid, $time, $row["created"], $row["created"], $this->diafan->show
				));
			if ($next)
			{
				$this->result["next"]["text"] = $next["name"];
				if (! $this->diafan->configmodules("cat"))
				{
					$next["cat_id"] = 0;
				}
				$this->result["next"]["id"]   = $next["id"];
				$this->result["next"]["link"] = $this->diafan->_route->link($this->diafan->cid, "clauses", $next["cat_id"], $next["id"]);
			}

			$this->result["date"]         = $this->format_date($row['created']);

			$this->result["titlemodule"]  = $row["name"];
			$this->result["edit_titlemodule"] = array("id" => $row["id"], "table" => "clauses");
			$this->result["title_meta"]   = $row["title_meta"];
			$this->result["timeedit"]     = $row["timeedit"];

			$this->result["keywords"]     = $row["keywords"];
			$this->result["descr"]        = $row["descr"];
			
			$this->result["path"]         = $this->get_path('clauses');

			//сохранение кеша
			$this->diafan->_cache->save($this->result, $cache_meta, $this->diafan->module);
		}
		$this->diafan->cat = $this->result["cat_id"];

		$row = DB::fetch_array(DB::query("SELECT [text], [anons] FROM {clauses} WHERE id=%d", $this->diafan->show));

		$this->result["text"]  = $this->diafan->_useradmin->get($row["text"], 'text', $this->result["id"], 'clauses', _LANG);
		$this->result["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $this->result["id"], 'clauses', _LANG);
		$this->result["date"] = $this->diafan->_useradmin->get($this->result["date"], 'created', $this->result["id"], 'clauses');

		if (! empty($this->result["previous"]["text"]))
		{
			$this->result["previous"]["text"] =
				$this->diafan->_useradmin->get($this->result["previous"]["text"], 'name', $this->result["previous"]["id"], 'clauses', _LANG);
		}
		if (! empty($this->result["next"]["text"]))
		{
			$this->result["next"]["text"] =
				$this->diafan->_useradmin->get($this->result["next"]["text"], 'name', $this->result["next"]["id"], 'clauses', _LANG);
		}
		foreach ($this->result["path"] as $k => $path)
		{
			if ($k == 0)
				continue;
			$this->result["path"][$k]["name"] = $this->diafan->_useradmin->get($path["name"], 'name', $path["id"], 'clauses_category', _LANG);
		}

		if ($this->diafan->configmodules("rating"))
		{
			$this->result["show_rating"] = $this->diafan->_rating->get();
			$this->result["add_rating"] = $this->diafan->_rating->add();
		}

		if ($this->diafan->configmodules("comments"))
		{
			$this->result["comments"] = $this->diafan->_comments->get();
		}

		if ($this->diafan->configmodules("tags"))
		{
			$this->result["tags"] = $this->diafan->_tags->get();
		}

		return $this->result;
	}

	/**
	 * Генерирует данные для шаблонной функции: блок статей
	 * 
	 * @param integer $count количество статей
	 * @param integer $cat_id категория
	 * @param integer $images количество фотографий
	 * @param string $sort сортировка date - по дате, rand - случайно
	 * @param integer $site_id страница сайта
	 * @return array
	 */
	public function show_block($count, $cat_id, $images, $sort, $site_id)
	{
		$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));

		//кеширование
		$cache_meta = array(
				"name"     => "block",
				"cat_id"   => $cat_id,
				"count"    => $count,
				"language" => _LANG,
				"time"     => $time,
				"site_id"  => $site_id,
				"sort"     => $sort,
				"role_id"  => $this->diafan->_user->id ? $this->diafan->_user->role_id : 0
			);

		if ($sort == "rand" || ! $this->result = $this->diafan->_cache->get($cache_meta, "clauses"))
		{
			if ( ! $site_id && $cat_id)
			{
				$site_id = DB::query_result("SELECT site_id FROM {clauses_category} WHERE id=%d", $cat_id);
			}
			if (!$site_id)
			{
				$site_id = DB::query_result(
						"SELECT s.id FROM {site} AS s"
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='site'" : "")
						." WHERE s.addmodule='clauses' AND s.trash='0' AND s.[act]='1' AND s.block='0'"
						." AND (s.access='0'"
						.($this->diafan->_user->id ? " OR s.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.") LIMIT 1"
					);
			}
			else
			{
				if(DB::query_result("SELECT access FROM {site} WHERE id=%d", $site_id))
				{
					if(! $this->access($site_id, 0, "site"))
					{
						return FALSE;
					}
				}
			}
			if(! $site_id)
			{
				return FALSE;
			}
			if ($cat_id && $this->diafan->configmodules("cat", "clauses", $site_id))
			{
				if(DB::query_result("SELECT access FROM {clauses_category} WHERE id=%d", $cat_id))
				{
					if(! $this->access(0, $cat_id, "clauses"))
					{
						return FALSE;
					}
				}
				if ($this->diafan->configmodules("childrens_elements", "clauses", $site_id))
				{ 
					$children = $this->diafan->get_children($cat_id, "clauses_category");
				}
				$children[] = $cat_id;
			}

			if ($sort == "rand")
			{
				$max_count = DB::query_result(
						"SELECT COUNT(DISTINCT e.id) FROM {clauses} as e"
						.($cat_id && $this->diafan->configmodules("cat", "clauses", $site_id)
						  ? " INNER JOIN {clauses_category_rel} as c ON c.element_id=e.id"
							." AND c.cat_id IN (".implode(',', $children).")"
						  : ''
						 )
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
						." WHERE e.[act]='1' AND e.trash='0' AND e.created<%d"
						.($site_id ? " AND e.site_id=".$site_id : '')
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")", $time
					);
				$rands = array();
				for ($i = 1; $i <= min($max_count, $count); $i++)
				{
					do
					{
						$rand = mt_rand(0, $max_count - 1);
					}
					while (in_array($rand, $rands));
					$rands[] = $rand;
				}
			}
			else
			{
				$rands[0] = 1;
			}
			$this->result["rows"] = array();

			foreach ($rands as $rand)
			{
				$result = DB::query_range(
						"SELECT e.id, e.[name],e.[anons], e.cat_id, e.timeedit, e.site_id, e.created FROM {clauses} AS e"
						.($cat_id && $this->diafan->configmodules("cat", "clauses", $site_id)
						? " INNER JOIN {clauses_category_rel} as r ON r.element_id=e.id"
							." AND r.cat_id IN (" . implode(',', $children) . ")" 
						: ''
						)
						.($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=e.id AND a.module_name='clauses'" : "")
						." WHERE e.[act]='1' AND e.trash='0' AND e.created<%d"
						.($site_id ? " AND e.site_id=" . $site_id : '')
						." AND (e.access='0'"
						.($this->diafan->_user->id ? " OR e.access='1' AND a.role_id=".$this->diafan->_user->role_id : '')
						.")"
						." GROUP BY e.id"
						.($sort == "date" ? ' ORDER BY e.prior DESC, e.created DESC, e.id DESC' : ''),
						$time,
						$sort == "rand" ? $rand : 0,
						$sort == "rand" ? 1     : $count
					);

				$this->result["rows"] = array_merge($this->result["rows"], $this->get_elements($result, $images));
			}

			if (! empty($this->result["rows"]) && $cat_id && $this->diafan->configmodules("cat", "clauses", $site_id))
			{
				$cat = DB::fetch_array(DB::query("SELECT [name], site_id, id FROM {clauses_category} WHERE id=%d", $cat_id));
				
				$this->result["name"] = $cat["name"];
				$this->result["link_all"] = $this->diafan->_route->link($cat["site_id"], 'clauses', $cat["id"]);
				$this->result["category"] = true;
			}
			elseif (! empty($this->result["rows"]) && $site_id)
			{
				$this->result["name"] = DB::query_result("SELECT [name] FROM {site} WHERE id=%d", $site_id);
				$this->result["link_all"] = $this->diafan->_route->link($site_id);
				$this->result["category"] = false;
			}
			//сохранение кеша
			if ($sort != "rand")
			{
				$this->diafan->_cache->save($this->result, $cache_meta, "clauses");
			}
		}

		if ($this->result["rows"])
		{
			foreach ($this->result["rows"] as $i => $row)
			{
				$this->result["rows"][$i]["name"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'clauses', _LANG);

				$this->result["rows"][$i]["anons"] = $this->diafan->_useradmin->get($row["anons"], 'anons', $row["id"], 'clauses', _LANG);

				$this->result["rows"][$i]["date"] = $this->diafan->_useradmin->get($row["date"], 'created', $row["id"], 'clauses');
			}
		}

		return $this->result;
	}

	/**
	 * Форматирует данные о статьях для списка статей
	 *
	 * @param resource $result результат выполнения SQL-запроса
	 * @param string $images показывать фотографии
	 * @return array
	 */
	public function get_elements($result, $images = 'list')
	{
		if (empty($this->result["timeedit"]))
		{
			$this->result["timeedit"] = '';
		}
		$rows = array();
		while ($row = DB::fetch_array($result))
		{
			if (! $this->diafan->configmodules("cat", "clauses", $row["site_id"]))
			{
				$row["cat_id"] = 0;
			}
			if ($row["timeedit"] < $this->result["timeedit"])
			{
				$this->result["timeedit"] = $row["timeedit"];
			}
			unset($row["timeedit"]);

			$row["link"] = $this->diafan->_route->link($row["site_id"], "clauses", $row["cat_id"], $row["id"]);
			unset($row["cat_id"]);

			if ($this->diafan->configmodules("images", "clauses", $row["site_id"]))
			{
				if ($images === 'list' && $this->diafan->configmodules("list_img", "clauses", $row["site_id"]))
				{
					$row["img"]  = $this->diafan->_images->get($row["id"], $row["name"], 'clauses',
					               $this->diafan->configmodules("list_img", "clauses", $row["site_id"]) == 1 ? 1 : 0,
					               $row["link"]);
				}
				elseif ($images != 'list' && $images)
				{
					$row["img"]  = $this->diafan->_images->get($row["id"], $row["name"], 'clauses', $images, $row["link"]);
				}
			}
			$row["date"] = $this->format_date($row['created'], "clauses", $row["site_id"]);
			unset($row["created"]);

			$rows[] = $row;
		}
		return $rows;
	}
}