<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Comments_admin_config
 *
 * Конфигурирование модуля "Комментарии"
 */
class Comments_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'comments_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;

		$this->variable_table = array(
			'config'=>
				array (
				'format_date' => 'select',
				'count_level' => 'numtext',
				'max_count' => 'numtext',
				'use_bbcode' => 'checkbox',
				'hr1' => 'hr',
				'user_name' => 'checkbox',
				'only_user' => 'checkbox',
				'captcha' => 'checkbox',
				'security_moderation' => 'checkbox',
				'hr2' => 'hr',
				'error_insert_message' => 'text',
				'error_empty_fields' => 'text',
				'add_message' => 'text',
				'hr3' => 'hr',
				'sendmailadmin' => 'checkbox',
				'emailconfadmin' => 'function',
				'email_admin' => 'none',
				'subject_admin' => 'text',
				'message_admin' => 'textarea'
				)
		);

		$this->config_module = array(
			'config' => 1 //файл настроек модуля
		);

		$this->language_names = array(
			'error_insert_message',
			'add_message',
            'error_empty_fields'
		);

		$this->select_arr["format_date"] = array(
			0 => _ADMIN_FORMAT_DATE_0,
			1 => _ADMIN_FORMAT_DATE_1,
			2 => _ADMIN_FORMAT_DATE_2,
			3 => _ADMIN_FORMAT_DATE_3,
			4 => _ADMIN_FORMAT_DATE_4,
			5 => _ADMIN_FORMAT_DATE_5
		);

		$this->show_tr_click_checkbox = array(
			"sendmailadmin" => array(
				'emailconfadmin',
				'subject_admin',
				'message_admin'
			)
		);
	}
}