<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Comments_install
 *
 * Установка модуля "Комментарии"
 */

$title = "Комментарии";

$sql = array(
	"INSERT INTO {modules} (name, module_name, admin) VALUES ('comments', 'comments', '1')",

	"CREATE TABLE {comments} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		user_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		text text NOT NULL DEFAULT '',
		act ENUM('0', '1') NOT NULL DEFAULT '0',
		created INT(12) UNSIGNED NOT NULL DEFAULT '0',
		module_name VARCHAR(17) NOT NULL DEFAULT '',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		parent_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		count_children SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY module_name (module_name(2))
	) CHARSET=utf8",

	"CREATE TABLE {comments_parents} (
		`id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT ,
		`element_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		`parent_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		`trash` ENUM( '0', '1' ) NOT NULL DEFAULT '0',
		PRIMARY KEY (`id`)
	) CHARSET=utf8",
	
	"CREATE TABLE {comments_param} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("`nameLANG` VARCHAR(250) NOT NULL DEFAULT '',")."
		type VARCHAR(20) NOT NULL DEFAULT '',
		module_name VARCHAR(17) NOT NULL DEFAULT '',
		sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
		required ENUM('0', '1') NOT NULL DEFAULT '0',
		show_in_list ENUM( '0', '1' ) NOT NULL,
		show_in_form_auth ENUM( '0', '1' ) NOT NULL,
		show_in_form_no_auth ENUM( '0', '1' ) NOT NULL,
		".multilang("`textLANG` text NOT NULL DEFAULT '',")."
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id)
	) CHARSET=utf8",
	
	"CREATE TABLE {comments_param_element} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		value text NOT NULL DEFAULT '',
		param_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY param_id (param_id),
		KEY value (value(5))
	) CHARSET=utf8",	
	
	"CREATE TABLE {comments_param_select} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		param_id int(11) unsigned NOT NULL default '0',
		".multilang("`nameLANG` VARCHAR(50) NOT NULL DEFAULT '',")."
		value VARCHAR(1) NOT NULL DEFAULT '',
		sort int(11) unsigned NOT NULL default '0',
		trash enum('0','1') NOT NULL default '0',
		PRIMARY KEY (id),
		KEY param_id (param_id)
	) CHARSET=utf8",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'captcha', '1')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'format_date', '5')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'user_name', '1')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'error_insert_message', 'Ваше сообщение уже имеется в базе.')",
	
	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'error_empty_fields', 'Не заполнены обязательные поля')",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('comments', 'error_insert_message', 'Your message is already in data base.', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'add_message', 'Спасибо! Ваш комментарий будет проверен в ближайшее время и появиться на сайте.')",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('comments', 'add_message', 'Thank you! Your comment will check in near time and will publish on this page.', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'count_level', '7')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'max_count', '50')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'use_bbcode', '1')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'sendmailadmin', '1')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'subject_admin', '%%title (%%url). Новый комментарий')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'message_admin', 'Здравствуйте, администратор сайта %%title (%%url)!<br>На странице %%urlpage появился новый комментарий:<br>%%message')",

	"INSERT INTO {comments_param} (".multilang("nameLANG,")." type, sort, required, show_in_list, show_in_form_no_auth) VALUES
(".multilang("'Имя',", "'Name',")." 'text', 1, '1', '1', '1')"
);

$adminsite = array( 12 =>
					array (
						'name' => 'Комментарии',
						'rewrite' => 'comments',
						'group_id' => '2',
						'text' => '<p>Комментарии оставляются пользователями на сайте и прикрепляются к продуктам магазина, к новостям, статьям, фотогалереям и пр. Все комментарии с сайта собираются в этом модуле в неактивном виде. Чтобы комментарий начал отображаться на сайте, его необходимо активировать.<br />
<a href="base_path/comments/config/">Настройки модуля &quot;Комментарии&quot;</a>.</p>
<p><a target="_blank" href="http://cms.diafan.ru/dokument/">Полная документация и помощь</a></p>',
						'numrow' => '255772',
						'sort' => '28',
						'act' => '1',
						'child' =>
						array (
							0 =>
							array (
								'name' => 'Комментарии',
								'rewrite' => 'comments',
								'group_id' => '2',
								'text' => '<p>Комментарии оставляются пользователями на сайте и прикрепляются к продуктам магазина, к новостям, статьям, фотогалереям и пр. Все комментарии с сайта собираются в этом модуле в неактивном виде. Чтобы комментарий начал отображаться на сайте, его необходимо активировать.<br />
<a href="base_path/comments/config/">Настройки модуля &quot;Комментарии&quot;</a>.</p>
<p><a target="_blank" href="http://cms.diafan.ru/dokument/">Полная документация и помощь</a></p>',
								'numrow' => '95',
								'sort' => '0',
								'act' => '1',
							),
							1 =>
							array (
								'name' => 'Конструктор формы',
								'rewrite' => 'comments/param',
								'group_id' => '2',
								'text' => '<p><a target="_blank" href="http://cms.diafan.ru/dokument/">Полная документация и помощь</a></p>',
								'numrow' => '234535',
								'sort' => '1',
								'act' => '1',
							),
							2 =>
							array (
								'name' => 'Настройки',
								'rewrite' => 'comments/config',
								'group_id' => '2',
								'text' => '<p><a target="_blank" href="http://cms.diafan.ru/dokument/">Полная документация и помощь</a></p>',
								'numrow' => '5631',
								'sort' => '2',
								'act' => '',
							),
						),
					)
);
	
$example = array();

if (! empty($_POST["photo"]))
{
	$sql[] = "INSERT INTO {config} (module_name, name, value) VALUES ('photo', 'comments', '1'), ('photo', 'comments_cat', '1')";

	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		3,
		'Лошадь просто супер. Сынишка в восторге. Спасибо!',
		'1',
		'".(time()-86400*5)."',
		'photo',
		'2',
		1
	)";
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		8,
		'Вау, какая изворотливая!',
		'1',
		'".time()."',
		'photo',
		'9',
		2
	);";
}

if (! empty($_POST["shop"]))
{
	$sql[] = "INSERT INTO {config} (module_name, name, value) VALUES ('shop', 'comments', '1'), ('shop', 'comments_cat', '1')";

	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		1,
		'Хороший коршун, я купил себе три на дачу.',
		'1',
		'".(time()-86400*6)."',
		'shop',
		'1',
		1
	)";
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		4,
		'Отличный пеликан. Купил и не нарадуюсь.',
		'1',
		'".(time()-86400*4)."',
		'shop',
		'3',
		2
	)";
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		5,
		'Очень хочется познакомиться с вашим создателем.',
		'1',
		'".(time()-86400*3)."',
		'shop',
		'30',
		1
	)";
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		6,
		'Красавец',
		'1',
		'".(time()-86400*2)."',
		'shop',
		'19',
		2
	)";
}

if (! empty($_POST["clauses"]))
{
	$sql[] = "INSERT INTO {config} (module_name, name, value) VALUES ('clauses', 'comments', '1'), ('clauses', 'comments_cat', '1')";

	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		7,
		'Отличная статья. Я в восторге. Автор.',
		'1',
		'".(time()-86400)."',
		'clauses',
		'1',
		1
	)";
}
if (! empty($_POST["news"]))
{
	$sql[] = "INSERT INTO {config} (module_name, name, value) VALUES ('news', 'comments', '1'), ('news', 'comments_cat', '1')";
}
if (! empty($_POST["files"]))
{
	$sql[] = "INSERT INTO {config} (module_name, name, value) VALUES ('files', 'comments', '1'), ('files', 'comments_cat', '1')";
}
if (! empty($_POST["faq"]))
{
	$sql[] = "INSERT INTO {config} (module_name, name, value) VALUES ('faq', 'comments', '1'), ('faq', 'comments_cat', '1')";
}

/**
 * Деинсталлирует модуль
 * 
 * @return void
 */
function module_basic_uninstall_comments()
{
	$module = 'comments';
	DB::query("DELETE FROM {config} WHERE name='".$module."';");
	DB::query("DELETE FROM {config} WHERE name='".$module."_cat';");
}
