<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Language_admin_list
 *
 * Редактирование списка языковых версий сайта
 */
class Language_admin_list extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'languagelist';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'language';

	/**
	 * @var array список полей в таблицах базы данных, подлежащих переводу
	 */
	protected $array_language = array();

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'main'=>
				array (
				  'name' => 'text',
				  'shortname' => 'text',
				)
		);		
		
		$this->config_module = array(
			'del'	=> 1	//удалить
		);
		
		$this->array_language = array(
			'banners' => array('alt', 'title', 'act'),
			'site' => array('name', 'title', 'text', 'keywords', 'descr', 'title_meta', 'act'),
			'clauses' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'clauses_category' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'comments_param' => array('name', 'text'),
			'comments_param_select' => array('name'),
			'faq' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'faq_category' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'feedback_param' => array('name', 'text'),
			'feedback_param_select' => array('name'),
			'files' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'files_category' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'images' => array('alt', 'title'),
			'menu' => array('name', 'act'),
			'menu_category' => array('name', 'act'),
			'news' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'news_category' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'photo' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'photo_category' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'shop' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'shop_additional_cost' => array('name', 'act', 'text'),
			'shop_category' => array('name', 'act', 'keywords', 'descr', 'title_meta', 'anons', 'text'),
			'shop_delivery' => array('name', 'act', 'text'),
			'shop_order_param' => array('name', 'text'),
			'shop_order_param_select' => array('name'),
			'shop_param' => array('name', 'text', 'measure_unit'),
			'shop_param_element' => array('value'),
			'shop_param_select' => array('name'),
			'shop_payment' => array('name', 'act', 'text'),
			'subscribtion' => array('name', 'text'),
			'subscribtion_category' => array('name', 'text'),
			'tags' => array('act'),
			'tags_name' => array('name'),
			'users_param' => array('name', 'text'),
			'users_param_select' => array('name'),
			'votes' => array('name'),
			'votes_category' => array('name', 'act')
		);
	}

	/**
	 * Выводит контент модуля
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_LANGUAGE_ADD);
		
		$this->list_row();	
		

		return true;
	}

	/**
	 * Редактирование поля "Сокращенное название языка на латинице"
	 * 
	 * @return boolean true
	 */
	protected function edit_shortname_module()
	{
		echo '
		<tr>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>
				<input type="text" name="'. $this->key.'" size="40" value="'
				.($this->diafan->edit == 1
				 ?  LANGUAGE_BASE.'" disabled'
				 : (! $this->diafan->addnew ? str_replace('"', '&quot;', $this->value):'').'"'
				).'>
				'.$this->show_help_row().'
			</td>
		</tr>
		<tr>
			<td></td>
			<td align="left">
				<a href="'.BASE_PATH_HREF.'language/site'.$this->diafan->edit.'/">'._ADMIN_LANGUAGE_EDIT_FILE.'</a>
			</td>
		</tr>';

		return true;
	}

	/**
	 * Сохранение поля "Сокращенное название языка на латинице"
	 * 
	 * @return boolean
	 */
	protected function save_shortname_module()
	{
		if ($this->diafan->save == 1)
		{
			$this->query[] = "shortname='%s'";		
			$this->value[] = '';
			return false;
		}
		$shortname = (! empty($_POST["shortname"]) ? $_POST["shortname"] : $_POST["name"]);
		$shortname = substr($this->diafan->translit($shortname), 0, 3);
		
		$this->query[] = "shortname='%s'";		
		$this->value[] = $shortname;
		return true;
	}

	/**
	 * Добавление языкового интерфейса (вместо основной функции)
	 * 
	 * @return boolean
	 */
	public function new_module()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->diafan->redirect(URL);
			return false;
		}

		DB::query("INSERT INTO {".$this->table."} () VALUES ()");
		$this->diafan->save = DB::last_id($this->table);

		if (! $this->diafan->save)
		{
			echo '<script language="javascript" type="text/javascript">alert(\''
			.sprintf(_ADMIN_ERROR_INSERT_INTO, DB_PREFIX.$this->table)
			.'\');history.go(-1);</script>';
			return;
		}

		foreach ($this->array_language as $tab => $filds)
		{
			$creattable = DB::fetch_array(DB::query("SHOW CREATE TABLE {".$tab."}"));

			if ($creattable)
			{
				foreach ($filds as $f)
				{
					if (preg_match("/".$f."` ([^\n]+),\n/", $creattable['Create Table'], $ob))
					{
						DB::query("ALTER TABLE {".$tab."} ADD `".$f.$this->diafan->save."`".$ob[1]." AFTER `".$f."`");
					}
				}
			}
		}

		DB::query("UPDATE {site} set act".$this->diafan->save."='1' WHERE id=1");

		$this->save_module();
		return true;
	}

	/**
	 * Удаление языкового интерфейса (вместо основной функции)
	 * 
	 * @return boolean
	 */
	public function del_module()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->diafan->redirect(URL);
			return false;
		}

		if ($this->diafan->admin_roles('del'))
		{
			$this->diafan->redirect(URL);
			return false;
		}

		if (! empty($_POST["id"]))
		{
			$ids = array($_POST["id"]);
		}
		else
		{
			$ids = $_POST["ids"];
		}
		foreach ($ids as $id)
		{
			$id = intval($id);
			if ($id == 1 || ! $id)
			{
				continue;
			}

			foreach ($this->array_language as $tab => $filds)
			{
				$creattable = DB::fetch_array(DB::query("SHOW CREATE TABLE {".$tab."}"));
				
				if ($creattable)
				{
					foreach ($filds as $f)
					{
						if (preg_match('/'.$f.'` ([^,]+),/', $creattable['Create Table'], $ob))
						{
							DB::query("ALTER TABLE {".$tab."} DROP `".$f.$id."`");
						}
					}
				}
			}

			DB::query("DELETE FROM {".$this->table."} WHERE id=%d", $id);
		}

		include_once ABSOLUTE_PATH.'plugins/json.php';
		$result["redirect"] = BASE_PATH.'language/';
		echo to_json($result);

		return true;
	}
}