<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Language_inc
 *
 * Подключение модуля "Языки сайта"
 */
class Language_inc extends Model
{
	/**
	 * @var array подключенные языковые файлы модулей
	 */
	private $modules;

	/**
	 * Отдает значение языковой константы
	 *
	 * @param string $name название константы
	 * @param string $module_name модуль
	 * @param boolean $useradmin выдавать форму для редактирования
	 * @param integer|string $lang_id номер языка
	 * @return string
	 */
	public function get($name, $module_name, $useradmin = true, $lang_id = '')
	{
		if (! $name)
		{
			return '';
		}

		$name=strtoupper($name);

		if ($useradmin)
		{
			$text = $this->diafan->_useradmin->get_lang($name);
		}
		else
		{
			$text = defined('_LANG_'.$name) ? constant('_LANG_'.$name) : '';
		}
		return $text;
	}
}