<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Menu_admin_ajax
 * 
 * Обработка Ajax-запросов при работе с меню в административной части
 */
class Menu_admin_ajax
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array результаты, передаваемы Ajaxом
	 */
	private $result;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($frame)
	{
		$this->diafan = $frame->diafan;

		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->result["error"] = 'ERROR';
			$this->send_json();
		}

		$this->result["hash"] = $this->diafan->_user->get_hash();

		if (! empty($_POST["action"]))
		{
			switch($_POST["action"])
			{
				case 'list_site_id':
					$this->list_site_id();
					break;

				case 'list_module':
					$this->list_module();
					break;

				case 'group_menu':
					$this->group_menu();
					break;
			}
		}
	}

	/**
	 * Подгружает список модулей
	 * 
	 * @return void
	 */
	private function list_site_id()
	{
		if (! $_POST["parent_id"])
		{
			$list = '<div class="menu_list menu_list_first"><h2>'._ADMIN_SITE.'</h2>';
		}
		else
		{
			$list = '<div class="menu_list">';
		}
		
		$result = DB::query("SELECT id, [name], addmodule, count_children FROM {site} WHERE [act]='1' AND trash='0' AND parent_id='%d' AND block='0' ORDER BY sort ASC", $_POST["parent_id"]);
		while ($row = DB::fetch_array($result))
		{
			$list .= '<p site_id="'.$row["id"].'" module_name="site" element_id="" cat_id="">';
			if ($row["count_children"])
			{
				$list .= '<a href="#" class="plus menu_plus">+</a>';
			}
			else
			{
				$list .= '&nbsp;&nbsp;';
			}
			$list .= '&nbsp;<a href="'.BASE_PATH_HREF.'site/edit'.$row["id"].'/" class="menu_select">'.$row["name"].'</a>';
			if ($row["addmodule"] && file_exists(ABSOLUTE_PATH.'modules/'.$row["addmodule"].'/admin/'.$row["addmodule"].'.admin.menu.php'))
			{
				Customization::inc('modules/'.$row["addmodule"].'/admin/'.$row["addmodule"].'.admin.menu.php');
				eval('$count = '.ucfirst($row["addmodule"]).'_admin_menu::count($this, '.$row["id"].');');
				if ($count)
				{
					$list .= ' <a href="#" class="menu_select_module plus" module_name="'.$row["addmodule"].'">m</a>';
				}
			}
			$list .= '</p>';
		}
		$list .= '</div>';

		$this->result["data"] = $list;

		$this->send_json();
	}

	/**
	 * 
	 * 
	 * @return void
	 */
	private function list_module()
	{
		if (empty($_POST["module_name"]) || empty($_POST["site_id"]))
		{
			$this->result["error"] = 'ERROR';
			$this->send_json();
		}
		$module_name = $this->diafan->get_param($_POST, "module_name", "", 1);
		$parent_id   = (int)$this->diafan->get_param($_POST, "parent_id", "", 2);
		$site_id     = (int)$this->diafan->get_param($_POST, "site_id", "", 2);

		$list = '';
		if (! $parent_id)
		{
			$constant = '_LANG_'.strtoupper($module_name);
			if (defined($constant))
			{
				$list .= '<h2>'.constant($constant).'</h2>';
			}
		}
		else
		{
			$list = '<div class="menu_list">';
		}

		if (file_exists(ABSOLUTE_PATH.'modules/'.$module_name.'/admin/'.$module_name.'.admin.menu.php'))
		{
			Customization::inc('modules/'.$module_name.'/admin/'.$module_name.'.admin.menu.php');
			eval('$rows = '.ucfirst($module_name).'_admin_menu::list_($this, \''.$site_id."', '".$parent_id."');");
			foreach ($rows as $row)
			{
				if (! empty($row["hr"]))
				{
					$list .= '<p><hr></p>';
					continue;
				}
				$list .= '<p site_id="'.$site_id.'" module_name="'.$module_name.'" cat_id="'.$row["cat_id"].'" element_id="'.$row["element_id"].'">';
				if ($row["count"])
				{
					$list .= '<a href="#" class="plus menu_plus">+</a>';
				}
				else
				{
					$list .= '&nbsp;&nbsp;';
				}
				if ($row["element_id"])
				{
					$list .= '&nbsp;<a href="'.BASE_PATH_HREF.$module_name.'/edit'.$row["element_id"].'/" class="menu_select">'.$row["name"].'</a>';
				}
				else
				{
					$list .= '&nbsp;<a href="'.BASE_PATH_HREF.$module_name.'/category/edit'.$row["cat_id"].'/" class="menu_select">'.$row["name"].'</a>';
				}
				$list .= '</p>';
			}
		}
		if ($parent_id)
		{
			$list .= '</div>';
		}

		$this->result["data"] = $list;
		$this->send_json();
	}

	/**
	 * Сохраняет ссылки на элементы в меню при групповом выделение в списке
	 * 
	 * @return void
	 */
	private function group_menu()
	{
		Customization::inc('modules/menu/admin/menu.admin.save.php');

		$_POST['ids'] = array_reverse($_POST['ids']);
		foreach($_POST['ids'] as $id)
		{
			$row = DB::fetch_array(DB::query("SELECT * FROM {%h} WHERE id=%d", $_POST["table"], $id));
			if(! $row)
				continue;

			$module = str_replace('_category', '', $_POST["table"]);
			$save = array(
				"id" => $row["id"],
				"module" => $module, 
				"is_category" => strstr($_POST["table"], '_category'),
				"site_id" => ! empty($row["site_id"]) ? $row["site_id"] : 0,
				"is_new" => false,
				"parent_id" => ! empty($row["parent_id"]) ? $row["parent_id"] : '',
				"name" => $row["name"._LANG],
				"old_name" => $row["name"._LANG],
				"access" => $row["access"],
				"old_access" => $row["access"],
				"sort" => ! empty($row["sort"]) ? $row["sort"] : 0,
				"act" => $row["act"._LANG],
				"cat_id" => ! empty($row["cat_id"]) ? $row["cat_id"] : 0
			);
			$menu_cat_ids = ! empty($_POST["menu_cat_ids"]) ? $_POST["menu_cat_ids"] : array();

			Menu_admin_save::save_menu($save, $menu_cat_ids, $this->diafan->language_all);
		}

		$this->result["redirect"] = URL;
		$this->send_json();
	}

	/**
	 * Отправляет результат
	 *
	 * @return boolean
	 */
	private function send_json()
	{
		if (! empty($this->result["errors"]) || ! empty($this->result["data"]) || ! empty($this->result["redirect"]))
		{
			include_once ABSOLUTE_PATH.'plugins/json.php';
			echo to_json($this->result);
			return true;
		}
		return false;
	}
}