<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Menu_admin_save
 * 
 * Сохранение полей, связанных с работой модуля "Меню"
 */
class Menu_admin_save
{
	/**
	 * Сохранение поля "Показывать в меню"
	 * 
	 * @return boolean true
	 */
	public static function save(&$th)
	{
		if (! $th->site_id)
		{
			$th->get_site_id();
		}
		$save = array(
			"id" => $th->diafan->save,
			"module" => $th->diafan->module, 
			"is_category" => $th->config_module["category"], 
			"site_id" => $th->site_id,
			"is_new" => $th->diafan->savenew,
			"parent_id" => ! empty($_POST["parent_id"]) ? $_POST["parent_id"] : '',
			"name" => $_POST["name"],
			"old_name" => ! empty($th->oldrow['name'._LANG]) ? $th->oldrow['name'._LANG] : $_POST["name"],
			"access" => ! empty($_POST["access"]) ? 1 : 0,
			"old_access" => isset($th->oldrow["access"]) ? $th->oldrow["access"] : (empty($_POST["access"]) ? 1 : 0),
			"sort" => $th->sort,
			"act" => ! empty($_POST["act"]) ? 1 : 0,
			"cat_id" => ! empty($_POST["cat_id"]) ? $_POST["cat_id"] : 0
		);
		$menu_cat_ids = ! empty($_POST["menu_cat_ids"]) && empty($_POST["block"]) ? $_POST["menu_cat_ids"] : array();
		self::save_menu($save, $menu_cat_ids, $th->diafan->language_all);
	}

	/**
	 * Сохранение пункта в меню
	 * 
	 * @param array $save данные об элементе
	 * @param array $menu_cat_ids категории меню, в которых нужно отображить пункт
	 * @param array $languages данные о языках сайта
	 * @return boolean true
	 */
	public static function save_menu($save, $menu_cat_ids, $languages)
	{
		global $diafan;
		$edit_menu = false;
		if ($save["module"] == 'site')
		{
			$name_menu = 'site_id';
		}
		else
		{
			if ($save["is_category"])
			{
				$name_menu = 'module_cat_id';
			}
			else
			{
				$name_menu = 'element_id';
			}
		}

		$show_in_menu = array();
		if (! $save["is_new"])
		{
			$result = DB::query("SELECT cat_id FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND trash='0'", $save["module"], $save["id"]);
			while ($row = DB::fetch_array($result))
			{
				$show_in_menu[] = $row["cat_id"];
			}

		}
		if (! $menu_cat_ids)
		{
			if ($show_in_menu)
			{
				foreach ($show_in_menu as $menu_cat_id)
				{
					$edit_menu = true;
					$id = DB::query_result("SELECT id FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND cat_id=%d AND trash='0'", $save["module"], $save["id"], $menu_cat_id);
					$children = $diafan->get_children($id, "menu");
					$children[] = $id;
					DB::query("DELETE FROM {menu_parents} WHERE parent_id IN (%s)", implode(',', $children));
					DB::query("DELETE FROM {menu_parents} WHERE element_id IN (%s)", implode(',', $children));
					DB::query("DELETE FROM {menu} WHERE id IN (%s)", implode(',', $children));

					if($row["module"] == 'site')
					{
						DB::query("UPDATE {site} SET is_menu='0' WHERE id=%d",$save["id"]);
					}

					// пересчитываем поле count_children
					$result = DB::query("SELECT id FROM {menu} WHERE cat_id=%d AND trash='0'", $menu_cat_id); 
					while ($row = DB::fetch_array($result))
					{
						$count = DB::query_result("SELECT COUNT(*) FROM  {menu_parents} WHERE parent_id=%d AND trash='0'", $row["id"]);
						DB::query("UPDATE {menu} SET count_children=%d WHERE id=%d", $count, $row["id"]);
					}
				}
			}
		}
		else
		{
			foreach ($menu_cat_ids as $menu_cat_id)
			{
				if (! in_array($menu_cat_id, $show_in_menu))
				{
					$edit_menu = true;
					$parent_id = 0;
					if ($save["parent_id"])
					{
						$parent_id = DB::query_result("SELECT id FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND cat_id=%d AND trash='0'", $save["module"], $save["parent_id"], $menu_cat_id);
					}
					if ($save["module"] == 'site')
					{
						DB::query("INSERT INTO {menu} ([name], module_name, site_id, cat_id, parent_id, access, sort, [act])"
								  ." VALUES ('%h', 'site', %d, %d, %d, '%d', %d, '%d')",
								  $save["name"],
								  $save["id"],
								  $menu_cat_id,
								  $parent_id,
								  $save["access"],
								  $save["sort"],
								  $save["act"] || $save["id"] == 1 ? 1 : 0
								);
						DB::query("UPDATE {site} SET is_menu='1' WHERE id=%d", $save["id"]);
					}
					else
					{
						if (! $save["parent_id"] && $save["cat_id"])
						{
							$parent_id = DB::query_result("SELECT id FROM {menu} WHERE module_name='%h' AND module_cat_id=%d AND cat_id=%d AND trash='0'", $save["module"], $save["cat_id"], $menu_cat_id);
						}
						if (! $parent_id && $save["site_id"])
						{
							$parent_id = DB::query_result("SELECT id FROM {menu} WHERE module_name='site' AND site_id=%d AND cat_id=%d AND trash='0'", $save["site_id"], $menu_cat_id);
						}
						DB::query("INSERT INTO {menu} ([name], module_name, site_id, ".$name_menu.", cat_id, parent_id, access, sort, [act])"
								  ." VALUES ('%h', '%h', %d, %d, %d, %d, '%d', %d, '%d')",
								  $save["name"],
								  $save["module"],
								  $save["site_id"],
								  $save["id"],
								  $menu_cat_id,
								  $parent_id,
								  $save["access"],
								  $save["sort"],
								  $save["act"]
								  );
						//DB::query("UPDATE {site} SET is_menu='1' WHERE id=%d", $save["site_id"]);
					}
					$new_menu_id = DB::last_id("menu");
					$table = $save["module"];
					if ($save["is_category"])
					{
						$table .= '_category';
					}
					foreach ($languages as $lang)
					{
						if ($lang[0] != _LANG)
						{
							$element = DB::fetch_array(DB::query("SELECT name".$lang[0]." AS name, act".$lang[0]." AS act FROM {%h} WHERE id=%d", $table, $save["id"]));
							DB::query("UPDATE {menu} SET act".$lang[0]."='%d', name".$lang[0]."='%h' WHERE id=%d", $element["act"], $element["name"], $new_menu_id);
						}
					}
					if ($parent_id)
					{
						$parents = $diafan->get_parents($parent_id, "menu");
						$parents[] = $parent_id;
						foreach ($parents as $parent_id)
						{
							DB::query("INSERT INTO {menu_parents} (element_id, parent_id) VALUES (%d, %d)", $new_menu_id, $parent_id);
						}
						DB::query("UPDATE {menu} SET count_children=count_children+1 WHERE id IN (%s)", implode(',', $parents));
					}
					if (! $save["sort"])
					{
						DB::query("UPDATE {menu} SET sort=id WHERE id=%d", $new_menu_id);
					}
				}
			}
			foreach ($show_in_menu as $menu_cat_id)
			{
				if (! in_array($menu_cat_id, $menu_cat_ids))
				{
					$edit_menu = true;
					$id = DB::query_result("SELECT id FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND cat_id=%d AND trash='0'", $save["module"], $save["id"], $menu_cat_id);
					$children = $diafan->get_children($id, "menu");
					$children[] = $id;
					DB::query("DELETE FROM {menu_parents} WHERE parent_id IN (%s)", implode(',', $children));
					DB::query("DELETE FROM {menu_parents} WHERE element_id IN (%s)", implode(',', $children));
					DB::query("DELETE FROM {menu} WHERE id IN (%s)", implode(',', $children));

					// пересчитываем поле count_children
					$result = DB::query("SELECT id FROM {menu} WHERE cat_id=%d AND trash='0'", $menu_cat_id); 
					while ($row = DB::fetch_array($result))
					{
						$count = DB::query_result("SELECT COUNT(*) FROM  {menu_parents} WHERE parent_id=%d", $row["id"]);
						DB::query("UPDATE {menu} SET count_children=%d WHERE id=%d", $count, $row["id"]);
					}
				}
				else
				{
					// если изменилось имя (совпадает старое имя) или доступ для элемента/категории,
					// то делаем соответствующие изменения пункта меню
					$result = DB::query("SELECT id, [name] FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND cat_id=%d AND trash='0'", $save["module"], $save["id"], $menu_cat_id);
					while ($row = DB::fetch_array($result))
					{
						if ($row["name"] == $save['old_name'] && $save["name"] != $save["old_name"])
						{
							$edit_menu = true;
							DB::query("UPDATE {menu} SET [name]='%h' WHERE id=%d", $save["name"], $row["id"]);
						}
						if ($save["access"] && ! $save["old_access"] || ! $save["access"] && $save["old_access"])
						{
							$edit_menu = true;
							DB::query("UPDATE {menu} SET access='%d' WHERE id=%d", $save["access"], $row["id"]);
						}
					}
				}
			}

		}
		if($edit_menu)
		{
			$diafan->_cache->delete("", "menu");
		}
		return $edit_menu;
	}
}