<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * News
 *
 * Контроллер модуля "Новости"
 */
class News extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$this->rewrite_variable_names = array('page', 'show', 'cat', 'year', 'month', 'day');
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;
		
		$model = new News_model($this->diafan);
		
		if ($this->diafan->show)
		{
			$this->result = $model->id();
		}
		elseif (! $this->diafan->configmodules("cat") || $this->diafan->year || $this->diafan->month)
		{
			$this->result = $model->list_();
		}
		elseif (! $this->diafan->cat)
		{
			$this->result = $model->first_page();
		}
		else
		{
			$this->result = $model->list_category();
		}
		$this->get_global_variables();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->diafan->_tpl->get($this->view, 'news', $this->result);

		return true;
	}

	/**
	 * Шаблонная функция: блок новостей
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'cat_id', 'images', 'site_id', 'template');
		
		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);
		$images   = intval($attributes["images"]);

		Customization::inc('modules/news/news.model.php');
		$model = new News_model($this->diafan);
		$result = $model->show_block($count, $cat_id, $images, $site_id);

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'news', $result))
		{
			$this->diafan->_tpl->get('show_block', 'news', $result);
		}
		return true;
	}

	/**
	 * Шаблонная функция: календарь архива новостей
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_calendar($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'only_news', 'site_id', 'cat_id', 'template', 'detail');

		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);
		$only_news = $attributes["only_news"] ? true : false;
		$detail = $attributes["detail"];
		$template = $attributes["template"];

		Customization::inc('modules/news/news.model.php');
		$model  = new News_model($this->diafan);
		$result = $model->show_calendar($only_news, $detail, $site_id, $cat_id, $template);
		if (! $result)
		{
			return false;
		}

		if (! $attributes["template"] || ! $text = $this->diafan->_tpl->get('show_calendar_'.($detail == "day" ? '_day' : '').$attributes["template"], 'news', $result))
		{
			$text = $this->diafan->_tpl->get('show_calendar'.($detail == "day" ? '_day' : ''), 'news', $result);
		}
		if($detail == "day")
		{
			echo $text;
		}
		return true;	
	}
}