<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Photo_admin_config
 *
 * Конфигурация фотогалереи
 */
class Photo_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'photo_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->variable_table = array(
			'config'=>
			array (
			'nastr' => 'numtext',
			'page_show' => 'checkbox',
			'hr1' => 'hr',
			'cat' => 'checkbox',
			'count_list' => 'numtext',
			'childrens_elements' => 'checkbox',
			'hr2' => 'hr',
			'big_width' => 'function',
			'big_height' => 'none',
			'big_quality' => 'none',
			'medium_width' => 'function',
			'medium_height' => 'none',
			'medium_quality' => 'none',
			'watermark_photo' => 'function',
			'use_animation' => 'checkbox',
			'hr3' => 'hr',
			'comments' => 'module',
			'tags' => 'module',
			'rating' => 'module',
			'upload_max_filesize' => 'function',
			'themes' => 'function',
			'theme_list' => 'none',
			'view_list' => 'none',
			'theme_first_page' => 'none',
			'view_first_page' => 'none',
			'theme_id' => 'none',
			'view_id' => 'none',
			)
		);

		$this->config_module = array(
			'element_site' => 1, //делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
			'config'       => 1  //файл настроек модуля
		);
		
		$this->show_tr_click_checkbox['watermark'] = array(
				'watermark_only_big',
				'watermark_path',
				'watermark_placement'
			);

		$this->show_tr_click_checkbox = array(
			'cat' => array(
				'count_list',
				'childrens_elements'
			)
		);
	}

	protected function edit_watermark_photo_module_config()
	{
		echo '<script type="text/javascript" src="' . BASE_PATH . 'modules/photo/admin/photo.admin.config.js"></script>';
		$fileds = array('watermark', 'watermark_only_big', 'watermark_path', 'watermark_placement', 'resize');
		
		foreach ($fileds as $filed)
		{
			if (empty($this->values[$filed]))
			{
				$this->values[$filed] = $this->diafan->configmodules($filed);
			}
		}
		
		$this->show_tr_click_checkbox['watermark'] = array(
				'watermark_only_big',
				'watermark_path',
				'watermark_placement'
			);
		
		echo '
		<tr id="watermark">
			<td class="td_first">'.$this->variable_names("watermark").'</td>
			<td>
				<input type="checkbox" name="watermark" value="1"'.($this->values["watermark"] == 1 ? " checked" : '').$this->show_tr_click_checkbox("watermark").'>
				'.$this->show_help_row("watermark").'
			</td>
		</tr>';
		Customization::inc('modules/images/admin/images.admin.view.php');
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/images/admin/images.admin.js"></script>

		<tr valign="top" id="watermark_path">
			<td class="td_first">'.$this->variable_names("watermark_path").'</td>
			<td>
				<input type="file" name="watermark" size="40">
				<input type="button" value="'._ADMIN_IMAGE_UPLOAD.'" class="watermark_upload"> '.$this->show_help_row("watermark_path").'
				<div class="images_container">'.Images_admin_view::show_watermark($this).'</div>
				<div class="errors error_watermark"></div>
			</td>
		</tr>';
		if (! $this->values["watermark_placement"])
		{
			$this->values["watermark_placement"] = 'bottom=5,right=5';
		}
		list($vertical,  $horizontal) = explode(',', $this->values["watermark_placement"], 2); 
		list($vertical,  $sy)         = explode('=', trim($vertical), 2); 
		list($horizontal, $sx)        = explode('=', trim($horizontal), 2);

		echo '
		<tr id="watermark_placement">
			<td class="td_first">'.$this->variable_names("watermark_placement").'</td>
			<td>
				<select name="watermark_placement_vertical">
					<option value="middle"'.($vertical == 'middle' ? ' selected' : '').'>'._ADMIN_WATERMARK_PLACEMENT_MIDDLE_CONFIG.'</option>
					<option value="bottom"'.($vertical == 'bottom' ? ' selected' : '').'>'._ADMIN_WATERMARK_PLACEMENT_BOTTOM_CONFIG.'</option>
				</select>
				<input type="text" name="watermark_placement_vertical_px" size="3" value="'.$sy.'" class="inpnum"> px
				<select name="watermark_placement_horizontal">
					<option value="center"'.($horizontal == 'cetner' ? ' selected' : '').'>'._ADMIN_WATERMARK_PLACEMENT_CENTER_CONFIG.'</option>
					<option value="right"'.($horizontal == 'right' ? ' selected' : '').'>'._ADMIN_WATERMARK_PLACEMENT_RIGHT_CONFIG.'</option>
				</select>
				<input type="text" name="watermark_placement_horizontal_px" size="3" value="'.$sx.'" class="inpnum"> px
				&nbsp;&nbsp;&nbsp;
				'.$this->show_help_row("watermark_placement").'
			</td>
		</tr>
		<tr id="watermark_only_big">
			<td class="td_first">'.$this->variable_names("watermark_only_big").'</td>
			<td>
				<input type="checkbox" name="watermark_only_big" value="1"'.($this->values["watermark_only_big"] == 1 ? " checked" : '').'>
				'.$this->show_help_row("watermark_only_big").'
			</td>
		</tr>
		<tr id="resize" valign="top">
			<td class="td_first">'.$this->variable_names("resize").'</td>
			<td>
				<input type="button" name="resize" confirm="'._ADMIN_RESIZE_CONFIG_CONFIRM.'" value="'._ADMIN_APPLY.'">
				'.$this->show_help_row("resize").'
				<div class="errors loading-resize"><img src="'.BASE_PATH.'adm/img/loading.gif"></div>
				<div class="errors error_resize"></div>
			</td>
		</tr>';
		return true;
	}
	
	protected function save_watermark_photo_module_config()
	{
	    $fileds = array('watermark', 'watermark_only_big');
	    foreach ($fileds as $filed)
	    {
		$this->query[] = $filed."='%d'";
		$this->value[] = !empty($_POST[$filed]) ? $_POST[$filed] : '';
	    }
	    $this->query[] = "watermark_path='%h'";
	    $this->value[] = $this->diafan->configmodules("watermark_path");
	    $this->query[] = "watermark_placement='%h'";
		$this->value[] = (in_array($_POST["watermark_placement_vertical"], array('bottom', 'middle')) ? $_POST["watermark_placement_vertical"] : 'middle')
		.'='.intval($_POST["watermark_placement_vertical_px"]).','
		.(in_array($_POST["watermark_placement_horizontal"], array('right', 'center')) ? $_POST["watermark_placement_horizontal"] : 'center')
		.'='.intval($_POST["watermark_placement_horizontal_px"]);

	    return true;
	}
	
	/**
	 * Редактирование поля "Размер большого изображения" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	protected function edit_big_width_module_config()
	{
		echo '
		<tr id="big">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="text" name="'.$this->key.'" size="3" value="'.$this->value.'" class="inpnum"> x
				<input type="text" name="big_height" size="3" value="'.$this->values["big_height"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="big_quality" size="2" value="'.$this->values["big_quality"].'" class="inpnum">'
				.$this->show_help_row().'
			</td>
		</tr>';
		return true;
	}

	/**
	 * Редактирование поля "Размер маленького изображения" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	protected function edit_medium_width_module_config()
	{
		echo '
		<tr id="medium">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="text" name="'.$this->key.'" size="3" value="'.$this->value.'" class="inpnum"> x
				<input type="text" name="medium_height" size="3" value="'.$this->values["medium_height"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="medium_quality" size="2" value="'.$this->values["medium_quality"].'" class="inpnum">'
				.$this->show_help_row().'
			</td>
		</tr>';
		return true;
	}
}