<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Search_model
 *
 * Модель модуля "Поиск по сайту"
 */
class Search_model extends Model
{
	/**
	 * @var integer количество элементов, показанных на странице
	 */
	private $nastr = 10;

	/**
	 * @var boolean искать все слова сразу (по умолчанию ищет хотя бы одно слово)
	 */
	private $search_all_word = false;

	/**
	 * Генерирует список найденных страниц
	 * 
	 * @return array
	 */
    public function show_module()
    {
	   $search = '';
	   if (isset($_GET["searchword"]))
	   {
		  if (is_array($_GET["searchword"]))
		  {
			 $_GET["searchword"] = '';
		  }
		  $search = trim(htmlspecialchars(stripslashes($_GET["searchword"])));
	   }
	   $this->result = array();

	   if (! empty($search))
	   {
			$search_words = $this->diafan->_search->prepare($search);
          
			$lang = _LANG ? _LANG : 1;
			
			$keys = array();
			$result = DB::query("SELECT id FROM {search_keywords} WHERE keyword IN ('".implode("', '", $search_words)."')");
			while ($row = DB::fetch_array($result))
			{
				$keys[] = $row["id"];
			}
			if($this->search_all_word)
			{
				// обязательны все слова
				$where = "";
				foreach($keys as $k => $key)
				{
					$where .= " INNER JOIN {search_index} AS i".$k." ON r.id=i".$k.".result_id AND i".$k.".keyword_id=".$key;
				}
			}
			else
			{
				// ищет хотя бы одно слово, сортировка по количеству найденных
				$where = "INNER JOIN {search_index} AS i ON r.id=i.result_id AND i.keyword_id IN ('".implode("', '", $keys)."')";
			}

			$nen = DB::query_result("SELECT COUNT(DISTINCT r.id) FROM {search_results} as r ".$where." WHERE r.lang_id=%d", $lang);

			////navigation//
			if ($this->nastr)
			{
				$this->diafan->_paginator->nastr = $this->nastr;
			}
			$this->diafan->_paginator->page    = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->get_nav = '?searchword='.$search;
			$this->diafan->_paginator->nen     = $nen;
			$links = $this->diafan->_paginator->get();
			////navigation///
		  
			$k = ! $this->diafan->page ? 1 : ($this->diafan->page - 1) * $this->diafan->_paginator->nastr + 1;

			$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $links);

			$result = DB::query_range("
				SELECT r.name, r.url as link, r.snippet, COUNT(r.id) as c FROM {search_results} as r ".$where."
				WHERE r.lang_id=%d GROUP BY r.id".(! $this->search_all_word ? " ORDER BY c DESC" : ""),
				$lang, $this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);
		  
		  
			while ($row = DB::fetch_array($result))
			{
				//$row["name"] = $this->diafan->short_text($row["name"], 20);
				$row["link"] = BASE_PATH_HREF.$row["link"];

				$this->result["rows"][] = $row;
			}

			$this->result["count"] = $this->diafan->_paginator->nen;
			$this->result["count-page"] = $this->diafan->_paginator->nen > $this->diafan->_paginator->nastr ? 
			                                    $this->diafan->_paginator->nastr : $this->diafan->_paginator->nen;
		}
		$this->result["value"] = $search;
		$this->result["button"] = _LANG_SEARCH;
		$this->result["action"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->cid);

		return $this->result;
    }

	/**
	 * Генерирует контент для шаблонной функции: форма поиска по сайту
	 * 
	 * @return array
	 */
	function show_search($button)
	{			
		$result["value"] = '';
		if (isset($_GET["searchword"]))
		{
			if (is_array($_GET["searchword"]))
			{
				$_GET["searchword"] = '';
			}
			$result["value"] = trim(htmlspecialchars(stripslashes($_GET["searchword"])));
		}
		$result["action"] = BASE_PATH_HREF.$this->diafan->_route->module('search',TRUE);
		$result["button"] = $button;
		return $result;
	}
}
