<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Shop_admin_ajax
 * 
 * Обработка Ajax-запросов в административной части модуля Магазин
 */
class Shop_admin_ajax extends Theme_admin
{

    /**
     * @var object основной объект системы
     */
    public $diafan;

    /**
     * @var array результаты, передаваемы Ajaxом
     */
    private $result;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($frame)
    {
        $this->diafan = $frame->diafan;

        // Прошел ли пользователь проверку идентификационного хэша
        if ($_POST["action"] != "show_rel_goods")
        {
            if ( ! $this->diafan->_user->checked)
            {
                $this->result["error"] = 'ERROR_HASH';
                $this->send_json();
            }
        }
        $this->result["hash"] = $this->diafan->_user->get_hash();

        if ( ! empty($_POST["action"]))
        {
            switch ($_POST["action"])
            {
                case 'up_param':
                case 'down_param':
                    $this->sort_param();
                    break;
                case 'delete_param':
                    $this->delete_param();
                    break;
                case 'rel_goods':
                    $this->rel_goods();
                    break;
                case 'show_rel_goods':
                    $this->show_rel_goods();
                    break;
                case 'delete_rel_good':
                    $this->delete_rel_good();
                    break;
                case 'show_discount_goods':
                    $this->show_discount_goods();
                    break;
                case 'discount_good':
                    $this->discount_good();
                    break;
                case 'delete_discount_good':
                    $this->delete_discount_good();
                    break;
                case 'clone_good':
                    $this->clone_good();
                    break;
                case 'show_order_goods':
                    $this->show_order_goods();
                    break;
                case 'add_order_good':
                    $this->add_order_good();
                    break;
            }
        }
    }

    /**
     * Сортирует значения списка параметров
     * 
     * @return void
     */
    private function sort_param()
    {
        $table = ! empty($_POST["file"]) && $_POST["file"] == "orderparam" ? "_order" : "";
        $id = intval($_POST['id']);
        if ( ! empty($id))
        {
            $oldsort = DB::query_result("SELECT sort FROM {shop".$table."_param_select} WHERE param_id=%d AND id=%d", $this->diafan->edit, $id);
            $row = DB::fetch_array(DB::query("SELECT id, sort FROM {shop".$table."_param_select} WHERE param_id=%d AND id<>%d AND"
                                    . ($_POST["action"] == "up_param" ? " sort<=%d ORDER BY sort DESC" : " sort>=%d ORDER BY sort ASC") . " LIMIT 1", $this->diafan->edit, $id, $oldsort));
            if ($row)
            {
                DB::query("UPDATE {shop".$table."_param_select} SET sort=%d WHERE id=%d", $oldsort, $row["id"]);
                DB::query("UPDATE {shop".$table."_param_select} SET sort=%d WHERE id=%d", $row["sort"], $id);
            }
        }
        $this->diafan->_cache->delete("", $this->diafan->module);

        $this->send_json();
    }

    /**
     * Клонирует товар
     * 
     * @return boolean true
     */
    private function clone_good()
    {
        $id = intval($_POST['id']);
        if (empty($id))
            return false;

        $row = DB::fetch_array(DB::query("SELECT * from {shop} WHERE id='%d'", $id));

        foreach ($row as $k => $v)
        {
            if ($k == 'name')
            {
                $v = _ADMIN_CLONE_COPY.' ' . $v;
            }
            $row[$k] = "'" . $v . "'";
        }
        unset($row['id']);
        unset($row['buy']);
        unset($row['view']);

        DB::query('INSERT INTO {shop} (' . implode(',', array_keys($row)) . ') VALUES (' . implode(',', $row) . ')');

        $n_id = DB::last_id("shop");
        $site_id = $row['site_id'];

        $result = DB::query("SELECT cat_id, trash FROM {shop_category_rel} WHERE element_id='%d'", $id);
        while ($row = DB::fetch_array($result))
        {
            DB::query("INSERT INTO {shop_category_rel} (element_id, cat_id, trash) VALUES ('%d','%d','%s')", $n_id, $row['cat_id'], $row['trash']);
        }
		
		$prices = array();
        $result = DB::query("SELECT * FROM {shop_price} WHERE good_id=%d AND trash='0'", $id);
        while ($row = DB::fetch_array($result))
        {
            $row['good_id'] = $n_id;
            foreach ($row as $k => $v)
			{
				if($k != "id")
				{
					$row_param[$k] = "'" . $v . "'";
				}
			}
            DB::query('INSERT INTO {shop_price} (' . implode(',', array_keys($row_param)) . ') VALUES (' . implode(',', $row_param) . ')');
			if($row["id"] == $row["price_id"])
			{
				$price_id = DB::last_id("shop_price");
				$prices[$row["price_id"]] = $price_id;

				$result_param = DB::query("SELECT param_id, param_value FROM {shop_price_param} WHERE price_id=%d", $row["price_id"]);
				while ($row_param = DB::fetch_array($result_param))
				{
					DB::query("INSERT INTO {shop_price_param} (price_id, param_id, param_value) VALUES (%d, %d, %d)", $price_id, $row_param["param_id"], $row_param["param_value"]);
				}
			}
        }
		foreach($prices as $old => $new)
		{
			DB::query("UPDATE {shop_price} SET price_id=%d WHERE price_id=%d AND good_id=%d", $new, $old, $n_id);
		}

        $result = DB::query("SELECT value, param_id FROM {shop_param_element} WHERE element_id='%d' AND trash='0'", $id);
        while ($row = DB::fetch_array($result))
        {
            $row['element_id'] = $n_id;
            foreach ($row as $k => &$v)
                $v = "'" . $v . "'";
            DB::query('INSERT INTO {shop_param_element} (' . implode(',', array_keys($row)) . ') VALUES (' . implode(',', $row) . ')');
        }
        return true;
    }

    /**
     * Удаляет значения списка параметров
     * 
     * @return void
     */
    private function delete_param()
    {
        $table = ! empty($_POST["file"]) && $_POST["file"] == "orderparam" ? "_order" : "";
        $id = intval($_POST['id']);
        if ( ! empty($id))
        {
            DB::query("DELETE FROM {shop".$table."_param_select} WHERE param_id=%d AND id=%d", $this->diafan->edit, $id);
        }
        $this->diafan->_cache->delete("", $this->diafan->module);

        $this->send_json();
    }

    /**
     * Прикрепляет похожие товары
     * 
     * @return void
     */
    private function rel_goods()
    {
        if (empty($_POST["element_id"]))
        {
            DB::query("INSERT INTO {shop} () VALUES ()");
            $_POST["element_id"] = DB::last_id("shop");
            $this->result["id"] = $_POST["element_id"];
        }
        Customization::inc('modules/shop/admin/shop.admin.view.php');
        if ($_POST["element_id"] != $_POST["rel_id"] &&
                ! DB::query_result("SELECT COUNT(*) FROM {shop_rel} WHERE good_id=%d AND rel_good_id=%d OR rel_good_id=%d AND good_id=%d", $_POST["element_id"], $_POST["rel_id"], $_POST["element_id"], $_POST["rel_id"]))
        {
            DB::query("INSERT INTO {shop_rel} (good_id, rel_good_id) VALUES (%d, %d)", $_POST["element_id"], $_POST["rel_id"]);
        }

        $this->result["data"] = Shop_admin_view::rel_goods($this, $_POST["element_id"]);

        $this->send_json();
    }

    /**
     * Подгружает список товаров для выбора похожих
     * 
     * @return void
     */
    private function show_rel_goods()
    {
        if (empty($_POST["element_id"]))
        {
            $_POST["element_id"] = 0;
        }
        $nastr = 24;
        $list = '';
        if (empty($_POST["page"]))
        {
            $start = 0;
            $page = 1;
            if ( ! isset($_POST["search"]) && ! isset($_POST["cat_id"]))
            {
                $list = '<form>'._LANG_SEARCH . ': <input type="text" size="30" class="rel_shop_search">';
				if($this->diafan->configmodules("cat", "shop"))
				{
					$result = DB::query("SELECT id, name, parent_id FROM {shop_category} WHERE trash='0' ORDER BY sort ASC");
					while ($row = DB::fetch_array($result))
					{
						$cats[$row["parent_id"]][] = $row;
					}
					$vals = array();
					if(! empty($_POST["cat_id"]))
					{
						$vals[] = $this->diafan->get_param($_POST, "cat_id", 2);
					}
					$list.= ' <select name="cat_id" class="rel_shop_cat_id"><option value="">'._LANG_ALL.'</option>'.$this->get_options($cats, $cats[0], $vals) . '</select>';
				}
				$list.= '</form><div class="rel_all_goods_container">';
            }
        }
        else
        {
            $page = intval($_POST["page"]);
            $start = ($page - 1) * $nastr;
        }
        $rel_goods = array();
        if ($_POST["element_id"])
        {
            $result = DB::query("SELECT good_id, rel_good_id FROM {shop_rel} WHERE good_id=%d OR rel_good_id=%d", $_POST["element_id"]);
            while ($row = DB::fetch_array($result))
            {
                $rel_goods[] = $row["good_id"];
                $rel_goods[] = $row["rel_good_id"];
            }
        }

		$where = '';
		if(! empty($_POST["cat_id"]))
		{
			$where = " AND cat_id=".$this->diafan->get_param($_POST, "cat_id", 2);
		}

        if ( ! empty($_POST["search"]))
        {
            $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0' AND name LIKE '%h%%' AND id<>%d".$where, $_POST["search"], $_POST["element_id"]);
            $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0' AND name LIKE '%h%%' AND id<>%d".$where, $_POST["search"], $_POST["element_id"], $start, $nastr);
        }
        else
        {
            $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0' AND id<>%d".$where, $_POST["element_id"]);
            $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0' AND id<>%d".$where, $_POST["element_id"], $start, $nastr);
        }
        while ($row = DB::fetch_array($result))
        {
            $img = DB::query_result("SELECT name FROM {images} WHERE element_id=%d AND module_name='shop' AND trash='0' ORDER BY sort ASC LIMIT 1", $row["id"]);
            $list .= '<div class="rel_shop" element_id="' . $row["id"] . '">
			<div' . (in_array($row["id"], $rel_goods) ? ' class="rel_shop_selected"' : '') . '>
			' . ($img ? '<a href="#"><img src="' . BASE_PATH . USERFILES . '/shop/small/' . $img . '"></a><br>' : '') . '
			<a href="#">' . $row["name"] . '</a>
			</div>
			</div>';
        }
        $list .= '<div class="clear rel_shop_navig">';
        for ($i = 1; $i <= ceil($count / $nastr); $i ++ )
        {
            if ($i != $page)
            {
                $list .= '<a href="#" page="' . $i . '">' . $i . '</a> ';
            }
            else
            {
                $list .= '[' . $i . '] ';
            }
        }
        $list .= '</div>';
        if (empty($_POST["page"]) && ! isset($_POST["search"]))
        {
            $list .= '</div>';
        }

        $this->result["data"] = $list;

        $this->send_json();
    }

    /**
     * Удаляет похожие товары
     * 
     * @return void
     */
    private function delete_rel_good()
    {
        DB::query("DELETE FROM {shop_rel} WHERE good_id=%d AND rel_good_id=%d", $_POST['element_id'], $_POST['rel_id']);
        DB::query("DELETE FROM {shop_rel} WHERE rel_good_id=%d AND good_id=%d", $_POST['element_id'], $_POST['rel_id']);

        $this->diafan->_cache->delete("", $this->diafan->module);

        $this->send_json();
    }

    /**
     * Подгружает список товаров
     * 
     * @return void
     */
    private function show_discount_goods()
    {
        if (empty($_POST["discount_id"]))
        {
            $_POST["discount_id"] = 0;
        }
        $nastr = 24;
        $list = '';
        if (empty($_POST["page"]))
        {
            $start = 0;
            $page = 1;
            if ( ! isset($_POST["search"]))
            {
                $list = _LANG_SEARCH . ': <input type="text" size="30" class="rel_shop_search">
				<div class="rel_all_goods_container">';
            }
        }
        else
        {
            $page = intval($_POST["page"]);
            $start = ($page - 1) * $nastr;
        }
        $discount_goods = array();
        if ($_POST["discount_id"])
        {
            $result = DB::query("SELECT good_id FROM {shop_discount_object} WHERE discount_id=%d", $_POST["discount_id"]);
            while ($row = DB::fetch_array($result))
            {
                $discount_goods[] = $row["good_id"];
            }
        }
        if ( ! empty($_POST["search"]))
        {
            $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0' AND name LIKE '%h%%'", $_POST["search"]);
            $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0' AND name LIKE '%h%%'", $_POST["search"], $start, $nastr);
        }
        else
        {
            $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0'");
            $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0'", $start, $nastr);
        }
        while ($row = DB::fetch_array($result))
        {
            $img = DB::query_result("SELECT name FROM {images} WHERE element_id=%d AND module_name='shop' AND trash='0' ORDER BY sort ASC LIMIT 1", $row["id"]);
            $list .= '<div class="rel_shop" element_id="' . $row["id"] . '">
			<div' . (in_array($row["id"], $discount_goods) ? ' class="rel_shop_selected"' : '') . '>
			' . ($img ? '<a href="#"><img src="' . BASE_PATH . USERFILES . '/shop/small/' . $img . '"></a><br>' : '') . '
			<a href="#">' . $row["name"] . '</a>
			</div>
			</div>';
        }
        $list .= '<div class="clear rel_shop_navig">';
        for ($i = 1; $i <= ceil($count / $nastr); $i ++ )
        {
            if ($i != $page)
            {
                $list .= '<a href="#" page="' . $i . '">' . $i . '</a> ';
            }
            else
            {
                $list .= '[' . $i . '] ';
            }
        }
        $list .= '</div>';
        if (empty($_POST["page"]) && ! isset($_POST["search"]))
        {
            $list .= '</div>';
        }

        $this->result["data"] = $list;

        $this->send_json();
    }

    /**
     * Прикрепляет скидку к товару
     * 
     * @return void
     */
    private function discount_good()
    {
        if ( ! $_POST["discount_id"])
        {
            DB::query("INSERT INTO {shop_discount} () VALUES ()");
            $_POST["discount_id"] = DB::last_id("shop_discount");
            $this->result["id"] = $_POST["discount_id"];
        }
        Customization::inc('modules/shop/admin/shop.admin.view.php');
        if ( ! DB::query_result("SELECT COUNT(*) FROM {shop_discount_object} WHERE good_id=%d AND discount_id=%d", $_POST["good_id"], $_POST["discount_id"]))
        {
            DB::query("INSERT INTO {shop_discount_object} (good_id, discount_id) VALUES (%d, %d)", $_POST["good_id"], $_POST["discount_id"]);
        }

        $this->result["data"] = Shop_admin_view::discount_goods($this, $_POST["discount_id"]);

        $this->send_json();
    }

    /**
     * Удаляет скидку на товар
     * 
     * @return void
     */
    private function delete_discount_good()
    {
        DB::query("DELETE FROM {shop_discount_object} WHERE good_id=%d AND discount_id=%d", $_POST['good_id'], $_POST['discount_id']);

        $this->diafan->_cache->delete("", $this->diafan->module);

        $this->send_json();
    }

    /**
     * Подгружает список товаров для добавления в заказ
     * 
     * @return void
     */
    private function show_order_goods()
    {
        if (empty($_POST["order_id"]))
        {
            $_POST["order_id"] = 0;
        }
        $nastr = 18;
        $list = '';
        if (empty($_POST["page"]))
        {
            $start = 0;
            $page = 1;
            if ( ! isset($_POST["search"]) && ! isset($_POST["cat_id"]))
            {
                $list = '<form>'._LANG_SEARCH . ': <input type="text" size="30" class="order_goods_search">';
				if($this->diafan->configmodules("cat", "shop"))
				{
					$result = DB::query("SELECT id, name, parent_id FROM {shop_category} WHERE trash='0' ORDER BY sort ASC");
					while ($row = DB::fetch_array($result))
					{
						$cats[$row["parent_id"]][] = $row;
					}
					$vals = array();
					if(! empty($_POST["cat_id"]))
					{
						$vals[] = $this->diafan->get_param($_POST, "cat_id", 2);
					}
					$list.= ' <select name="cat_id" class="order_goods_cat_id"><option value="">'._LANG_ALL.'</option>'.$this->get_options($cats, $cats[0], $vals) . '</select>';
				}
				$list.= '</form><div class="order_all_goods_container">';
            }
        }
        else
        {
            $page = intval($_POST["page"]);
            $start = ($page - 1) * $nastr;
        }

		$where = '';
		if(! empty($_POST["cat_id"]))
		{
			$where = " AND cat_id=".$this->diafan->get_param($_POST, "cat_id", 2);
		}

        if ( ! empty($_POST["search"]))
        {
            $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0' AND name LIKE '%h%%'".$where, $_POST["search"]);
            $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0' AND name LIKE '%h%%'".$where, $_POST["search"], $start, $nastr);
        }
        else
        {
            $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0'".$where);
            $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0'".$where, $start, $nastr);
        }
		$user_id = DB::query_result("SELECT user_id FROM {shop_order} WHERE id=%d", $_POST["order_id"]);
        while ($row = DB::fetch_array($result))
        {
            $img = DB::query_result("SELECT name FROM {images} WHERE element_id=%d AND module_name='shop' AND trash='0' ORDER BY sort ASC LIMIT 1", $row["id"]);
			$prices = $this->diafan->_shop->price_get_all($row["id"], $user_id);
            $list .= '<div class="order_good">
			<div>
			' . ($img ? '<img src="' . BASE_PATH . USERFILES . '/shop/small/' . $img . '"><br>' : '') . '
			' . $row["name"];
			foreach($prices as $price)
			{
				$list .= '<br><a href="#" price_id="'.$price["id"].'">'.$this->diafan->format_price($price["price"]).' '.$this->diafan->configmodules("currency", "shop").'</a>';
			}
			$list .= '</div>
			</div>';
        }
        $list .= '<div class="clear order_goods_navig">';
        for ($i = 1; $i <= ceil($count / $nastr); $i ++ )
        {
            if ($i != $page)
            {
                $list .= '<a href="#" page="' . $i . '">' . $i . '</a> ';
            }
            else
            {
                $list .= '[' . $i . '] ';
            }
        }
        $list .= '</div>';
        if (empty($_POST["page"]) && ! isset($_POST["search"]))
        {
            $list .= '</div>';
        }

        $this->result["data"] = $list;

        $this->send_json();
    }

    /**
     * Добавляет выбранный товар в заказ
     * 
     * @return void
     */
    private function add_order_good()
    {
        if (empty($_POST["order_id"]) || empty($_POST["price_id"]))
        {
            return false;
        }
		$price = DB::fetch_array(DB::query("SELECT price_id, price, good_id FROM {shop_price} WHERE id=%d", $_POST["price_id"]));
		$where = array();
		$params = array();
		$result = DB::query("SELECT param_id, param_value FROM {shop_price_param} WHERE price_id=%d AND trash='0'", $price["price_id"]);
		while ($row = DB::fetch_array($result))
		{
			$params[$row["param_id"]] = $row["param_value"];
			$where[] = "s.param_id=".intval($row["param_id"])." AND s.value=".intval($row["param_value"]);
		}
		if(! DB::query_result("SELECT g.id FROM {shop_order_goods} AS g WHERE g.order_id=%d AND g.good_id=%d"
				.($where ? " AND (SELECT COUNT(*) FROM {shop_order_goods_param} AS s WHERE g.id=s.order_good_id AND (".implode(" OR ", $where).")) = ".count($where) : ""), 
				$_POST["order_id"], $price["good_id"]))
		{
			DB::query("INSERT INTO {shop_order_goods} (order_id, good_id, count_goods, price) VALUES (%d, %d, 1, %f)", $_POST["order_id"], $price["good_id"], $price["price"]);
			$order_good_id = DB::last_id("shop_order_goods");
			$depend = '';
			if($params)
			{
				foreach($params as $id => $value)
				{
					DB::query("INSERT INTO {shop_order_goods_param} (value, param_id, order_good_id) VALUES (%d, %d, %d)", $value, $id, $order_good_id);
					$param_name  = DB::query_result("SELECT [name] FROM {shop_param} WHERE id=%d", $id);
					$param_value = DB::query_result("SELECT s.[name] FROM {shop_param_select} as s WHERE s.id=%d", $value);
					$depend .= ($depend ? ', ' : '').$param_name.': '.$param_value;
				}
			}
			$good = DB::fetch_array(DB::query("SELECT [name], article FROM {shop} WHERE id=%d", $price["good_id"]));
			$this->result["data"] = '
			<tr class="tr_good">
				<td id="first"><a href="'.BASE_PATH_HREF.'shop/edit'.$price["good_id"].'/">'.$good["name"].' '.$depend.' '.$good["article"].'</a></td>
				<td align="center"><input type="text" name="count_goods'.$order_good_id.'" value="1" size="2"></td>
				<td align="right"><input type="text" name="price_goods'.$order_good_id.'" value="'.$price["price"].'" size="4"></td>
				<td align="right">'.$this->diafan->format_price($price["price"]).'</td>
				<td><a href="javascript:void(0)" confirm="'._ADMIN_CONFIRM_DELETE.'" class="delete_order_good" title="'._LANG_DELETE.'">
				<img src="'.BASE_PATH.'adm/img/delete.png" width="13" height="13" alt="'._LANG_DELETE.'"></a></td>
</tr>';
		}

        $this->send_json();
    }

    /**
     * Отдает ответ Ajax
     * 
     * @return void
     */
    private function send_json()
    {
        if ($this->result)
        {
            include_once ABSOLUTE_PATH . 'plugins/json.php';
            echo to_json($this->result);
            exit;
        }
    }
}
