<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Shop_admin_currency
 *
 * Валюты
 */
class Shop_admin_currency extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shopcurrency';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'shop_currency';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'main' => array(
				'name' => 'text',
				'exchange_rate' => 'floattext'
			)
		);

		$this->config_module = array(
			'del'   => 1, //удалить
			'trash' => 1  //использовать корзину
		);
	}

	/**
	 * Выводит список заказов
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_SHOP_ADD_CURRENCY);
		$this->list_row();
		return true;
	}

	/**
	 * Сохранение поля "Курс валюты"
	 * @return boolean true
	 */
	protected function save_exchange_rate_module()
	{
		DB::query("UPDATE {shop_currency} SET exchange_rate='%f' WHERE id=%d", $_POST["exchange_rate"], $this->diafan->save);
		$this->diafan->_shop->price_calc(0, 0, $this->diafan->save);
		return true;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("shop_price", "currency_id=".$del_id, $trash_id);

		return true;
	}
}