<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Shop_admin_import_category
 *
 * Список импортов
 */
class Shop_admin_import_category extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shopimport';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'shop_import_category';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->nastr = 100;

		 //поля в базе данных для редактирования
        $this->variable_table = array(
            'main' =>
            array(
                'name' => 'text',
                'type' => 'select',
                'delete_items' => 'checkbox',
                'site_id' => 'function',
                'image_directory' => 'text', 
                'menu_id' => 'function'
            )
            ,
            'other_rows' =>
            array(
            )
        );

		$this->config_module = array(
			'del'             => 1, //удалить
			'category'        => 1, //часть модуля - категории
			'link_to_element' => 1, //основная ссылка ведет к списку элементов, принадлежащих категории
			'trash'           => 1  //использовать корзину
		);
		//$this->select_arr["format"] = array('csv' => 'CSV', 'xls' => 'XLS');
		$this->select_arr["type"] = array('good' => _ADMIN_GOOD_ID, 'category' => _ADMIN_CAT_ID);
	}

	/**
	 * Выводит список категорий
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_ADD_IMPORT);

		$this->list_row();
		
		return true;
	}
    
    protected function save_menu_id_module()
    {
        if(! isset($_POST['menu_id']))
        {
            return FALSE;
        }
        
        DB::query("UPDATE {".$this->table."} SET menu_id=%d WHERE id=%d", $_POST['menu_id'], $this->diafan->save);
        
        return TRUE;
    }
    
    protected function edit_menu_id_module()
    {
        $menu_id = DB::query_result("SELECT menu_id FROM {" . $this->table . "} WHERE id=%d", $this->diafan->edit);

        echo '
		<tr valign="top">
			<td class="td_first">' . _ADMIN_SHOP_IMPORT_MENU_ID . '</td>
			<td>';
        $result = DB::query("SELECT id, name FROM {menu_category} WHERE trash='0' ORDER BY id ASC");
        if (DB::num_rows($result) > 0)
        {
            echo '<select name="menu_id">';
            echo '<option value="0">-</option>';
            while ($row = DB::fetch_array($result))
            {
                echo '<option value="' . $row["id"] . '"  ' . ($menu_id == $row["id"] ? ' selected="selected" ' : '' ). '>' . $row["name"] . '</option>';
            }
            echo '</select>';
        }
        echo '
			</td>
		</tr>';
        return true;
    }
}