<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Shop_admin_order
 *
 * Редактирование заказов товаров
 */
class Shop_admin_order extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shoporder';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'shop_order';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'main' => array(
			'number'	 => 'function',
			'created'	 => 'datetime',
			'lang_id'	 => 'select',
			'hr1'		 => 'hr',
			
			'goods'      => 'function',
			'payment_id' => 'select',
			'delivery_id'=> 'select',
			'hr2'		 => 'hr',
			
			'user_id'	 => 'function',
			'param'		 => 'function',
			'hr3'		 => 'hr',
			
			'status'     => 'function'
			)
		);

		$this->config_module = array(
			'del'      => 1, //удалить
			'datetime' => 1, //показывать дату и время в списке
			'trash'    => 1  //использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'status',
			'summ',
			'user_id',

		);

		$this->select["lang_id"] = array(
			"language",
			"id",
			"name"
		);

		$this->select_arr["status"] = array(
			0 => _ADMIN_SHOPORDER_STATUS_0,
			1 => _ADMIN_SHOPORDER_STATUS_1,
			2 => _ADMIN_SHOPORDER_STATUS_2,
			3 => _ADMIN_SHOPORDER_STATUS_3
		);

		$this->select["payment_id"] = array(
			"shop_payment",
			"id",
			"name",
			"",
			"-",
			"trash='0'"
		);

		$this->select["delivery_id"] = array(
			"shop_delivery",
			"id",
			"name",
			"",
			"-",
			"trash='0'"
		);
		
		$this->select_arr["color"] = array(
			0	=> "red",
			1	=> "blue",
			2	=> "gray",
			3	=> "darkgreen"
		);
	}

	/**
	 * Выводит список заказов
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->name = "id, concat('"._ADMIN_SHOPORDER_NUMBER." ', id)";
		
		echo '<br><a href="'.BASE_PATH_HREF.'shop/order/?status=0" class="new_order">'._ADMIN_SHOPORDER_CHECK_NEW_ORDER.'</a><br><br>';
		
		echo '<form action="'.URL.'" method="GET">
		<p>'._ADMIN_STATUS.': <select name="status">
		<option value="all">'._LANG_ALL.'</option>';
		foreach ($this->select_arr["status"] as $id => $value)
		{
			echo '<option value="'.$id.'"'.(isset($_GET["status"]) && $_GET["status"] == $id ? ' selected' : '').'>'.$value.'</option>';
		}
		echo '</select></p>
		</form>
		<script type="text/javascript">
		$(document).ready(function(){
			$("select[name=status]").change(function(){
				if ($(this).val() == "all")
				{
					$(this).attr("name", "");
				}
				$(this).parents("form").submit();
			})
		});
		</script>';

		if (isset($_GET["status"]))
		{
			$status = (int)$this->diafan->get_param($_GET, "status", 0, 2);
			$this->where = " AND status='".$status."'";
			$this->get_nav = '?status='.$status;
		}
		echo '<meta http-equiv="refresh" content="300" />';
		$this->list_row();
		
		if (! $this->count)
		{
			echo _ADMIN_SHOPORDER_NONE;
		}

		return true;
	}

	/**
	 * Выводит имя заказчика в списке заказов
	 * @return string
	 */
	protected function other_row_user_id($row)
	{
		return '</td><td class="user_id">'
		.($row["user_id"]
		 ? '<a href="'.BASE_PATH_HREF.'users/edit'.$row["user_id"].'/">'.DB::title("users", $row["user_id"], "fio").'</a>'
		 : _ADMIN_SHOPORDER_NOT_REGISTRATION);
	}

	/**
	 * Выводит сумму заказа в списке заказов
	 * @return string
	 */
	protected function other_row_summ($row)
	{
		return '</td><td class="summ">'
		.($row["summ"]
		 ? $this->diafan->format_price($row["summ"]).' '.$this->diafan->configmodules("currency", "shop")
		 : '');
	}



	/**
	 * Выводит статус заказа в списке заказов
	 * @return string
	 */
	protected function other_row_status($row)
	{
		if (! $row["status"])
		{
			$row["status"] = 0;
		}
		return '</td><td class="status">'.(! empty($this->select_arr["status"][$row["status"]])
				    ? '<span style="color:'.$this->select_arr["color"][$row["status"]].';font-weight: bold;">'
				      .$this->select_arr["status"][$row["status"]].'</span>'
				    : '');
	}

	/**
	 * Редактирование поля "Номер"
	 * @return boolean true
	 */
	protected function edit_number_module()
	{
		echo '<tr>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td style="color:#999999;font-weight:bold">
				'.$this->diafan->edit.' '.$this->show_help_row().'
			</td>
		</tr>';
		return true;
	}

	/**
	 * Редактирование поля "Пользователь"
	 * @return boolean true
	 */
	protected function edit_user_id_module()
	{
		if ($this->value)
		{
			echo '
			<tr>
				<td align="right">'.$this->variable_names().'</td>
				<td>
					<a href="'.BASE_PATH_HREF.'users/edit'.$this->value.'/">'.DB::title("users", $this->value, "fio").'</a>'
					.$this->show_help_row().'
				</td>
			</tr>';
		}
	}

	/**
	 * Редактирование поля "Статус"
	 * @return boolean true
	 */
	protected function edit_status_module()
	{
		echo '<tr><td></td><td><input type="button" class="button" rel="'.$this->value.'" id="order_button_status" value="'.($this->value == 0? _ADMIN_SHOPORDER_SEND_TO_STATUS_1 : _ADMIN_SHOPORDER_SEND_TO_STATUS_3).'">';
		echo '
				<script type="text/javascript">
				$(document).ready(function(){
				$("#order_button_status").click(function (){
				    var val=$(this).attr("rel");
				    if(!val) { $("#order_select_status [value=\'1\']").attr("selected", "selected"); }
				    else { $("#order_select_status [value=\'3\']").attr("selected", "selected"); }
				    
				    $("#save").submit();
				    });
				});
				</script></td></tr>';
				
		echo '<tr>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>';
				
		echo '<select name="status" id="order_select_status">';
			foreach ($this->select_arr["status"] as $key => $value)
			{
				if ($this->value == 0 && $key == 3)
					continue;
				echo '<option value="'.$key.'"'.($key == $this->value ? ' selected' : '').'>'.$value.'</option>';
			}
			echo '</select>'.$this->show_help_row();
		echo '</td>
		</tr>';
		return true;
	}

	/**
	 * Редактирование поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$values = array();
		$rvalues = array();
		$result_el = DB::query("SELECT value as rv, [value], param_id FROM {shop_order_param_element} WHERE element_id=%d", $this->diafan->edit);
		while ($row_el = DB::fetch_array($result_el))
		{
			$values[$row_el["param_id"]][]  = $row_el["value"];
			$rvalues[$row_el["param_id"]][] = $row_el["rv"];
		}

		$result = DB::query("SELECT id, name, type FROM {shop_order_param} WHERE trash='0' ORDER BY sort ASC");

		while ($row = DB::fetch_array($result))
		{
			$option = array();
			if (! $this->diafan->addnew && in_array($row["type"], array('select', 'multiple')))
			{
				$result_select = DB::query("SELECT [name], id FROM {shop_order_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
				while ($row_select = DB::fetch_array($result_select))
				{
					$option[] = $row_select;
				}
			}
			if ($row["type"] == 'text' || $row["type"] == 'email')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
					</td>
				</tr>';
			}
			
            elseif ($row["type"] == 'date')
            {

                echo '
                <tr>
                    <td align="right">'.$row["name"].'</td>
                    <td>
                        <input type="text" id="param'.$row["id"].'" name="param'.$row["id"].'" size="20" value="'
                        .(! empty($rvalues[$row["id"]]) ? $this->diafan->formate_from_date($rvalues[$row["id"]][0]): '')
                    .'" class="timecalendar" showTime="false">
                    </td>
                </tr>';
            }

            elseif ($row["type"] == 'datetime')
            {
                echo '
                <tr>
                    <td align="right">'.$row["name"].'</td>
                    <td>
                        <input type="text" id="param'.$row["id"].'" name="param'.$row["id"].'" size="20" value="'
                        .(! empty($rvalues[$row["id"]]) ? $this->diafan->formate_from_datetime($rvalues[$row["id"]][0]) : '')
                    .'" class="timecalendar" showTime="true">
                    </td>
                </tr>';
            }
			elseif ($row["type"] == 'numtext')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="20" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'" class="inpnum">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'textarea')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<textarea name="param'.$row["id"].'" cols="60" rows="5">'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'</textarea>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'checkbox')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="checkbox" name="param'.$row["id"].'" value="1"'
						.(! $this->diafan->addnew && ! empty($values[$row["id"]]) ? " checked":'').'>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'select')
			{
				$value = (! empty($rvalues[$row["id"]][0]) ? $rvalues[$row["id"]][0] : '');
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<select name="param'.$row["id"].'">
						<option value="">-</option>';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.($value == $select["id"] ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'multiple')
			{
				$value = (! empty($rvalues[$row["id"]]) ? $rvalues[$row["id"]] : array());
				echo '
				<tr>
					<td align="right">
						'.$row["name"].'
					</td>
					<td>
						<select name="param'.$row["id"].'[]" multiple="multiple">';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.(in_array($select["id"], $value) ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
		}
		return true;
	}

	/**
	 * Редактирование поля "Товары"
	 * @return boolean true
	 */
	protected function edit_goods_module()
	{
		$summ = 0; $count = 0;
		echo '
		<tr valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
                <script type="text/javascript" src="'.BASE_PATH.'modules/shop/admin/shop.admin.js"></script>
				<table class="border" cellspacing="0">
					<tr id="tr_first">
						<td id="first">'._LANG_NAME_GOOD.'</td>
						<td>'._LANG_COUNT.'</td>
						<td>'._LANG_PRICE.'</td>
						<td>'._LANG_DISCOUNT.'</td>
						<td>'._LANG_SUM.'</td>
                                                    
					</tr>';
		$format_price = intval($this->diafan->configmodules("format_price_1", "shop"));

		$result = DB::query("SELECT * FROM {shop_order_goods} where order_id=%d", $this->values["id"]); 
		while ($row = DB::fetch_array($result))
		{
			$depend = '';
			$result_p = DB::query("SELECT * FROM {shop_order_goods_param} WHERE order_good_id=%d", $row["id"]); 
			while ($row_p = DB::fetch_array($result_p))
			{
				$param_name  = DB::query_result("SELECT [name] FROM {shop_param} WHERE id=%d", $row_p["param_id"]);
				$param_value = DB::query_result("SELECT s.[name] FROM {shop_param_select} as s WHERE s.id=%d AND s.param_id=%d", $row_p["value"], $row_p["param_id"]);
				$depend .= ($depend ? ', ' : '').$param_name.': '.$param_value;
			}
			$good = DB::fetch_array(DB::query("SELECT [name], article FROM {shop} WHERE id=%d", $row["good_id"]));
			if($row["discount_id"])
			{
				if(empty($discounts[$row["discount_id"]]))
				{
					$d = DB::fetch_array(DB::query("SELECT discount, deduction FROM {shop_discount} WHERE id=%d", $row["discount_id"]));
					$discounts[$row["discount_id"]] = $d["discount"] ? $d["discount"].'%' : $d["deduction"].' '.$this->diafan->configmodules("currency", "shop");
				}
				$row["discount"] = $discounts[$row["discount_id"]];
			}
			
			echo '
			<tr class="tr_good">
				<td id="first"><a href="'.BASE_PATH_HREF.'shop/edit'.$row["good_id"].'/">'.$good["name"].' '.$depend.' '.$good["article"].'</a></td>
				<td align="center"><input type="text" name="count_goods'.$row["id"].'" value="'.$row["count_goods"].'" size="2"></td>
				<td align="right"><input type="text" name="price_goods'.$row["id"].'" value="'.number_format($row["price"], $format_price, "", "").'" size="4"></td>
				<td>'.($row["discount_id"] ? '<a href="'.BASE_PATH_HREF.'shop/discount/edit'.$row["discount_id"].'/">'.$row["discount"].'</a>' : '').'</td>
				<td align="right">'.$this->diafan->format_price($row["price"] * $row["count_goods"]).'</td>
				<td><a href="javascript:void(0)" confirm="'._ADMIN_CONFIRM_DELETE.'" class="delete_order_good" title="'._LANG_DELETE.'">
				<img src="'.BASE_PATH.'adm/img/delete.png" width="13" height="13" alt="'._LANG_DELETE.'"></a></td>
</tr>';
					
			$summ += $row["price"] * $row["count_goods"];
			$count += $row["count_goods"];
		}
		echo '<tr class="tr_good">
			<td id="first" colspan="4">
				<a href="javascript:void(0)" class="order_good_plus" title="' . _LANG_ADD . '"><img src="' . BASE_PATH . 'adm/img/add_new.png" width="14" height="14" alt="' . _LANG_ADD . '"></a>
				<div class="hide" id="order_goods_container"></div></td>
		</tr>';
		$result = DB::query("SELECT a.id, a.[name], a.price, a.amount, s.id AS sid, s.summ FROM {shop_additional_cost} AS a LEFT JOIN {shop_order_additional_cost} AS s ON s.additional_cost_id=a.id AND s.order_id=%d WHERE a.trash='0'", $this->values["id"]); 
		while ($row = DB::fetch_array($result))
		{
			if($row["sid"])
			{
				$row['price'] = $row['summ'];
			}
			else
			{
				if (! empty($row['amount']))
				{
					if ($row['amount'] < $summ)
					{
						$row['price'] = 0;
					}
				}
			}
		    echo '<tr class="tr_good">
				<td id="first" colspan="4">'.$row["name"].'</td>
				<td align="right" class="order_good_price"><input type="text" name="summ_additional_cost'.$row["id"].'" value="'.$row["price"].'" size="4"></td>
				<td><input name="additional_cost_id'.$row["id"].'" value="1" type="checkbox" '.($row["sid"] ? ' checked' : '').'></td>
			</tr>';
		}
		if ($this->values["delivery_id"])
		{
			$delivery_name = DB::query_result("SELECT [name] FROM {shop_delivery} WHERE id=%d", $this->values["delivery_id"]);
		    echo '<tr>
				<td id="first" colspan="4">'.$delivery_name.'</td>
				<td align="right" class="order_good_price">'.$this->diafan->format_price($this->values["delivery_summ"]).'</td>
			</tr>';
		}
		echo '
			<tr>
				<td id="first">'._LANG_GOODS_TOTAL.'</td>
				<td align="center" class="order_good_count">'.$count.'</td>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
				<td align="right" class="order_good_price">'.$this->diafan->format_price($this->values["summ"]).'</td>
			</tr>
		</table>
		'.$this->show_help_row().'
			</td>
		</tr>';

		return true;
	}

	/**
	 * Сохранение поля "Пользователь"
	 * @return boolean true
	 */
	protected function save_user_id_module()
	{
		return true;
	}

	/**
	 * Сохранение поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		$ids = array();
		$result = DB::query("SELECT id, name, type FROM {shop_order_param} WHERE trash='0' ORDER BY sort ASC");

		while ($row = DB::fetch_array($result))
		{
			if ($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {shop_order_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				if (! empty($_POST['param'.$row["id"]]) && is_array($_POST['param'.$row["id"]]))
				{
					foreach ($_POST['param'.$row["id"]] as $v)
					{
						DB::query(
							"INSERT INTO {shop_order_param_element} (value, param_id, element_id) VALUES ('%s', %d, %d)",
							$v,
							$row["id"],
							$this->diafan->save
						);
					}
				}
				$ids[] = $row["id"];
			}
			elseif (! empty($_POST['param'.$row["id"]]))
			{
				$id = 0;
				if (! $this->diafan->savenew)
				{
					$id = DB::query_result("SELECT id FROM {shop_order_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				}
				if ($row["type"] == "date")
                {
                    $_POST['param'.$row["id"]] = $this->diafan->formate_in_date($_POST['param'.$row["id"]]);
                }
                if ($row["type"] == "datetime")
                {
                    $_POST['param'.$row["id"]] = $this->diafan->formate_in_datetime($_POST['param'.$row["id"]]);
                }
				if ($id)
				{
					DB::query(
						"UPDATE {shop_order_param_element} SET ".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						."='%s' WHERE id=%d",
						$_POST['param'.$row["id"]],
						$id
					);
					DB::query("DELETE FROM {shop_order_param_element} WHERE param_id=%d AND element_id=%d AND id<>%d", $row["id"], $this->diafan->save, $id);
				}
				else
				{
					DB::query(
						"INSERT INTO {shop_order_param_element} (".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						.", param_id, element_id) VALUES ('%s', %d, %d)",
						$_POST['param'.$row["id"]],
						$row["id"],
						$this->diafan->save
					);
				}
				$ids[] = $row["id"];
			}
		}
		DB::query("DELETE FROM {shop_order_param_element} WHERE param_id NOT IN (".implode(", ", $ids).") AND element_id=%d", $this->diafan->save);
		return true;
	}

	/**
	 * Сохранение поля "Товары"
	 * @return boolean true
	 */
	protected function save_goods_module()
	{
		$summ = 0;
		$result = DB::query("SELECT * FROM {shop_order_goods} WHERE order_id=%d", $this->diafan->save); 
		while ($row = DB::fetch_array($result))
		{
			if(empty($_POST["count_goods".$row["id"]]))
			{
				DB::query("DELETE FROM {shop_order_goods} WHERE id=%d", $row["id"]);
			}
			else
			{
				if ($_POST["count_goods".$row["id"]] != $row["count_goods"])
				{
					DB::query("UPDATE {shop_order_goods} SET count_goods=%d WHERE id=%d", $_POST["count_goods".$row["id"]], $row["id"]);
				}
				if ($_POST["price_goods".$row["id"]] != $row["price"])
				{
					DB::query("UPDATE {shop_order_goods} SET price=%f WHERE id=%d", $_POST["price_goods".$row["id"]], $row["id"]);
				}

				$summ += $_POST["price_goods".$row["id"]] * $_POST["count_goods".$row["id"]];
			}
		}
		$result = DB::query("SELECT a.id, s.id AS sid, s.summ FROM {shop_additional_cost} AS a LEFT JOIN {shop_order_additional_cost} AS s ON s.additional_cost_id=a.id AND s.order_id=%d WHERE a.trash='0'", $this->diafan->save); 
		while ($row = DB::fetch_array($result))
		{
			if($row["sid"])
			{
				if(empty($_POST['additional_cost_id'.$row["id"]]))
				{
					DB::query("DELETE FROM {shop_order_additional_cost} WHERE id=%d", $row["sid"]);
				}
				elseif($row['summ'] != $_POST['summ_additional_cost'.$row["id"]])
				{
					DB::query("UPDATE {shop_order_additional_cost} SET summ=%f WHERE id=%d", $_POST['summ_additional_cost'.$row["id"]], $row["sid"]);
				}
			}
			else
			{
				if(! empty($_POST['additional_cost_id'.$row["id"]]))
				{
					DB::query("INSERT INTO {shop_order_additional_cost} (additional_cost_id, summ, order_id) VALUES (%d, %f, %d)", $row["id"], $_POST['summ_additional_cost'.$row["id"]], $this->diafan->save);
				}
			}
		}
		
		$result = DB::query("SELECT a.id, a.[name], s.summ, s.id AS a_id FROM {shop_additional_cost} AS a INNER JOIN {shop_order_additional_cost} AS s ON s.additional_cost_id=a.id WHERE s.order_id=%d", $this->diafan->save); 
		while ($row = DB::fetch_array($result))
		{
			if(! isset($_POST['summ_additional_cost'.$row["id"]]))
			{
				DB::query("DELETE FROM {shop_order_additional_cost} WHERE id=%d", $row["a_id"]);
			}
			else
			{
				if($_POST['summ_additional_cost'.$row["id"]] != $row["summ"])
				{
					DB::query("UPDATE {shop_order_additional_cost} SET summ=%f WHERE id=%d", $_POST['summ_additional_cost'.$row["id"]], $row["a_id"]);
				}
				$summ += $_POST['summ_additional_cost'.$row["id"]];
			}
		}
		DB::query("UPDATE {shop_order} SET summ=%f+delivery_summ WHERE id=%d", $summ, $this->diafan->save);
		
		return true;
	}

	/**
	 * Сохранение поля "Способ доставки"
	 * @return boolean true
	 */
	protected function save_delivery_id_module()
	{
		$result = DB::query("SELECT id, price, amount FROM {shop_delivery}  WHERE [act]='1' AND trash='0'AND id=%d", $_POST["delivery_id"]);
		if ($row = DB::fetch_array($result))
		{
			if (! empty($row['amount']))
			{
				if ($row['amount'] < DB::query_result("SELECT summ FROM {shop_order} WHERE id=%d", $this->diafan->save))
				{
					$row['price'] = 0;
				}
			}
			$delivery_summ = $row["price"];
			$delivery_id = $row["id"];
		}
		DB::query("UPDATE {shop_order} SET summ=summ-delivery_summ+%f, delivery_summ=%f, delivery_id=%d WHERE id=%d", $delivery_summ, $delivery_summ, $delivery_id, $this->diafan->save);
	}

	/**
	 * Сохранение поля "Статус",
     * отправка ссылок на купленные файлы при необходимости
     * 
	 * @return boolean true
	 */
	protected function save_status_module()
	{
		if($_POST["status"] == 3 && $this->oldrow["status"] != 3)
		{
			$this->diafan->_shop->order_pay($this->diafan->save);
		}
        
        $this->query[] = "status='%d'";
		$this->value[] = $_POST["status"];
		
        return TRUE;
    }
    
    
	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("shop_order_goods", "order_id=".$del_id, $trash_id);
		$this->del_or_trash_where("shop_order_goods_param", "order_good_id IN (SELECT id FROM {shop_order_goods} WHERE order_id=".$del_id.")", $trash_id);
		$this->del_or_trash_where("shop_order_param_element", "element_id=".$del_id, $trash_id);

		return true;
	}
}