<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Site_admin
 *
 * Редактирование страниц сайта
 */
class Site_admin extends Frame_admin
{

	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'site';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'site';

	/**
	 * Конструктор класса
	 *
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->nastr = 100;


		//поля в базе данных для редактирования
		$this->variable_table = array ( 'main'       => array ( 'name'     => 'text',
																'act'      => 'checkbox',
																'menu'     => 'module',
																'tags'     => 'module',
																'comments' => 'module',
																'hr4'      => 'hr',
																'text'     => 'editor',
																'search'   => 'module', ),
										'other_rows' => array ( 'hr1'           => 'hr',
																'images'        => 'module',
																'number'        => 'function',
																'block'         => 'checkbox',
																'timeedit'      => 'text',
																'title_meta'    => 'text',
																'keywords'      => 'text',
																'descr'         => 'textarea',
																'js'            => 'textarea',
																'rewrite'       => 'function',
																'access'        => 'function',
																'title_no_show' => 'checkbox',
																'map_no_show'   => 'checkbox',
																'hr2'           => 'hr',
																'addmodule'     => 'select',
																'parent_id'     => 'select',
																'hr3'           => 'hr',
																'theme'         => 'text',

										) );


		//переводимые поля
		$this->language_names = array ( 'name', 'act', 'title', 'title_meta', 'keywords', 'descr', 'text' );

		$this->config_module = array ( 'parent' => 1, //содержит вложенности
									   'order'  => 1, //сортируется
									   'act'    => 1, //показать/скрыть
									   'view'   => 1, //просмотр на сайте
									   'del'    => 1, //удалить
									   'menu'   => 1, //используется в меню
									   'nopage' => 1, //не разбивать на страницы
									   'trash'  => 1 //использовать корзину
		);

		//нельзя редактировать поля Принадлежит, Псевдоссылка, Сторонняя ссылка, Активность для Главной страницы
		if ($this->diafan->edit == 1 && !$this->diafan->addnew || $this->diafan->save == 1 && !$this->diafan->savenew)
		{
			unset( $this->variable_table["act"] );
			unset( $this->variable_table["parent_id"] );
			unset( $this->variable_table["rewrite"] );
			unset( $this->variable_table["hr3"] );
			unset( $this->variable_table["block"] );
			unset( $this->variable_table["map_no_show"] );
		}
	}

	/**
	 * Выводит список страниц сайта
	 * @return boolean true
	 */
	public function show_module()
	{
		echo '<ul class="list">
		<li class="level_0">';


		//Главная страница
		if ($row = DB::fetch_array(DB::query("SELECT [name] FROM {" . $this->table . "} WHERE id=1 LIMIT 1")))
		{
			echo '		    <div class="table_wrap"><table width="100%"><tbody><tr>
			
			<td class="name" style="padding-left:8px"><a title="' . _LANG_EDIT . '" href="' . URL . 'edit1/">' . ( $row["name"] ? $row["name"] : 1 ) . '</a>';

			if (DB::query_result("SELECT COUNT(*) FROM {menu} WHERE module_name='site' AND site_id=1 AND trash='0' AND [act]='10'"))
			{
				echo ' <span title="' . _ADMIN_MENU . '">(м)</span>';
			}

			echo '</td><td class="action_separator"></td><td class="action_icon"><a href="' . URL . 'parent0/addnew1/" title="' . _ADMIN_SITE_ADD . '"><img src="' . BASE_PATH . 'adm/img/add.png" alt="' . _ADMIN_SITE_ADD . '"></a></td>
		     </tr></tbody></table></div>';
		}
		echo '</li></ul>';

		//весь список
		$this->list_row();

		$query = DB::query('SELECT id,[name]' . ( $this->config_module["act"] ? ', act' . $this->lang_act . ' AS `act`' : '' ) . ',block, addmodule FROM {' . $this->table . '} WHERE trash="0" AND block="1" ORDER BY id DESC');
		if (DB::num_rows($query) > 0)
		{
			echo '<h1>' . _ADMIN_SITE_BLOCKS . ' <a class="help_img"><img src="' . BASE_PATH . 'adm/img/quest.gif" alt="' . _LANG_HELP . '"><div id="helpsiteblock" class="help_row">' . _ADMIN_SITE_BLOCKS_HELP . '</div></a></h1><ul class="list">
		';

			while ($row = DB::fetch_array($query))
			{

				echo '<li class="level_0" row_id="'.$row["id"].'"><div class="table_wrap' . ( ( $this->config_module['act'] && !$row['act'] ) ? ' no_act' : '' ) . '"><table width="100%"><tbody><tr>
			<td class="name" style="padding-left:8px">' . $this->get_base_link($row) . '</td>
			' . $this->get_actions($row) . '
			</tbody></table></div></li>';
			}
		}

		echo '</ul>';


		return true;
	}

	/**
	 * Редактирование поля "Шаблон страницы"
	 * @return boolean true
	 */
	protected function edit_theme_module()
	{
		echo '<tr>
			<td class="td_first">
				' . $this->variable_names() . '
			</td>
			<td>
				<select name="theme">
					<option value="">site.php</option>';

		if ($dir = opendir(ABSOLUTE_PATH . "themes"))
		{
			while (( $file = readdir($dir) ) !== false)
			{
				if ($file != '.' && $file != '..' && $file != 'site.php')
				{
					echo '<option value="' . $file . '"' . ( $this->value == $file ? ' selected' : '' ) . '>' . $file . '</option>';
				}
			}
		}
		closedir($dir);
		echo '
				</select>' . $this->show_help_row() . '
			</td>
		</tr>';
		return true;
	}

	/**
	 * Редактирование поля "Прикрепленный модуль"
	 * @return boolean true
	 */
	protected function edit_addmodule_module()
	{
		echo '<tr>
			<td class="td_first">
				' . $this->variable_names() . '
			</td>
			<td>
				<select name="' . $this->key . '">
					<option value="">' . _LANG_NOT . '</option>';
					$result = DB::query("SELECT DISTINCT(name) FROM {modules} WHERE site='1' ORDER BY id ASC");
					while ($row = DB::fetch_array($result))
					{
						$const = strtoupper('_LANG_' . $row["name"]);
						echo '<option value="' . $row["name"] . '"' . ( $this->value == $row["name"] ? ' selected' : '' ) . '>' . ( defined($const) ? constant($const) : $row["name"] ) . '</option>';
					}

		echo '
				</select>
				' . $this->show_help_row() . '
			</td>
		</tr>';
		return true;
	}

	/**
	 * Сохранение поля "Псевдоссылка"
	 * @return boolean true
	 */
	protected function save_rewrite_module()
	{
        if($this->diafan->save == 1) return false;

		$this->diafan->_cache->delete("", "rewrite");
		DB::query("DELETE FROM {rewrite} WHERE module_name='%s' AND site_id=%d", $this->diafan->module, $this->diafan->save);
		if (!empty( $_POST["rewrite"] ))
		{
			//$rewrite = $this->diafan->translit($_POST["rewrite"]);
			$rewrite = $_POST["rewrite"];
			//если такая псевдоссылка принадлежит другому элементу, добавляем номер id
			if (DB::query_result("SELECT id FROM {rewrite} WHERE rewrite='%s'", $rewrite))
			{
				$rewrite .= $this->diafan->save;
			}
			DB::query("INSERT INTO {rewrite} (module_name, site_id, rewrite) VALUES ('site', %d, '%h')", $this->diafan->save, $rewrite);

			return true;
		}
		if (!empty( $rewrite ))
		{
			// в готовой псевдоссылке берется только последняя часть
			if (strstr($rewrite, '/'))
			{
				$rewrite_array = explode("/", $rewrite);
				$rewrite = $rewrite_array[count($rewrite_array) - 1];
			}
		}
		else
		{
			$this->generate_rewrite();
			$rewrite = $_POST["rewrite"];
		}

		//если сохраняемый элемент имеет родителя, то в начало псевдоссылки подставляется псевдоссылка родителя
		$rewrite = ( $_POST["parent_id"] ? DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='%s' AND site_id=%d", $this->table, $_POST["parent_id"]) . '/' : '' ) . $rewrite;

		//если такая псевдоссылка принадлежит другому элементу, добавляем номер id
		if (DB::query_result("SELECT id FROM {rewrite} WHERE rewrite='%s'", $rewrite))
		{
			$rewrite .= $this->diafan->save;
		}

		//изменяем псевдоссылку у дочерних страниц
		$this->save_children_rewrite($this->diafan->save, $rewrite);

		DB::query("INSERT INTO {rewrite} (module_name, site_id, rewrite) VALUES ('site', %d, '%h')", $this->diafan->save, $rewrite);
		return true;
	}

	/**
	 * Изменяет псевдоссылки вложенных страниц
	 * @return boolean true
	 */
	private function save_children_rewrite($parent_id, $rewrite)
	{
		$result = DB::query("SELECT r.rewrite, s.id FROM {site} AS s" . " INNER JOIN {} AS r ON r.site_id=a.id AND r.module_name='site'" . " WHERE s.parent_id=%d AND s.id<>%d", $parent_id, $parent_id);
		while ($row = DB::fetch_array($result))
		{
			if (empty( $row["rewrite"] ))
			{
				$rewrite1 = $rewrite . '/' . $row["id"];
			}
			else
			{
				$rew = explode("/", $row["rewrite"]);
				if (empty( $rew[count($rew) - 1] ))
				{
					$rewrite1 = $rewrite . '/' . $row["id"];
				}
				else
				{
					$rewrite1 = $rewrite . '/' . $rew[count($rew) - 1];
				}
			}
			DB::query("UPDATE {rewrite} SET rewrite='%h' WHERE module_name='%s', site_id=%d", $rewrite1, $row["id"]);
			$this->save_children_rewrite($row["id"], $rewrite1);
		}
		return true;
	}

	/**
	 * Сохранение поля "JavaScript"
	 * @return void
	 */
	protected function save_js_module()
	{
		$this->query[] = "js='%s'";
		$this->value[] = $_POST["js"];
	}
}