<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Users_admin_ajax
 *
 * Обработка Ajax-запросов в административной части модуля Пользователи
 */
class Users_admin_ajax
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array результаты, передаваемы Ajaxом
	 */
	private $result;

	/**
	 * Конструктор класса
	 *
	 * @return void
	 */
	public function __construct($frame)
	{
		$this->diafan = $frame->diafan;

		// Прошел ли пользователь проверку идентификационного хэша
		if (!$this->diafan->_user->checked)
		{
			$this->result["error"] = 'ERROR';
			$this->send_json();
		}

		$this->result["hash"] = $this->diafan->_user->get_hash();

		if (!empty( $_POST["action"] ))
		{
			switch ($_POST["action"])
			{
				case 'up_param':
				case 'down_param':
					$this->sort_param();
					break;
				case 'delete_param':
					$this->delete_param();
					break;
			}
		}
	}

	/**
	 * Сортирует значения списка параметров
	 *
	 * @return void
	 */
	private function sort_param()
	{
		$id = intval($_POST['id']);
		if (!empty( $id ))
		{
			$oldsort = DB::query_result("SELECT sort FROM {users_param_select} WHERE param_id=%d AND id=%d", $this->diafan->edit, $id);
			$row = DB::fetch_array(DB::query("SELECT id, sort FROM {users_param_select} WHERE param_id=%d AND id<>%d AND" . ( $_POST["action"] == "up_param" ? " sort<=%d ORDER BY sort DESC" : " sort>=%d ORDER BY sort ASC" ) . " LIMIT 1", $this->diafan->edit, $id, $oldsort));
			if ($row)
			{
				DB::query("UPDATE {users_param_select} SET sort=%d WHERE id=%d", $oldsort, $row["id"]);
				DB::query("UPDATE {users_param_select} SET sort=%d WHERE id=%d", $row["sort"], $id);
			}
		}
		$this->diafan->_cache->delete("", $this->diafan->module);
		$this->diafan->_cache->delete("", $this->diafan->rewrite);

		$this->send_json();
	}

	/**
	 * Сортирует значения списка параметров
	 *
	 * @return void
	 */
	private function delete_param()
	{
		$id = intval($_POST['id']);
		if (!empty( $id ))
		{
			DB::query("DELETE FROM {users_param_select} WHERE param_id=%d AND id=%d", $this->diafan->edit, $id);
		}
		$this->diafan->_cache->delete("", $this->diafan->module);
		$this->diafan->_cache->delete("", $this->diafan->rewrite);

		$this->send_json();
	}

	/**
	 * Отдает ответ Ajax
	 *
	 * @return void
	 */
	private function send_json()
	{
		if ($this->result)
		{
			include_once ABSOLUTE_PATH . 'plugins/json.php';
			echo to_json($this->result);
			exit;
		}
	}
}