<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Users_admin
 *
 * Редактирование администраторов сайта
 */
class Users_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'users';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'users';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
				
				//поля в базе данных для редактирования
		$this->variable_table = array(
			'main'=>
				array (
				'fio' => 'text',
				'created' => 'date',
				'act' => 'checkbox',
				'hr1' => 'hr',
				'name' => 'text',
				'password' => 'password',
				'mail' => 'text',
				'param' => 'function',
				'hr2' => 'hr',
				'role_id' => 'select',
				'avatar' => 'function',
				'hr3' => 'hr',
				'subscribtion' => 'function',
				'htmleditor' => 'checkbox',
				)
		);
		
		
		$this->config_module = array(
			'del'	=> 1,	//удалить
			'act'	=> 1,	//показать/скрыть
			'trash' => 1	//использовать корзину
		);
		
		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'name as n',
			'role_id'
		);

		$this->select["role_id"] = array(
			"users_role",
			"id",
			"name",
			"",
			"",
			"trash='0'"
		);

		if (!$this->diafan->_user->admin && ! $this->diafan->addnew && $this->diafan->edit == $this->diafan->_user->id || ! $this->diafan->savenew && $this->diafan->save == $this->diafan->_user->id)
		{
			unset($this->variable_table['role_id']);
			unset($this->variable_table['act']);
		}
	}

	/**
	 * Выводит список пользователей
	 * @return boolean true
	 */
	public function show_module()
	{
        if($this->diafan->error == 2)
        {
            echo '<div class="error">'._LANG_LOGIN_EXISTS.'</div>';
        }

		$this->addnew_init(_ADMIN_USERS_ADD);
		$this->name = 'fio';
		
		$this->list_row();
		

		return true;
	}

	/**
	 * Выводит статус пользователя (на сайте) в списке
	 * 
	 * @return string
	 */
	protected function other_row_nameasn($row)
	{
		return '<td class="nick">'.$row["n"]
		.($this->diafan->_user->id == $row["id"]
		  || DB::query_result("SELECT COUNT(*) FROM {sessions} WHERE timestamp>=%d AND user_id='%d'", (time() - 900), $row["id"])
		 ? ' <font style="color: #ffffff; background-color: red;">'._ADMIN_USERS_ON_SITE.'</font>'
		 : ''
		 );
	}

	/**
	 * Выводит тип пользователя в списке
	 * 
	 * @return string
	 */
	protected function other_row_role_id($row)
	{
		global $roles;
		if (! $roles)
		{
			$roles[0] = '';
			$result = DB::query("SELECT name, id FROM {users_role}");
			while ($role = DB::fetch_array($result))
			{
				$roles[$role["id"]] = $role["name"];
			}
		}
		return '</td><td class="role_id">'.$roles[$row["role_id"]];
	}

	/**
	 * Сохранение поля "Логин"
	 * 
	 * @return boolean true
	 */
	protected function save_name_module()
	{
		$this->query[] = "name='%h'";
		$this->value[] = $this->diafan->translit($_POST["name"]);

		return true;
	}
	
	/**
	 * Редактирование поля "Аватар"
	 * @return boolean true
	 */
	protected function edit_avatar_module()
	{
		if (! $this->diafan->configmodules("avatar", "users"))
			return false;

		echo '
		<tr valign="top">
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>';
		if (!empty($this->values) && file_exists(ABSOLUTE_PATH.'userfiles/avatar/'.$this->values["name"].'.png'))
		{
			echo '<img src="'.BASE_PATH.'userfiles/avatar/'.$this->values["name"].'.png?'.rand(0, 99).'" width="'
			.$this->diafan->configmodules("avatar_width", "users").'" height="'
			.$this->diafan->configmodules("avatar_height", "users").'" alt="'.$this->values["fio"].' ('.$this->values["name"].')">'
			.'<input type="checkbox" name="delete_avatar" value="1"> '._LANG_DELETE
			.'<br><br>';
		}
		echo '
		<input type="file" name="avatar" size="40" class="inptext">'
		.$this->show_help_row().'
			</td>
		</tr>';

		return true;
	}
	
	/**
	 * Сохранение поля "Аватар"
	 * 
	 * @return boolean true
	 */
	protected function save_avatar_module()
	{
		if (! $this->diafan->configmodules("avatar", "users"))
		{
			return false;
		}
		if (! empty($_POST["delete_avatar"]))
		{
			unlink(ABSOLUTE_PATH.USERFILES.'/avatar/'.$this->oldrow["name"].'.png');
		}
		if (isset($_FILES["avatar"]) || is_array($_FILES["avatar"]) && $_FILES["avatar"]['name'] != '')
		{
			list($width, $height) = getimagesize($_FILES["avatar"]['tmp_name']);
			if (! $width || ! $height)
			{
				echo '<script language="javascript" type="text/javascript">alert(\''
				._LANG_AVATAR_INCORRECT_FILE
				.'\');history.go(-1);</script>';
				return false;
			}
			if ($width < $this->diafan->configmodules("avatar_width", "users") || $height < $this->diafan->configmodules("avatar_height", "users"))
			{
				echo '<script language="javascript" type="text/javascript">alert(\''
				.sprintf(_LANG_AVATAR_INCORRECT_SIZE, $this->diafan->configmodules("avatar_width", "users"), $this->diafan->configmodules("avatar_height", "users"))
				.'\');history.go(-1);</script>';
				return false;
			}
			Customization::inc('includes/image.php');
			if (! Image::resize($_FILES["avatar"]['tmp_name'], $this->diafan->configmodules("avatar_width", "users"), $this->diafan->configmodules("avatar_height", "users"), $this->diafan->configmodules("avatar_quality", "users"), true, true))
			{
				echo '<script language="javascript" type="text/javascript">alert(\''
				._LANG_AVATAR_FILE_NO_UPLOAD
				.'\');history.go(-1);</script>';
				return false;
			}
			$dst_img = imageCreateTrueColor($this->diafan->configmodules("avatar_width", "users"), $this->diafan->configmodules("avatar_height", "users"));
			$original  = @imageCreateFromString(file_get_contents($_FILES["avatar"]['tmp_name'])); 
			imageCopy($dst_img, $original, 0, 0, 0, 0, $this->diafan->configmodules("avatar_width", "users"), $this->diafan->configmodules("avatar_height", "users"));
			imagePNG($dst_img, ABSOLUTE_PATH.USERFILES.'/avatar/'.$this->oldrow["name"].'.png');
		}
		return true;
	}
	
	/**
	 * Редактирование поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$values = array();
		$rvalues = array();
		$result_el = DB::query("SELECT value as rv, [value], param_id FROM {users_param_element} WHERE element_id=%d", $this->diafan->edit);
		while ($row_el = DB::fetch_array($result_el))
		{
			$values[$row_el["param_id"]][]  = $row_el["value"];
			$rvalues[$row_el["param_id"]][] = $row_el["rv"];
		}

		$result = DB::query("SELECT id, name, type FROM {users_param} WHERE trash='0' ORDER BY sort ASC");

		while ($row = DB::fetch_array($result))
		{
			$option = array();
			if (! $this->diafan->addnew && in_array($row["type"], array('select', 'multiple')))
			{
				$result_select = DB::query("SELECT [name], id FROM {users_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
				while ($row_select = DB::fetch_array($result_select))
				{
					$option[] = $row_select;
				}
			}
			if ($row["type"] == 'text' || $row["type"] == 'email')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'date')
            {

                echo '
                <tr>
                    <td align="right">'.$row["name"].'</td>
                    <td>
                        <input type="text" id="param'.$row["id"].'" name="param'.$row["id"].'" size="20" value="'
                        .(! empty($rvalues[$row["id"]]) ? $this->diafan->formate_from_date($rvalues[$row["id"]][0]): '')
                    .'" class="timecalendar" showTime="false">
                    </td>
                </tr>';
            }

            elseif ($row["type"] == 'datetime')
            {
                echo '
                <tr>
                    <td align="right">'.$row["name"].'</td>
                    <td>
                        <input type="text" id="param'.$row["id"].'" name="param'.$row["id"].'" size="20" value="'
                        .(! empty($rvalues[$row["id"]]) ? $this->diafan->formate_from_datetime($rvalues[$row["id"]][0]) : '')
                    .'" class="timecalendar" showTime="true">
                    </td>
                </tr>';
            }
			elseif ($row["type"] == 'numtext')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="20" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'" class="inpnum">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'textarea')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<textarea name="param'.$row["id"].'" cols="60" rows="5">'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'</textarea>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'checkbox')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="checkbox" name="param'.$row["id"].'" value="1"'
						.(! $this->diafan->addnew && ! empty($values[$row["id"]]) ? " checked":'').'>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'select')
			{
				$value = (! empty($rvalues[$row["id"]][0]) ? $rvalues[$row["id"]][0] : '');
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<select name="param'.$row["id"].'">
						<option value="">-</option>';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.($value == $select["id"] ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'multiple')
			{
				$value = (! empty($rvalues[$row["id"]]) ? $rvalues[$row["id"]] : array());
				echo '
				<tr>
					<td align="right">
						'.$row["name"].'
					</td>
					<td>
						<select name="param'.$row["id"].'[]" multiple="multiple">';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.(in_array($select["id"], $value) ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
		}
		return true;
	}
	
	/**
	 * Сохранение поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		$ids = array();
		$result = DB::query("SELECT id, name, type FROM {users_param} WHERE trash='0' ORDER BY sort ASC");

		while ($row = DB::fetch_array($result))
		{
			if ($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {users_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				if (! empty($_POST['param'.$row["id"]]) && is_array($_POST['param'.$row["id"]]))
				{
					foreach ($_POST['param'.$row["id"]] as $v)
					{
						DB::query(
							"INSERT INTO {users_param_element} (value, param_id, element_id) VALUES ('%s', %d, %d)",
							$v,
							$row["id"],
							$this->diafan->save
						);
					}
				}
				
			}
			elseif (! empty($_POST['param'.$row["id"]]))
			{
				$id = 0;
				if (! $this->diafan->savenew)
				{
					$id = DB::query_result("SELECT id FROM {users_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				}
				if ($row["type"] == "date")
                {
                    $_POST['param'.$row["id"]] = $this->diafan->formate_in_date($_POST['param'.$row["id"]]);
                }
                if ($row["type"] == "datetime")
                {
                    $_POST['param'.$row["id"]] = $this->diafan->formate_in_datetime($_POST['param'.$row["id"]]);
                }
				if ($id)
				{
					DB::query(
						"UPDATE {users_param_element} SET ".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						."='%s' WHERE id=%d",
						$_POST['param'.$row["id"]],
						$id
					);
					DB::query("DELETE FROM {users_param_element} WHERE param_id=%d AND element_id=%d AND id<>%d", $row["id"], $this->diafan->save, $id);
				}
				else
				{
					DB::query(
						"INSERT INTO {users_param_element} (".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						.", param_id, element_id) VALUES ('%s', %d, %d)",
						$_POST['param'.$row["id"]],
						$row["id"],
						$this->diafan->save
					);
				}
			}
			$ids[] = $row["id"];
		}
		DB::query("DELETE FROM {users_param_element} WHERE param_id NOT IN (".implode(", ", $ids).") AND element_id=%d", $this->diafan->save);
		return true;
	}
	
	/**
	 * Редактирование поля "Подписан на рассылки"
	 * @return boolean true
	 */
	protected function edit_subscribtion_module()
	{
		if (! $this->diafan->configmodules("cat", "subscribtion"))
			return false;

		echo '
		<tr valign="top">
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>';
		$this->parent_id_subscribtion_module_registration(0, '', array(), $this->value);
		echo $this->show_help_row().'
			</td>
		</tr>';

		return true;
	}
	
	/**
	 * Формирует список рассылок
	 * @return array
	 */
	private function parent_id_subscribtion_module_registration($parent_id, $rew, $array, $subscribtion)
	{
		$result = DB::query("SELECT name,id FROM {subscribtion_category} WHERE parent_id='%d' AND trash='0'", $parent_id);
		while ($row = DB::fetch_array($result))
		{
			echo $rew.'<input type="checkbox" name="subscribtion[]" value="'.$row["id"].'"'
			.(! strstr($subscribtion, ' '.$row["id"].' ') ? ' checked' : '')
			.'> '.$row["name"].'<br>';
			if (in_array($row["id"], $array))
			{
				return $array;
			}
			$array[] = $row["id"];
			$array = $this->parent_id_subscribtion_module_registration($row["id"], '&nbsp;&nbsp;&nbsp;'.$rew, $array, $subscribtion);
		}
		return $array;
	}
	
	/**
	 * Сохранение поля "Список рассылок"
	 * @return boolean
	 */
	protected function save_subscribtion_module()
	{
		if (! $this->diafan->configmodules("cat", "subscribtion"))
			return false;

		$array = array();
		$result = DB::query("SELECT id FROM {subscribtion_category} WHERE trash='0'");
		while ($row = DB::fetch_array($result))
		{
			if (empty($_POST["subscribtion"]) || ! in_array($row["id"], $_POST["subscribtion"]))
			{
				$array[] = $row["id"];
			}
		}
		$cats = '0 '.implode("  ", $array).' 0';
		$this->query[] = "subscribtion='%s'";
		$this->value[] = $cats;

		return true;
	}
}
