<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Users_admin_role
 *
 * Редактирование права администраторов
 */
class Users_admin_role extends Frame_admin
{

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'usersrole';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'users_role';
    private $admin_variable_roles = array(
	_ADMIN_USERSROLE_INIT => 'init',
	_ADMIN_USERSROLE_EDIT => 'edit',
	_ADMIN_USERSROLE_DEL => 'del'
    );
    private $user_variable_roles;
    private $user_variable_names;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
		'main'=>
				array (
				'name' => 'text',
				'perm' => 'function',
				)
		);

		$this->config_module = array(
			'del' => 1, //удалить
			'trash' => 1 //использовать корзину
		);
    }

    /**
     * Выводит список типов пользователей
     * @return boolean TRUE
     */
    public function show_module()
    {
		$this->addnew_init(_ADMIN_USERSROLE_ADD);

		$this->list_row();

		return TRUE;
    }

    protected function edit_perm_module()
    {
		echo '<tr><td colspan="2">
			<script src="'.BASE_PATH.'modules/users/admin/users.admin.role.js"></script>
		<div id="tabs">
		<ul>
			<li><a href="#tabs-admin">'._ADMIN_USERSROLE_ADMIN.'</a></li>
			<li><a href="#tabs-site">'._ADMIN_USERSROLE_SITE.'</a></li>	
		</ul>
		<div id="tabs-admin">';
		$this->table_admin_roles();
		echo '</div>
		<div id="tabs-site">';
		$this->table_site_roles();
		echo '</div>
		</div>
		<input type="hidden" name="type" id="type" value="admin">
		</td></tr>';
		return TRUE;
    }

    private function table_admin_roles()
    {
		$variable_roles = $this->admin_variable_roles;

		echo '<table class="border"><tr id="tr_first"><td>&nbsp;';
		foreach ($variable_roles as $key => $v)
		{
			echo '</td><td>'.$key.'<br><input type="checkbox" name="check_all_role" value="'.$v.'">';
		}
		echo '</td></tr>';

		$rewrites = array();
		$all_roles=(bool)DB::query_result("SELECT id FROM {users_role_perm} WHERE role_id=%d AND type='admin' AND rewrite='all' AND perm='all' LIMIT 1",$this->diafan->edit);
		$result = DB::query("SELECT id, name, rewrite FROM {adminsite} WHERE parent_id=0 ORDER BY sort ASC");
		while ($row = DB::fetch_array($result))
		{
			$rewrites[] = $row['rewrite'];
			if(!$all_roles) {
			$roles = explode(',', DB::query_result("SELECT perm FROM {users_role_perm} WHERE role_id='%d' AND rewrite='%s' AND type='admin' LIMIT 1", $this->diafan->edit, $row['rewrite']));
			}
			else
			{
			$roles=array('all');
			}
			echo '<tr><td align="right"><b>'.$row["name"].'</b>';
			foreach ($variable_roles as $v)
			{

			echo '</td><td><input type="checkbox" name="'.$v.'[]" value="'.$row["id"].'" class="checkbox checkbox_'.$v.'"';
			if (!$this->diafan->addnew)
			{
				if ($roles[0] == 'all' || in_array($v, $roles))
				echo " checked";
			}
			echo '>';
			}
			echo '</td></tr>';

			$result2 = DB::query("SELECT id, name, rewrite FROM {adminsite} WHERE parent_id='".$row["id"]."' ORDER BY sort ASC");
			while ($row2 = DB::fetch_array($result2))
			{
			if (in_array($row2["rewrite"], $rewrites))
				continue;

			$rewrites[] = $row2["rewrite"];
			if(!$all_roles) {
			$roles = explode(',', DB::query_result("SELECT perm FROM {users_role_perm} WHERE role_id='%d' AND rewrite='%s' AND type='admin' LIMIT 1", $this->diafan->edit, $row2['rewrite']));
			}
			else
			{
				$roles=array('all');
			}
			echo '<tr><td align="right">'.$row2["name"];
			foreach ($variable_roles as $v)
			{

				echo '</td><td><input type="checkbox" name="'.$v.'[]" value="'.$row2["id"].'" class="checkbox checkbox_'.$v.'"';
				if (!$this->diafan->addnew)
				{
				if ($roles[0] == 'all' || in_array($v, $roles))
					echo " checked";
				}
				echo '>';
			}
			echo '</td></tr>';
			}
		}
		echo '</table>';
    }

    private function get_user_roles()
    {
		if ($dir = opendir(ABSOLUTE_PATH."modules"))
		{
			$this->user_variable_names = array();
			while (($file = readdir($dir)) !== FALSE)
			{
				if (!$file != '.' && $file != '..' && $file != 'users' && (file_exists(ABSOLUTE_PATH.'modules/'.$file.'/admin/'.$file.'.admin.role.php')))
				{
					$const = strtoupper('_LANG_'.$file);
					$this->user_variable_names[$file] = (defined($const) ? constant($const) : $file);

					Customization::inc('modules/'.$file.'/admin/'.$file.'.admin.role.php');
					$class_name = ucfirst($file).'_admin_role';
					$module = new $class_name($this);
					$this->user_variable_roles[$file] = $module->get_rules();
					unset($module);
				}
			}
			closedir($dir);
		}
    }

    private function table_site_roles()
    {
		$this->get_user_roles();

		$values = array();
		$res = DB::query('SELECT rewrite,perm FROM {users_role_perm} WHERE role_id=%d AND type="site"', $this->diafan->edit);
		while ($row = DB::fetch_array($res))
		{
			$values[$row['rewrite']] = explode(',', $row['perm']);
		}

		echo '<table class="border">';
		foreach ($this->user_variable_roles as $module => $roles)
		{
			echo '<tr><td><b>'.$this->user_variable_names[$module].'</b></td><td>';

			foreach ($roles as $name => $title)
			{
				echo '<input type="checkbox" name="'.$module.'[]" value="'.$name.'"'.(!empty($values[$module]) && in_array($name, $values[$module]) ? 'checked' : '').'> '.$title.'<br/>';
			}

			echo '</td></tr>';
		}
		echo '</table>';
    }

    /**
     * Сохранение поля "Права доступа"
     * @return boolean TRUE
     */
    protected function save_perm_module()
    {
		DB::query("DELETE FROM {users_role_perm} WHERE role_id=%d AND type='%s'", $this->diafan->save, $_POST['type']);
		if ($_POST['type'] == 'admin')
		{
			$perm = array();
			$count = count($this->admin_variable_roles);
			$count_rewrite = 0;
			$result = DB::query("SELECT id, rewrite FROM {adminsite}");
			while ($row = DB::fetch_array($result))
			{
				$count_rewrite++;
				$i = 0;
				foreach ($this->admin_variable_roles as $v)
				{
					if (!empty($_POST[$v]) && in_array($row["id"], $_POST[$v]))
					{
						$perm[$row["rewrite"]][] = $v;
						$i++;
					}
				}
				if ($i > 0)
				{
					if ($i == $count)
					{
						$perm[$row["rewrite"]] = 'all';
					}
					else
					{
						$perm[$row["rewrite"]] = implode(',', $perm[$row["rewrite"]]);
					}

					DB::query("INSERT INTO {users_role_perm} (rewrite, perm, role_id, type) VALUES ('%s', '%s', %d, '%s')", $row['rewrite'], $perm[$row["rewrite"]], $this->diafan->save, $_POST['type']);
				}
			}

			if (!empty($perm) && $count_rewrite == count($perm))
			{
				DB::query("DELETE FROM {users_role_perm} WHERE role_id=%d AND type='%s'", $this->diafan->save, $_POST['type']);
				DB::query("INSERT INTO {users_role_perm} (rewrite, perm, role_id, type) VALUES ('all', 'all', %d, '%s')", $this->diafan->save, $_POST['type']);
			}
		}

		if ($_POST['type'] == 'site')
		{
			$this->get_user_roles();
			foreach ($this->user_variable_roles as $module => $roles)
			{
			if (!empty($_POST[$module]))
			{
				$perm = implode(',', $_POST[$module]);
				DB::query("INSERT INTO {users_role_perm} (rewrite,perm,role_id,type) VALUES ('%s','%s',%d,'%s')", $module, $perm, $this->diafan->save, $_POST['type']);
			}
			}
		}
		return TRUE;
    }

}