<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Votes_inc
 *
 * Подключение модуля "Голосование"
 */
class Votes_inc extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	public $result;

	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;
	}

	/**
	 * Выводит подключенные к странице опросы
	 * 
	 * @param integer $id номер опроса
	 * @return void
	 */
	public function votes_show_votes($id = 0)
	{
		if ($this->diafan->configmodules('security_user', 'votes') && ! $this->diafan->_user->id)
			return false;
		
		if (! $id && ! $this->diafan->configmodules('order', 'votes'))
		{
			$max_count = DB::query_result("SELECT COUNT(id) FROM {votes_category} WHERE [act]='1' AND trash='0'"
						      ." AND (site_id='%d' OR site_id='0')", $this->diafan->cid);
			$rand = rand(0, $max_count - 1);
		}

		$result_question = DB::query("SELECT id, [name] FROM {votes_category} WHERE [act]='1' AND trash='0'"
					     ." AND (site_id='%d' OR site_id='0')"
					     .($id
					       ? " AND id=".$id
					       : ($this->diafan->configmodules('order','votes')
						  ? " ORDER BY sort ASC"
						  : " LIMIT ".$rand.", 1"
						  )
					       ),
					     $this->diafan->cid);
		$rows = array();
		while ($row = DB::fetch_array($result_question))
		{
			$result = array();
			$result["question_id"] = $row["id"];
			if ($this->check_log($row["id"]))
			{
				$result_answer = DB::query("SELECT id, [name] FROM {votes} WHERE trash='0' AND cat_id='%d' ORDER BY sort ASC", $row["id"]);
				while ($row_answers = DB::fetch_array($result_answer))
				{
					$row_answer = array();
					$row_answer["id"] = $row_answers["id"];
					$row_answer["name"] = $this->diafan->_useradmin->get($row_answers["name"], 'name', $row_answers["id"], 'votes', _LANG);
					$result["answers"][] = $row_answer;
				}
				$result["captcha"] = '';
				if ($this->diafan->configmodules('security', 'votes') == 2)
				{
					$result["captcha"] = $this->diafan->_captcha->get("votes".$row["id"], $this->get_error("votes".$row["id"], "code"));
				}
				$result["answers"] = $this->diafan->_tpl->get('form', 'votes', $result);
			}
			else
			{
				$sum_votes = DB::query_result("SELECT SUM(count_votes) FROM {votes} WHERE trash='0' AND cat_id='%d'", $row["id"]);

				$result_answer = DB::query("SELECT [name], count_votes FROM {votes} WHERE trash='0' AND cat_id='%d' ORDER BY sort ASC", $row["id"]);
				while ($row_answer = DB::fetch_array($result_answer))
				{
					$ra["count"]   = $row_answer["count_votes"];
					$ra["persent"] = $sum_votes ? round($row_answer["count_votes"] / $sum_votes * 100) : 0;
					$ra["name"]    = $row_answer["name"];
					$result["answers"][] = $ra;
				}
	
				$result["summ"] = $sum_votes;
				$result["answers"] = $this->diafan->_tpl->get('answers', 'votes', $result);
			}
			$result["question"] = $this->diafan->_useradmin->get($row["name"], 'name', $row["id"], 'votes_category', _LANG);
			$result["error"] = $this->get_error("votes".$row["id"]);
			$rows[] = $result;
		}
		$this->diafan->_tpl->get('show', 'votes', $rows);

		return true;
	}

	/**
	 * Проверяет доступ к голосованию
	 * 
	 * @return boolean
	 */
	private function check_log($id)
	{
		if ($this->diafan->configmodules('security_user', 'votes') && ! $this->diafan->_user->id)
		{
			return false;
		}
		if ($this->diafan->configmodules('security','votes') == 3)
		{
			if (DB::query_result("SELECT COUNT(id) FROM {log_note} WHERE session_id='%s' AND element_id='%d' AND include_name='votes'",
			                    $this->diafan->configmodules('security_user', 'votes') ? $this->diafan->_user->id : session_id(), $id))
			{
				return false;
			}
		}
		elseif ($this->diafan->configmodules('security', 'votes') == 4)
		{
			if (! empty($_SESSION["votes"][$id]))
			{
				return false;
			}
		}
		return true;
	}
}