<?php /**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

define('DIAFAN', 1);
include_once dirname(__FILE__)."/config.php";
define('ABSOLUTE_PATH', dirname(__FILE__).'/');

$fileperms = substr ( decoct ( fileperms ( dirname(__FILE__)."/config.php") ), 3, 6 );


if($fileperms != "777")
{
	exit('Установите права 777 для config.php');
}


if (!defined('VERSION_CMS') || VERSION_CMS != '4.5')
{
	exit('Обновление работает только для версии 4.5');
}

if(file_exists(ABSOLUTE_PATH.'installation/core.php'))
{
    $info = file_get_contents(ABSOLUTE_PATH.'installation/core.php', NULL, NULL, 0, 7*50);
    if(!preg_match("/version.*5\.0/", $info))
    {
		exit('Скопируйте файл /installation/core.php из пакета 5 версии diafan.CMS');
    }
}
else
{
    exit('Отсутвует файл '.ABSOLUTE_PATH.'/installation/core.php, скопируйте его из пакета 5 версии diafan.CMS');
}

define('IS_ADMIN', 1);
define('IS_INSTALL', 1);

include_once ABSOLUTE_PATH.'includes/customization.php';
include_once(ABSOLUTE_PATH.'includes/gzip.php');
include_once(ABSOLUTE_PATH.'includes/developer.php');

$dev = new Dev;
$dev->set_error();

if(! defined('CACHE_MEMCACHED'))
{
	define('CACHE_MEMCACHED', false);
}
define("VERSION", "5.0");
define("D_UPDATE", 1346325540);


include_once ABSOLUTE_PATH.'includes/function.php';
include_once(ABSOLUTE_PATH.'includes/http.php');
include_once(ABSOLUTE_PATH.'includes/https.php');
include_once(ABSOLUTE_PATH.'includes/xml.php');
include_once(ABSOLUTE_PATH.'includes/core.php');
include_once(ABSOLUTE_PATH.'includes/database.php');
include_once ABSOLUTE_PATH.'includes/init.php';
$diafan = new Init();

$language = array();
$result = DB::query("SELECT id FROM {language}");
while ($row = DB::fetch_array($result))
{
    $language[] = $row["id"] != 1 ? $row["id"] : '';
}

// объеденены пользователи сайта и пользователи панели администрирования
DB::query("ALTER TABLE {users_site} ADD `role_id` int(11) unsigned NOT NULL");
DB::query("CREATE TABLE {users_role_perm} (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `role_id` SMALLINT(5) unsigned NOT NULL,
  `perm` text CHARACTER SET utf8 NOT NULL,
  `rewrite` text CHARACTER SET utf8 NOT NULL,
  `type` enum('site','admin') CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) CHARSET=utf8 ;");

// формирует массив всех установленных модулей
$adminsite_rewrite = array();
$result = DB::query("SELECT rewrite FROM {adminsite}");
while ($row = DB::fetch_array($result))
{
	$adminsite_rewrite[] = $row['rewrite'];
}

// формирует массив всех ролей, переносит права в отдельную таблицу
$roles = array();
$result = DB::query("SELECT * FROM {users_role} WHERE trash='0'");
while ($row = DB::fetch_array($result))
{
	$roles[] = $row['id'];

	$perm = explode(',', $row["perm"]);
	if(in_array('admin all', $perm))
	{
		DB::query("INSERT INTO {users_role_perm} (role_id, perm, rewrite, type) VALUES (%d, 'all', 'all', 'admin')", $row["id"]);
	}
	else
	{
		foreach($adminsite_rewrite as $module_name)
		{
			if(in_array('admin '.$module_name.' all', $perm))
			{
				DB::query("INSERT INTO {users_role_perm} (role_id, perm, rewrite, type) VALUES (%d, 'all', '%s', 'admin')", $row["id"], $module_name);
			}
			else
			{
				if(in_array('admin '.$module_name.' init', $perm) || in_array('admin '.$module_name.' edit', $perm))
				{
					DB::query("INSERT INTO {users_role_perm} (role_id, perm, rewrite, type) VALUES (%d, 'init', '%s', 'admin')", $row["id"], $module_name);
				}
				if(in_array('admin '.$module_name.' save', $perm) || in_array('admin '.$module_name.' addnew', $perm) || in_array('admin '.$module_name.' act', $perm) || in_array('admin '.$module_name.' order', $perm))
				{
					DB::query("INSERT INTO {users_role_perm} (role_id, perm, rewrite, type) VALUES (%d, 'edit', '%s', 'admin')", $row["id"], $module_name);
				}
				if(in_array('admin '.$module_name.' del', $perm))
				{
					DB::query("INSERT INTO {users_role_perm} (role_id, perm, rewrite, type) VALUES (%d, 'del', '%s', 'admin')", $row["id"], $module_name);
				}
			}
		}
	}
}

// переносит модераторов форума
if(in_array('forum', $adminsite_rewrite))
{
	DB::query("INSERT INTO {users_role} (name) VALUES ('Модератор форума')");
	$role_id = DB::last_id("users_role");
	DB::query("INSERT INTO {users_role_perm} (role_id, perm, rewrite, type) VALUES (%d, 'moderator', 'forum', 'site')", $role_id);
	DB::query("UPDATE {users_site} SET role_id=%d WHERE moderator='1'", $role_id);
}

// объединяет пользователей сайта и админки
$result = DB::query("SELECT * FROM {users} WHERE trash='0'");
while ($row = DB::fetch_array($result))
{
	DB::query("INSERT INTO {users_site} (name, password, created, fio, act, role_id) VALUES ('%s', '%s', %d, '%s', '%d', %d)",
			  $row["name"], $row["password"], $row["created"], $row["fio"], $row["act"], $row["role_id"]);
	$user_id = DB::last_id("users_site");
	DB::query("UPDATE {trash} SET user_id=%d WHERE user_id=%d", $user_id, $row["id"]);
}

// переносит типы пользователей для скидки в роли
if(in_array('shop', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {shop_discount} ADD `role_id` int(11) unsigned NOT NULL");
	$result = DB::query("SELECT * FROM {shop_discount_type}");
	while ($row = DB::fetch_array($result))
	{
		DB::query("INSERT INTO {users_role} (name) VALUES ('%s')", $row["name"]);
		$role_id = DB::last_id("users_role");
		DB::query("UPDATE {users_site} SET role_id=%d WHERE discount_type=%d AND role_id=0", $role_id, $row["id"]);
		DB::query("UPDATE {shop_discount} SET role_id=%d WHERE type=%d", $role_id, $row["id"]);
	}
	DB::query("DROP TABLE {shop_discount_type} ;");
	DB::query("ALTER TABLE {shop_discount} DROP `type`");
}

if(DB::query_result("SHOW TABLES LIKE '{users_site}'"))
{
	DB::query("DROP TABLE {users} ;");
	DB::query("ALTER TABLE {users_site} DROP `moderator`, DROP `discount_type`");
	DB::query("RENAME TABLE {users_site} TO {users} ;");
	DB::query("ALTER TABLE {users_role} DROP `perm`");
	DB::query("UPDATE {config} SET module_name='users' WHERE module_name='usersite'");
	
	if(in_array('usersite', $adminsite_rewrite))
	{
		DB::query("RENAME TABLE {usersite_actlink} TO {users_actlink} ;");
		DB::query("RENAME TABLE {usersite_param} TO {users_param} ;");
		DB::query("RENAME TABLE {usersite_param_element} TO {users_param_element} ;");
		DB::query("RENAME TABLE {usersite_param_select} TO {users_param_select} ;");
	}
	else
	{
		DB::query("CREATE TABLE {users_param} (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("`nameLANG` VARCHAR(250) NOT NULL DEFAULT '',")."
		".multilang("`textLANG` text NOT NULL,")."
		`type` VARCHAR(20) NOT NULL DEFAULT '',
		`form` ENUM('none', 'form', 'reg', 'user') NOT NULL DEFAULT 'none',
		`sort` INT(11) UNSIGNED NOT NULL DEFAULT '0',
		`required` ENUM('0', '1') NOT NULL DEFAULT '0',
		`trash` ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (`id`)
		) CHARSET=utf8");
	
		DB::query("CREATE TABLE {users_param_element} (
		`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
		`value` text NOT NULL,
		`param_id` int(11) unsigned NOT NULL DEFAULT '0',
		`element_id` int(11) unsigned NOT NULL DEFAULT '0',
		`trash` enum('0','1') NOT NULL DEFAULT '0',
		PRIMARY KEY (`id`) ) CHARSET=utf8");
	
		DB::query("CREATE TABLE {users_param_select} (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`param_id` INT(11) UNSIGNED NOT NULL DEFAULT '0',
		`value` TINYINT(2) UNSIGNED NOT NULL DEFAULT '0',
		".multilang("`nameLANG` VARCHAR(50) NOT NULL DEFAULT '',")."
		`sort` INT(11) UNSIGNED NOT NULL DEFAULT '0',
		`trash` ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (`id`),
		KEY param_id (`param_id`)
		) CHARSET=utf8");
	}
}

// добавлена индексация в модуле Поиск
DB::query("CREATE TABLE {search_results} (
`id` int(11) unsigned NOT NULL auto_increment,
`name` varchar(255) NOT NULL,
`url` varchar(255) NOT NULL,
`snippet` varchar(255) NOT NULL,
`element_id` int(11) unsigned NOT NULL,
`module` varchar(50) NOT NULL,
`lang_id` int(1) NOT NULL,
`rating` int(5) unsigned NOT NULL,
PRIMARY KEY  (`id`)
)  DEFAULT CHARSET=utf8  ;");

DB::query("CREATE TABLE {search_keywords} (
`id` int(11) unsigned NOT NULL auto_increment,
`keyword` varchar(255) NOT NULL,
PRIMARY KEY  (`id`)
)  DEFAULT CHARSET=utf8  ;");

DB::query("CREATE TABLE {search_index} (
`id` int(11) unsigned NOT NULL auto_increment,
`keyword_id` int(11) unsigned NOT NULL,
`result_id` int(11) unsigned NOT NULL,
PRIMARY KEY  (`id`)
)  DEFAULT CHARSET=utf8 ;");

$adminsite_rewrite[] = 'search';

// JS код для страниц сайта
DB::query("ALTER TABLE {site} ADD `js` TEXT NOT NULL");

if(in_array('shop', $adminsite_rewrite))
{
	// Магазин: поля хит, новинка, акция
	DB::query("ALTER TABLE {shop} ADD `hit` enum('0','1') NOT NULL DEFAULT '0'");
	DB::query("ALTER TABLE {shop} ADD `new` enum('0','1') NOT NULL DEFAULT '0'");
	DB::query("ALTER TABLE {shop} ADD `action` enum('0','1') NOT NULL DEFAULT '0'");

	// Магазин: товар - файл
	DB::query("ALTER TABLE {shop} ADD `is_file` enum('0','1') NOT NULL DEFAULT '0'");
	if (! is_dir(ABSOLUTE_PATH.USERFILES.'/shop/files'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/shop/files', 0777);
	}
	$text = 'Options -Indexes
<files *>
deny from all
</files>';
	$fp = fopen(ABSOLUTE_PATH.USERFILES.'/shop/files/.htaccess', "w");
	fwrite($fp, $text);
	fclose($fp);

	// Магазин: сортировка товаров по дополнительным характеристикам
	DB::query("ALTER TABLE {shop_param} ADD `display_in_sort` enum('0','1') NOT NULL DEFAULT '0'");

	// Магазин: единица измерения для дополнительных характеристик
	foreach ($language as $lang_id)
	{
		DB::query("ALTER TABLE {shop_param} ADD `measure_unit".$lang_id."` varchar(50) NOT NULL");
	}
}

// В конструкторах модулей изменен формат даты
DB::query("UPDATE {users_param} SET type='datetime' WHERE type='date'");
if(in_array('comments', $adminsite_rewrite))
{
	DB::query("UPDATE {comments_param} SET type='datetime' WHERE type='date'");
}
if(in_array('feedback', $adminsite_rewrite))
{
	DB::query("UPDATE {feedback_param} SET type='datetime' WHERE type='date'");
}
if(in_array('shop', $adminsite_rewrite))
{
	DB::query("UPDATE {shop_order_param} SET type='datetime' WHERE type='date'");
	DB::query("UPDATE {shop_param} SET type='datetime' WHERE type='date'");
}

//Приведим все значения параметров с датой к формату гггг-мм-дд чч:мм
$modules_whith_params = array('users', 'comments', 'feedback', 'shop_order','shop');
foreach($modules_whith_params as $module)
{
	if(in_array($module, $adminsite_rewrite))
	{
		$result = DB::query("SELECT e.id, e.value FROM {".$module."_param_element} AS e INNER JOIN
		{".$module."_param} AS p ON e.param_id=p.id WHERE p.type='datetime'");

		while($row = DB::fetch_array($result))
		{

			DB::query("UPDATE {".$module."_param_element} SET value='%s' WHERE id=%d", 
					date('Y-m-d H:i', $row['value']), $row['id']);
		}
	}
}

// Доступ для страниц, элеметнов и категорий модуля для отдельных ролей
DB::query("CREATE TABLE {access} (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `element_id` int(11) unsigned NOT NULL DEFAULT '0',
  `cat_id` int(11) unsigned NOT NULL DEFAULT '0',
  `module_name` varchar(25) NOT NULL,
  `role_id` int(3) unsigned NOT NULL DEFAULT '0',
  `trash` ENUM('0', '1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) CHARSET=utf8");

if(in_array('news', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {news} ADD `access` ENUM( '0', '1' ) NOT NULL");
	DB::query("ALTER TABLE {news_category} ADD `access` ENUM( '0', '1' ) NOT NULL");
}
if(in_array('clauses', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {clauses} ADD `access` ENUM( '0', '1' ) NOT NULL");
	DB::query("ALTER TABLE {clauses_category} ADD `access` ENUM( '0', '1' ) NOT NULL");
}
if(in_array('faq', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {faq} ADD `access` ENUM( '0', '1' ) NOT NULL");
	DB::query("ALTER TABLE {faq_category} ADD `access` ENUM( '0', '1' ) NOT NULL");
}
if(in_array('shop', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {shop} ADD `access` ENUM( '0', '1' ) NOT NULL");
	DB::query("ALTER TABLE {shop_category} ADD `access` ENUM( '0', '1' ) NOT NULL");
}
if(in_array('photo', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {photo} ADD `access` ENUM( '0', '1' ) NOT NULL");
	DB::query("ALTER TABLE {photo_category} ADD `access` ENUM( '0', '1' ) NOT NULL");
}
if(in_array('files', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {files} ADD `access` ENUM( '0', '1' ) NOT NULL");
	DB::query("ALTER TABLE {files_category} ADD `access` ENUM( '0', '1' ) NOT NULL");
}
DB::query("ALTER TABLE {menu_category} ADD `access` ENUM( '0', '1' ) NOT NULL");


// Изменяем формат ограничения доступа к страницам сайта
$result = DB::query("SELECT id FROM {site} WHERE access='1'");
while ($row = DB::fetch_array($result))
{
	foreach($roles as $role_id)
	{
		DB::query("INSERT INTO {access} (element_id, module_name, role_id) VALUES (%d, 'site', %d)", $row["id"], $role_id);
	}
}

// Упрощена настройка "Защита от спама" в модуле Форма обратной связи
if(in_array('feedback', $adminsite_rewrite))
{
	$result = DB::query("SELECT value, id, site_id FROM {config} WHERE module_name='feedback' AND name='security'");
	while ($row = DB::fetch_array($result))
	{
		switch($row["value"])
		{
			case '1':
				DB::query("DELETE FROM {config} WHERE id=%d", $row["id"]);
				if($row["site_id"])
				{
					$site_id = $row["site_id"];
				}
				else
				{
					$site_id = DB::query_result("SELECT id FROM {site} WHERE addmodule='feedback'");
				}
				if($site_id)
				{
					DB::query("UPDATE {site} SET access='1' WHERE id=%d", $site_id);
					foreach($roles as $role_id)
					{
						DB::query("INSERT INTO {access} (element_id, module_name, role_id) VALUES (%d, 'site', %d)", $site_id, $role_id);
					}
				}
				break;

			case '2':
				DB::query("UPDATE {config} SET value='1' WHERE id=%d", $row["id"]);
				break;
		}
	}
}
if(in_array('shop', $adminsite_rewrite))
{
	//прикрепление общих характеристик к нескольким разделам
	DB::query("ALTER TABLE {shop_param}  DROP  `site_id`");

	//характеристик, влияющих на цену может быть несколько
	DB::query("CREATE TABLE {shop_price_param} (
		`id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT,
		`price_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		`param_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		`param_value` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		PRIMARY KEY (`id`)
		) CHARSET=utf8");

	$result = DB::query("SELECT * FROM {shop_price}");
	while($row = DB::fetch_array($result))
	{
		if($row["param_id"] && $row["param_value"])
		{
			DB::query("INSERT INTO {shop_price_param} (price_id, param_id, param_value) VALUES (%d, %d, %d)", $row["id"], $row["param_id"], $row["param_value"]);
		}
	}
	DB::query("ALTER TABLE {shop_price} DROP param_id, DROP param_value");

	// добавляем характеристики в цены для всех товаров, которые затрагивают характеристики, влияющие на цену
	$result = DB::query("SELECT * FROM {shop_param} WHERE type='multiple' AND required='1' AND trash='0'");
	while($row = DB::fetch_array($result))
	{
		$row["cats"] = array();
		$result_c = DB::query("SELECT cat_id FROM {shop_param_category_rel} WHERE element_id=%d AND trash='0'", $row["id"]);
		while($row_c = DB::fetch_array($result_c))
		{
			$row["cats"][] = $row_c["cat_id"];
		}
		$row["first_val"] = DB::query_result("SELECT id FROM {shop_param_select} WHERE param_id=%d AND trash='0'",  $row["id"]);
		if($row["cats"])
		{
			$result_s = DB::query("SELECT s.id FROM {shop} AS s INNER JOIN {shop_category_rel} AS c ON c.element_id=s.id WHERE c.cat_id IN (%s) AND s.trash='0' AND c.trash='0'", implode(",", $row["cats"]));
			while($row_s = DB::fetch_array($result_s))
			{
				$result_p = DB::query("SELECT * FROM {shop_price} WHERE good_id=%d", $row_s["id"]);
				while($row_p = DB::fetch_array($result_p))
				{
					$row_p["params"] = array();
					$result_p_pa = DB::query("SELECT * FROM {shop_price_param} WHERE price_id=%d", $row_p["id"]);
					while($row_p_pa = DB::fetch_array($result_p_pa))
					{
						$row_p["params"][$row_p_pa["param_id"]] = $row_p_pa["param_value"];
					}
					if(empty($row_p["params"][$row["id"]]))
					{
						$insert_param = false;
						$result_pa = DB::query("SELECT value FROM {shop_param_element} WHERE element_id=%d AND param_id=%d", $row_s["id"], $row["id"]);
						while($row_pa = DB::fetch_array($result_pa))
						{
							if($insert_param)
							{
								DB::query("INSERT INTO {shop_price} (good_id, price, count_goods) VALUES (%d, %f, %d)", $row_s["id"], $row_s["price"], $row_s["count_goods"]);
								$price_id = DB::last_id("shop_price");
								DB::query("INSERT INTO {shop_price_param} (param_id, param_value, price_id) VALUES (%d, %d, %d)", $row["id"], $row_pa["value"], $price_id);
								foreach($row_p["params"] as $id => $value)
								{
									DB::query("INSERT INTO {shop_price_param} (param_id, param_value, price_id) VALUES (%d, %d, %d)", $id, $value, $price_id);
								}
							}
							else
							{
								DB::query("INSERT INTO {shop_price_param} (param_id, param_value, price_id) VALUES (%d, %d, %d)", $row["id"], $row_pa["value"], $row_p["id"]);
								$insert_param = true;
							}
						}
						if(!  $insert_param)
						{
							DB::query("INSERT INTO {shop_price_param} (param_id, param_value, price_id) VALUES (%d, %d, %d)", $row["id"], $row["first_val"], $row_p["id"]);
							DB::query("INSERT INTO {shop_param_element} (param_id, value, element_id) VALUES (%d, %d, %d)", $row["id"], $row["first_val"], $row_s["id"]);
						}
					}
				}
			}
		}
	}
	DB::query("UPDATE {shop_param} SET required='1' WHERE id IN (SELECT param_id FROM {shop_price_param})");
}

// Шаблоны для элементов и категорий модулей
if(in_array('shop', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {shop} CHANGE `buy` `counter_buy` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0'");
	DB::query("ALTER TABLE {shop} CHANGE `view` `counter_view` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0'");
	DB::query("ALTER TABLE {shop} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
	DB::query("ALTER TABLE {shop_category} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
}
if(in_array('news', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {news} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
	DB::query("ALTER TABLE {news_category} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
}
if(in_array('clauses', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {clauses} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
	DB::query("ALTER TABLE {clauses_category} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
}
if(in_array('files', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {files} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
	DB::query("ALTER TABLE {files_category} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
}
if(in_array('faq', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {faq} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
	DB::query("ALTER TABLE {faq_category} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
}
if(in_array('photo', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {photo} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
	DB::query("ALTER TABLE {photo_category} ADD `theme` VARCHAR( 50 ) NOT NULL, ADD `view` VARCHAR( 50 ) NOT NULL");
}

// настройка "Использовать визуальный редактор" доступна для каждого администратора
DB::query("ALTER TABLE {users} ADD `htmleditor` ENUM( '0', '1' ) NOT NULL");
if(defined('HTMLEDITOR') && HTMLEDITOR)
{
	DB::query("UPDATE {users} SET htmleditor='1'");
}

// Опция "Текущий пункт меню как ссылка"
DB::query("ALTER TABLE {menu_category} ADD `current_link` ENUM( '0', '1' ) NOT NULL");

// В меню добавлено поле для загрузки изображения
if (! is_dir(ABSOLUTE_PATH.USERFILES.'/menu'))
{
	mkdir(ABSOLUTE_PATH.USERFILES.'/menu', 0777);
}

// Добавлены настройки для генерации ЧПУ
DB::query("INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('route', 'method', '1')");
DB::query("INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('route', 'translit_array', ' |а|б|в|г|д|е|ё|ж|з|и|й|к|л|м|н|о|п|р|с|т|у|ф|х|ц|ч|ш|щ|ы|э|ю|я|А|Б|В|Г|Д|Е|Ё|Ж|З|И|Й|К|Л|М|Н|О|П|Р|С|Т|У|Ф|Х|Ц|Ч|Ш|Щ|Ы|Э|Ю|Я````-|a|b|v|g|d|e|yo|zh|z|i|y|k|l|m|n|o|p|r|s|t|u|f|kh|ts|ch|sh|sch|y|e|yu|ya|A|B|V|G|D|E|YO|ZH|Z|I|Y|K|L|M|N|O|P|R|S|T|U|F|KH|TS|CH|SH|SCH|Y|E|YU|YA')");

if(in_array('shop', $adminsite_rewrite))
{
	// Названия полей и таблиц в магазине приведены к стандарту
	DB::query("ALTER TABLE {shop_param_good} CHANGE `good_id` `order_good_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0'");
	DB::query("RENAME TABLE {shop_param_good} TO {shop_order_goods_param} ;");

	// Изменено формирование цены
	DB::query("ALTER TABLE {shop_price} ADD `price_id`  INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
	ADD `old_price` FLOAT UNSIGNED NOT NULL DEFAULT '0',
	ADD `date_start` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
	ADD `date_finish` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
	ADD `discount_id`  INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
	ADD `discount` FLOAT NOT NULL DEFAULT '0',
	ADD `role_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0'");

	DB::query("UPDATE {shop_price} SET price_id=id");

	$discounts = array();
	$result = DB::query("SELECT * FROM {shop_discount} WHERE act='1'");
	while($row = DB::fetch_array($result))
	{
		if($row["date_finish"] && $row["date_finish"] < time())
		{
			continue;
		}
		$row["objects"] = array();
		$result_object = DB::query("SELECT * FROM {shop_discount_object} WHERE discount_id=%d", $row["id"]);
		while($row_object = DB::fetch_array($result_object))
		{
			$row["objects"][] = $row_object;
		}
		$discounts[] = $row;
	}
	if($discounts)
	{
		$result = DB::query("SELECT p.*, s.cat_id FROM {shop_price} AS p INNER JOIN {shop} AS s ON p.good_id=s.id WHERE p.trash='0'");
		while($row = DB::fetch_array($result))
		{
			foreach($discounts as $d)
			{
				$in_discount = false;
				if(empty($d["objects"][0]) || empty($d["objects"][0]["cat_id"]) && empty($d["objects"][0]["good_id"]))
				{
					$in_discount = true;
				}
				else
				{
					foreach($d["objects"] as $d_o)
					{
						if($d_o["cat_id"] == $row["cat_id"] && $row["cat_id"] || $d_o["good_id"] == $row["good_id"])
						{
							$in_discount = true;
							break;
						}
					}
				}
				if($in_discount)
				{
					$price = $row['price'];
					// скидка действует от суммы
					if ( ! empty($d['amount']) && $price > $d['amount'])
					{
						$price = $price * (100 - $d['discount']) / 100;
					}
					else
					{
						// если не задано
						if (empty($d['amount']))
						{
							$price = $price * (100 - $d['discount']) / 100;
						}
					}
					if ( ! empty($d['deduction']))
					{
						$price -= $d['deduction']; // фиксированная сумма к вычету.  
					}
					if($price != $row["price"])
					{
						DB::query("INSERT INTO {shop_price} (good_id, price, old_price, count_goods, price_id, date_start, date_finish, discount, discount_id, role_id) VALUES (%d, %f, %f, %d, %d, %d, %d, %f, %d, %d)", $row["good_id"], $price, $row["price"], $row["count_goods"], $row["id"], $d["date_start"], $d["date_finish"], $d["discount"], $d["id"], $d["role_id"]);
					}
				}
			}
		}
	}

	$result = DB::query("SELECT * FROM {shop_order_goods} WHERE depend_price > 0");
	while($row = DB::fetch_array($result))
	{
		$param_id = DB::query_result("SELECT param_id FROM {shop_param_select} WHERE id=%d", $row["depend_price"]);
		DB::query("INSERT INTO {shop_order_goods_param} (order_good_id, value, param_id) VALUES ('%d', '%d', '%d')", $row["id"], $row["depend_price"], $param_id);
	}
	DB::query("ALTER TABLE {shop_order_goods} DROP `depend_price`");

	DB::query("DROP TABLE {shop_order_count_goods}");

	// накопительная скидка
	DB::query("ALTER TABLE {shop_discount} ADD `threshold` INT( 11 ) UNSIGNED NOT NULL ");
	DB::query("ALTER TABLE {shop_price} ADD `threshold` INT( 11 ) UNSIGNED NOT NULL ");
	
	// купон на скидку
	DB::query("ALTER TABLE {shop_discount} ADD `coupon` VARCHAR( 10 ) NOT NULL ,
	ADD `user_id` INT( 11 ) UNSIGNED NOT NULL ,
	ADD `count_use` TINYINT( 3 ) UNSIGNED NOT NULL ");
	DB::query("ALTER TABLE {shop_price} ADD `user_id` INT( 11 ) UNSIGNED NOT NULL");

	// цены в иностранной валюте
	DB::query("CREATE TABLE {shop_currency} (
	`id` SMALLINT(5) UNSIGNED NOT NULL AUTO_INCREMENT,
	`name` VARCHAR(20) NOT NULL DEFAULT '',
	`exchange_rate` FLOAT NOT NULL default '0',
	`trash` ENUM('0', '1') NOT NULL DEFAULT '0',
	PRIMARY KEY  (`id`)
	) CHARSET=utf8");
	DB::query("ALTER TABLE {shop_price} ADD `currency_id` SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0'");
	DB::query("CREATE TABLE {shop_additional_cost} (
		`id` SMALLINT(5) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("`nameLANG` VARCHAR(50) NOT NULL DEFAULT '',")."
		".multilang("`textLANG` TEXT NOT NULL,")."
		".multilang("`actLANG` ENUM('0', '1') NOT NULL default '0',")."
		`percent` FLOAT NOT NULL default '0',
		`price` FLOAT NOT NULL default '0',
		`amount` FLOAT NOT NULL default '0',
		`required` ENUM('0', '1') NOT NULL DEFAULT '0',
		`sort` INT(11) UNSIGNED NOT NULL default '0',
		`trash` ENUM('0', '1') NOT NULL default '0',
		PRIMARY KEY  (`id`)
	) CHARSET=utf8");

	// расширены методы оплаты
	DB::query("ALTER TABLE {shop_payment_method} ADD payment VARCHAR(20) NOT NULL DEFAULT ''");
	$result = DB::query("SELECT * FROM {shop_payment_method}");
	while($row = DB::fetch_array($result))
	{
		$values = my_json_decode($row["module_values"]);
		if($values)
		{
			$row["module_values"] = serialize($values);
			$payment = '';
			switch($values["module_id"])
			{
				case 1:
					$payment = 'webmoney';
					break;
				case 2:
					$payment = 'robokassa';
					break;
				case 3:
					$payment = 'non_cash';
					break;
			}
			unset($values["module_id"]);
			DB::query("UPDATE {shop_payment_method} SET module_values='%s', payment='%s' WHERE id=%d", $row["module_values"], $payment, $row["id"]);
		}
	}
	DB::query("ALTER TABLE {shop_payment_method} CHANGE module_values params text NOT NULL");
	DB::query("CREATE TABLE {shop_pay_history} (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`order_id` INT(11) UNSIGNED NOT NULL DEFAULT '0',
		`status` ENUM('request_pay', 'pay') NOT NULL DEFAULT 'request_pay',
		`user_id` INT(11) UNSIGNED NOT NULL DEFAULT '0',
		`created` INT(10) UNSIGNED NOT NULL DEFAULT '0',
		`summ` FLOAT NOT NULL DEFAULT '0',
		`payment` VARCHAR(20) NOT NULL DEFAULT '',
		PRIMARY KEY  (`id`)
	) CHARSET=utf8");
	DB::query("DROP TABLE {shop_payment}");
	DB::query("RENAME TABLE {shop_payment_method} TO {shop_payment} ;");
	DB::query("ALTER TABLE {shop_order} CHANGE payment payment_id SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0'");
	DB::query("ALTER TABLE {shop_order} CHANGE delivery delivery_id SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0'");

	// корзина и оформление заказа в один шаг
	$site_order_id = DB::query_result("SELECT id FROM {site} WHERE addmodule='order'");
	$sites = $diafan->get_children($site_order_id, "site");
	$sites[] = $site_order_id;
	$result = DB::query("SELECT * FROM {site_parents} WHERE element_id IN (%s)", implode(",", $sites));
	while($row = DB::fetch_array($result))
	{
		DB::query("UPDATE {site} SET count_children=count_children-1 WHERE id=%d", $row["parent_id"]);
	}
	DB::query("DELETE FROM {site_parents} WHERE element_id IN (%s)", implode(",", $sites));
	DB::query("DELETE FROM {site} WHERE id IN (%s)", implode(",", $sites));
	DB::query("UPDATE {site} SET addmodule='cart' WHERE addmodule='basket'");
	foreach($language as $lang_id)
	{
		if($lang_id)
		{
			DB::query("ALTER TABLE {shop_delivery} ADD name".$lang_id." VARCHAR(50) NOT NULL DEFAULT ''");
			DB::query("ALTER TABLE {shop_delivery} ADD act".$lang_id." ENUM('0', '1') NOT NULL default '0'");
			DB::query("ALTER TABLE {shop_delivery} ADD text".$lang_id." TEXT NOT NULL");
			DB::query("ALTER TABLE {shop_payment} ADD name".$lang_id." VARCHAR(50) NOT NULL DEFAULT ''");
			DB::query("ALTER TABLE {shop_payment} ADD act".$lang_id." ENUM('0', '1') NOT NULL default '0'");
			DB::query("ALTER TABLE {shop_payment} ADD text".$lang_id." TEXT NOT NULL");
		}
	}
	DB::query("ALTER TABLE {shop_order} ADD `delivery_summ` FLOAT NOT NULL DEFAULT '0'");
	DB::query("CREATE TABLE {shop_order_additional_cost} (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`order_id` INT(11) UNSIGNED NOT NULL DEFAULT '0',
		`additional_cost_id` TINYINT(11) UNSIGNED NOT NULL DEFAULT '0',
		`summ` FLOAT NOT NULL DEFAULT '0',
		PRIMARY KEY  (`id`)
	) CHARSET=utf8");
	DB::query("ALTER TABLE {shop_order} CHANGE language `lang_id` TINYINT(2) UNSIGNED NOT NULL DEFAULT '0'");
}

if(in_array('comments', $adminsite_rewrite))
{
	// Комментарии: настраивается где использовать дополнительное поле
	DB::query("ALTER TABLE {comments_param}
		ADD `show_in_list` ENUM( '0', '1' ) NOT NULL,
		ADD `show_in_form_auth` ENUM( '0', '1' ) NOT NULL,
		ADD `show_in_form_no_auth` ENUM( '0', '1' ) NOT NULL"
	);
	DB::query("UPDATE {comments_param} SET show_in_list='1', show_in_form_auth='1', show_in_form_no_auth='1'");

	// Комментарии: дерево комментариев
	DB::query("ALTER TABLE {comments} ADD `parent_id` INT(11) UNSIGNED NOT NULL DEFAULT '0', ADD count_children SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0'");
	DB::query("CREATE TABLE {comments_parents} (
		`id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT ,
		`element_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		`parent_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		`trash` ENUM( '0', '1' ) NOT NULL DEFAULT '0',
		PRIMARY KEY (`id`)
	) CHARSET=utf8");
	DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('comments', 'count_level', '7')");
	DB::query("UPDATE {config} SET name='captcha' WHERE name='security' AND module_name='comments'");
	DB::query("UPDATE {config} SET name='only_user' WHERE name='security_user' AND module_name='comments'");
	DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('comments', 'subject_admin', '%%title (%%url). Новый комментарий'), ('comments', 'message_admin', 'Здравствуйте, администратор сайта %%title (%%url)!<br>На странице %%urlpage появился новый комментарий:<br>%%message')");
	foreach($language as $lang_id)
	{
		if($lang_id)
		{
			DB::query("ALTER TABLE {comments_param} ADD name".$lang_id." VARCHAR(250) NOT NULL DEFAULT ''");
			DB::query("ALTER TABLE {comments_param} ADD text".$lang_id." TEXT NOT NULL");
			DB::query("ALTER TABLE {comments_param_select} ADD name".$lang_id." VARCHAR(50) NOT NULL DEFAULT ''");
		}
	}
}
if(in_array('faq', $adminsite_rewrite))
{
	DB::query("UPDATE {config} SET name='captcha' WHERE name='security' AND module_name='comments' AND value='1'");
	DB::query("UPDATE {config} SET name='only_user' WHERE name='security' AND module_name='comments' AND value='2'");
}
if(in_array('feedback', $adminsite_rewrite))
{
	DB::query("UPDATE {config} SET name='captcha' WHERE name='security' AND module_name='comments' AND value='1'");
	DB::query("UPDATE {config} SET name='only_user' WHERE name='security' AND module_name='comments' AND value='2'");
}
if(in_array('rating', $adminsite_rewrite))
{
	DB::query("UPDATE {config} SET name='only_user' WHERE name='security_user' AND module_name='rating'");
}

DB::query("UPDATE {config} SET name='captcha' WHERE name='security' AND module_name='users'");
DB::query("ALTER TABLE {users_param}
	ADD `show_in_page` ENUM( '0', '1' ) NOT NULL,
	ADD `show_in_form_auth` ENUM( '0', '1' ) NOT NULL,
	ADD `show_in_form_no_auth` ENUM( '0', '1' ) NOT NULL"
);
DB::query("UPDATE {users_param} SET show_in_form_auth='1' WHERE form='form' OR form='user'");
DB::query("UPDATE {users_param} SET show_in_form_no_auth='1' WHERE form='form' OR form='reg'");
DB::query("ALTER TABLE {users_param} DROP form");
if(in_array('shop', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {shop_order_param} CHANGE def show_in_form_register ENUM('0', '1') NOT NULL DEFAULT '0'");
	DB::query("RENAME TABLE {shop_order_param_def} TO {shop_order_param_user} ;");
}
DB::query("CREATE TABLE {modules} (
id SMALLINT(5) UNSIGNED NOT NULL AUTO_INCREMENT,
name VARCHAR(30) NOT NULL DEFAULT '',
module_name VARCHAR(30) NOT NULL DEFAULT '',
site ENUM('0', '1') NOT NULL DEFAULT '0',
admin ENUM('0', '1') NOT NULL DEFAULT '0',
PRIMARY KEY  (id)
) CHARSET=utf8");

if(in_array('usersite', $adminsite_rewrite))
{
    DB::query("INSERT INTO {modules} (name,	module_name, site) VALUES ('registration', 'users', '1')");
    DB::query("INSERT INTO {modules} (name, module_name, site) VALUES ('reminding', 'users', '1')");
    DB::query("INSERT INTO {modules} (name, module_name, site) VALUES ('messages', 'users', '1')");
}
if(in_array('shop', $adminsite_rewrite))
{
    DB::query("INSERT INTO {modules} (name,	module_name, site) VALUES ('cart', 'shop', '1')");
}
if(in_array('forum', $adminsite_rewrite))
{
	DB::query("ALTER TABLE {forum_show} ADD `created` INT(10) UNSIGNED NOT NULL DEFAULT '0'");
	DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('forum', 'news_count_days', '3')");
	DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('forum', 'count_level', '7')");
	DB::query("UPDATE {config} SET name='only_user', value='1' WHERE name='access_add' AND value='2' AND module_name='forum'");
	DB::query("UPDATE {config} SET name='captcha' WHERE name='access_add' AND value='1' AND module_name='forum'");
	DB::query("ALTER TABLE {forum} ADD `name` VARCHAR(20) NOT NULL DEFAULT ''");
	DB::query("ALTER TABLE {forum_category} ADD `counter_view` INT(10) UNSIGNED NOT NULL DEFAULT '0'");
}
if(in_array('shop', $adminsite_rewrite))
{
	//Изменения в импорте товаров.
	DB::query("ALTER TABLE {shop_category} ADD `import_show_in_menu` enum('0','1') NOT NULL DEFAULT '0'");

	DB::query("ALTER TABLE {shop_import_category} ADD `image_directory` varchar(100) NOT NULL,
		ADD `menu_id` int(11) NOT NULL");
	
	//В заказе нужно отображать какая скидка учитывалась в цене
	DB::query("ALTER TABLE {shop_order_goods} ADD `discount_id` INT( 11 ) UNSIGNED NOT NULL ");
}

DB::query("ALTER TABLE {users} ADD `background` VARCHAR( 255 ) NOT NULL DEFAULT 'metall.jpg';");

DB::query("ALTER TABLE {attachments} ADD `access_admin` ENUM('0', '1') NOT NULL DEFAULT '0'");
DB::query("UPDATE {attachments} SET access_admin='1' WHERE module_name IN ('faq', 'feedback')");

if(in_array('faq', $adminsite_rewrite))
{
	DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('faq', 'attachments_access_admin', '1')");
}
if(in_array('feedback', $adminsite_rewrite))
{
	DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('feedback', 'attachments_access_admin', '1')");
}

DB::query("DELETE FROM {adminsite}");
include_once(ABSOLUTE_PATH.'installation/core.php');

if(! empty($adminsite))
{
	foreach($adminsite as $v) 
	{
		adminsite($v); 
	}
}
foreach($sql as $s)
{
	if(strstr($s, '{modules}') && ! strstr($s, 'CREATE'))
	{
		DB::query($s);
	}
}
unset($sql);
unset($adminsite);

foreach ($adminsite_rewrite as $rewrite)
{
	if ($rewrite != "usersite" && file_exists(ABSOLUTE_PATH.'modules/'.$rewrite.'/'.$rewrite.'.install.php'))
	{
		include_once(ABSOLUTE_PATH.'modules/'.$rewrite.'/'.$rewrite.'.install.php');

		if(! empty($adminsite))
		{
			foreach($adminsite as $v) 
			{
				adminsite($v); 
			}
		}
		if(! empty($sql))
		{
			foreach($sql as $s)
			{
				if(strstr($s, '{modules}'))
				{
					DB::query($s);
				}
			}
		}
		unset($adminsite);
		unset($sql);
	}
}

$diafan->_cache->delete("");

//////////////////////config
$new_values = array(
		'VERSION_CMS' => VERSION,
		'DATE_UPDATE' => D_UPDATE,
		'HTMLEDITOR'  => ''
);
$lang = array();
foreach ($language as $l)
{
	$lang[] = array($l);
}
include_once(ABSOLUTE_PATH.'includes/config.php');
Config::save($new_values, $lang);

echo '<font color="green">Обновление успешно завершено!</font>';

function my_json_decode($json)
{
    $comment = false;
    $out = '$x=';
    $len = strlen($json);
    for ($i = 0; $i < $len; $i++)
    {
	if (!$comment)
	{
	    if (($json[$i] == '{') || ($json[$i] == '['))
		$out .= ' array(';
	    else if (($json[$i] == '}') || ($json[$i] == ']'))
		$out .= ')';
	    else if ($json[$i] == ':')
		$out .= '=>';
	    else
		$out .= $json[$i];
	}
	else
	    $out .= $json[$i];
	if ($json[$i] == '"' && $json[($i - 1)] != "\\")
	    $comment = !$comment;
    }
	if($json)
	{
	   	 eval($out.';');
	}
	else
	{
		$x = '';
	}
    return $x;
}

function multilang($str)
{
	global $language;
	$result = '';

	$arg = func_get_args();

	$i = 0;
	foreach ($language as $lang_id)
	{
		if (isset($arg[$i-1]))
		{
			$str = $arg[$i-1];
		}
		$result .= str_replace('LANG', $lang_id, $str).' ';
		$i++;
	}
	return $result;
}
function adminsite($values, $parent_id = 0)
{
	if(empty($values["sort"]))
	{
		$values["sort"] = 0;
	}

    if (!empty($parent_id)) 
	{
        DB::query("UPDATE {adminsite} SET count_children=count_children+1 WHERE id=%d", $parent_id);
    }
	if(empty($values['act']))
	{
		$values['act'] = 0;
	}

	if (empty($parent_id))
	{
		DB::query("INSERT INTO {adminsite} (group_id, name, rewrite, text, numrow, act, sort) VALUES ('%s', '%s', '%s', '%s', %d, '%s', %d)", $values['group_id'], $values['name'], $values['rewrite'], $values['text'], $values['numrow'], $values['act'], $values['sort']);
		$last_id = DB::last_id("adminsite");
	}
	else 
	{
		DB::query("INSERT INTO {adminsite} (parent_id,group_id, name, rewrite, text,numrow, act,sort) VALUES (%d, %d, '%s', '%s', '%s',%d, '%s', %d)", $parent_id, $values['group_id'], $values['name'], $values['rewrite'], $values['text'], $values['numrow'], $values['act'], $values['sort']);
		$last_id = DB::last_id("adminsite");
		DB::query("INSERT INTO {adminsite_parents} (element_id, parent_id) VALUES (%d, %d)", $last_id, $parent_id);
	}

	if(!empty($values['child']))
	{
		foreach ($values['child'] as $k => $v)
		{
			$v["sort"] = $k;
			adminsite($v, $last_id);
		}
	}

    return $last_id;
}
